var app = {     // Meetooth application
        parametres: { 
            
            rememberme: false,
            initialized:false, 
//            serviceUrl:"https://s17263688.domainepardefaut.fr/H2A/Meetooth/serveur/int1/Meetooth/web/app_dev.php",
//            serviceUrl: "https://s17263688.domainepardefaut.fr/H2A/Meetooth/serveur/test1/meetoothsrv/web/app_dev.php",
            serviceUrl: "https://meetooth.com/code/meetoothsrv/web/app_dev.php",
            timeoutdelay: 40000,
            nbloginrestant: 3,
            apptitle:"Meetooth",   // App title
            evtinfotimer:null,
            meettimer: null,
            showmeettimer: null,
            contacttimer: null,
            notificationstimer: null,
            discoverDevicetimer: null,
            evtcheckonlineusers: null,
            notifymessagestimer: null,
            notifyevttimer: null,
            shortinterval: 2000,
            timerinterval: 20000,
            longtimerinterval: 140000,
            formule_premium: 0,
            bluetoothName: null,
            address: null,
            Os: null,
            contacts: [],
            meets: [],
            utilisateurs: [],
            favoris:[],
            notifications:0,
            seuilnotifications: 85,
            modeconnexion: "meetooth",
            unreads: {
                    meets: 0,
                    messages: 0,
                    events: 0
                    },
            criteres: [],
            // initialisation des valeurs de plusieurs paramètres
            set : function(options){
               for(var name in options){
                   if(this[name] !== undefined){
                       this[name]=options[name];
                       window.localStorage.setItem(name,options[name]);
                   }

               }
            },
            getRememberme: function(){
                
                if(window.localStorage.getItem("rememberme")){
                    app.parametres.rememberme=(window.localStorage.getItem("rememberme")=="false"?false:true);               
                }
                
                return app.parametres.rememberme;
            },
            reset: function(property){
                switch (property){
                    case "nbloginrestant":  app.parametres.set({nbloginrestant: 3});
                                            break;
                }
            },
            //Incrémente le nombre de notifications reçues
            incrementerNotifications: function(){
                this.notifications ++;
            },
            //Décrémente le nombre de notifications reçues
            decrementerNotifications: function(){
                if(this.notifications>0)
                    this.notifications --;
            }
        },
        
        user: {     // current user informations
            iduser: null,
            identifiant: null,
            password: null,
            photo: null,
            nom: null,
            prenom: null,
            mail: null,
            pseudo: null,
            naissance: null,
            idsession:null,
            description: null,
            sexe: null,
            initialize: function(){ // initialize users informations
                
                

            },
            
            // initialisation des valeurs de plusieurs paramètres
            set : function(options){
               for(var name in options){
                   if(this[name] !== undefined){
                       this[name]=options[name];
                       window.localStorage.setItem(name,options[name]);
                   }

               }

            },
            get: function(property){
                var result="";
                
                if(app.user[property]!== undefined){
                    if(property =="identifiant" && app.user[property]==null){
                        app.user[property]=window.localStorage.getItem(property) || null;
                        
                    }
                    result=app.user[property];
//                    result=window.localStorage.getItem(property);
                }
                
                return result;
            }
        },
        
        constants: {
            dialog: {
                info:       0,           // Message d'information, bulle disparaissante
                popup:      1,           // Pop up qui ne disparait pas
                meet:       2,           // Meet envoyé à un utilisateur
                infolong:   3            // Message d'information, bulle disparaissante après longue durée
            }
            
        },
        
        initialize: function(){
            
            this.parametres.initialized=true;
                        
            if(window.localStorage.getItem("rememberme")){
                this.parametres.rememberme=(window.localStorage.getItem("rememberme")=="false"?false:true);               
            }
            
            if(window.localStorage.getItem("nbloginrestant")!=null){
                try{
                    this.parametres.nbloginrestant=parseInt(window.localStorage.getItem("nbloginrestant"));
                }
                catch(exception){
                    this.parametres.nbloginrestant=3;
                    window.localStorage.setItem("nbloginrestant", 3);
                    console.log("erreur="+exception);
                }
            }
            else{
                 this.parametres.nbloginrestant=3;
                    window.localStorage.setItem("nbloginrestant", 3);
            }
            
            
            this.parametres.serviceUrl=window.localStorage.getItem("serviceUrl");

            //si elle est nulle, ie on n'a pas sauvegardé, je prends celle par défaut dans le fichier de conf
            if(this.parametres.serviceUrl==null){
                $.ajax({
                    url: "conf/serviceurl.ini",
                    success: function(data) {
                        app.parametres.set({serviceUrl:data});
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        console.log(textStatus);
                    },
                    async : false
                });
            }
                        
        },
        
        reset: function(variables){
            for(var parametre in variables){
                if(parametre=="nbloginautorise"){
                    this.parametres.nbloginautorise=3;
                }
            }
        },
        // recupère la valeur d'un objet
        getValue : function(name){
            if(this.parametres[name] != undefined)
                return this.parametres[name];
            else
                return "";
        },
        // initialisation des valeurs de plusieurs paramètres
        setValue : function(options){
           for(var name in options){
               if(this.parametres[name] != undefined){
                   this.parametres[name]=options[name];
                   window.localStorage.setItem(name,options[name]);
               }
               
           }
            
        },
        setlocalvalue: function(name, value){
            this.parametres[name]=value;
            window.localStorage.setItem(name,value);
        },
        
        
        clearHistory: function(){
            try{
                
                $.mobile.navigate.history.stack = []; 
                
            }
            catch(e){
                console.log("erreur"+e);
            }
            
        },
        
        services: {
            inscriptionUtilisateur: function(nom, prenom, identifiant, email, sexe, datenaissance, pseudo, password, description, criterescompatibilite, temoinevt,criteresevenement,callbackaction){
                var result, error=false;
                console.log("MeetoothLOG- Inscription="+app.parametres.serviceUrl+"/api/v1/user/inscription/"+nom+"/"+prenom+"/"+email+"/"+sexe+"/"+datenaissance+"/"+pseudo+"/"+identifiant+"/"+password+"/"+description+"/"+criterescompatibilite+"/"+temoinevt+"/"+criteresevenement+".json");

                try{
                    $.ajax({

                        // adresse du service d'enregistrement
                        url: app.parametres.serviceUrl+"/api/v1/user/inscription/"+nom+"/"+prenom+"/"+email+"/"+sexe+"/"+datenaissance+"/"+pseudo+"/"+identifiant+"/"+password+"/"+description+"/"+criterescompatibilite+"/"+temoinevt+"/"+criteresevenement+".json",

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            result=res;                
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "inscriptionUtilisateur");
                        },
                        complete: function(){
                            if(!error){
                                callbackaction(result);                                
                                // si l'inscription se passe bien, on enregistre l'utilisateur dans la BD locale
                                if(result==1){
                                    accessDB.saveUser({identifiant:email, pseudo: pseudo, nom: nom, prenom:prenom, photo:"", mail: email, datenaissance:datenaissance, description:description, sexe:sexe, adresse:"", password:""});
                                }
                            }
                            else{
                                app.utils.alert("Echec de l'opération\nUne erreur réseau s'est produite!","Meetooth - Inscription");
                            }
                        }

                    });


                }
                catch(exception){
                    console.log("Meetooth Erreur inscription utilisateur: "+exception);
                }
            },
            
            desinscrire: function(identifiant){
                console.log("URL="+app.parametres.serviceUrl+'/api/v1/user/desinscription/'+identifiant+'/Meetooth.json');
                try{
                    $.ajax({

                        // adresse du service d'enregistrement
                        url: app.parametres.serviceUrl+'/api/v1/user/desinscription/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        
                        timeout: app.parametres.timeoutdelay,
                        
                        success: function (res){
                            if(res==1){
                                app.utils.showloader("Suppression des paramètres...");
                                app.services.deconnexionUtilisateur(app.user.get("mail"), function(){
                                    app.utils.showInfoMessageLong("Compte supprimé!");
                                    app.utils.hideloader();
                                });
                                
                                // SUpprimer le compte de la BD locale
                                accessDB.deleteUser(identifiant);
                            }
                            else{
                                app.utils.showInfoMessageLong("Erreur, compte non supprimé !");
                            }               
                        },

                        error: function(resultat, statut, erreur){
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "desinscrire");
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            // récupération dun mot de passe égaré, le nouveau mot de passe généré sera envoyé par mail
            recupererMotdePasse: function(identifiant, callback){
                console.log("URL=");
                try{
                    $.ajax({
                        // adresse du service de récupération de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/user/rappelmotdepasse/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,
                        success: function (res){
                            callback(res);                
                        },

                        error: function(resultat, statut, erreur){
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "recupererMotdePasse");
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            // Authentify a user
            connexionUtilisateur: function(login, mdp, rememberme, callback){
                var result, error=false;  
                
                var address, nomdevice, osdevice;
                
                // if the device APi is not supported, create defaults settings to use
                if(! window.device ){
                    
                    address="00:00:00:AF:0F:AA";
                    nomdevice=login;
                    osdevice=navigator.platform;
                }
                
                address=encodeURIComponent(app.parametres.address || address);
                
                nomdevice=encodeURIComponent(app.parametres.bluetoothName || nomdevice);
                
                osdevice=encodeURIComponent(app.parametres.Os ||osdevice);
                
                try{
                    $.ajax({

                        // adresse du service d'enregistrement
                        url: app.parametres.serviceUrl+'/api/v1/user/connexion/'+login+'/'+mdp+'/'+address+'/'+nomdevice+'/'+osdevice+'.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,
                        success: function (data){
                            // mettre à jour ses infos   
                            result=data;
                            
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "connexionUtilisateur");
                            
                        },
                        
                        complete: function(){
                            if(!error){
                                if(result.error==0){
                                    // No error, try to load parameters values of the current user
                                    
                                    app.user.set({identifiant: result.iduser, idsession: result.idsession});
                                    
                                    // re_init the number of unsuccessfull connection attempts
                                    app.parametres.reset("nbloginrestant");
                                    
                                    // set the remember me variable
                                    app.parametres.set({"rememberme":rememberme});
                                                                        
                                    //clear the history
                                    app.clearHistory();                                    
                                    
                                    app.utils.showloader("Chargement...");
                                    
                                    // check data of the user
                                    app.services.rechercherUtilisateurConnexion (result.iduser, function(user){
                                        if(user){
                                            
                                            // look for the account formula and set the app regarding the result
                                            app.services.rechercherTypeFormule(result.iduser, function(formul){
                                                if(formul==1){
                                                    app.parametres.set({formule_premium: formul});
                                                    app.utils.updateUiFormule(formul);
                                                }
                                                else{
                                                   app.parametres.set({formule_premium: 0});
                                                   app.utils.updateUiFormule(0);
                                                }

                                            });                                            
                                            
                                            // locally save the login of the connected user
                                            window.localStorage.setItem("identifiant", result.iduser);
                                            
                                            app.user.set({identifiant: result.iduser, photo: user.photo, pseudo: user.pseudo, nom: user.nom, prenom: user.prenom, mail: user.email, password: user.motdepasse, naissance: app.utils.parseNaissance(user.datenaissance), description: user.description, sexe: user.sexe});
                                            
                                            app.utils.loadPeriodicalDataAtConnection(result.iduser);
                                            
                                            $( ":mobile-pagecontainer" ).pagecontainer( "change", "accueil.html", { reload: false, showLoadMsg: true, changeHash:true } );

                                        }
                                        else{
                                            app.utils.alert("Compte utilisateur non activé","Meetooth - Connexion");
                                        }
                                        
                                        app.utils.hideloader();
                                    });
                                    
                                    
                                    app.services.modifierDeviceUtilisateur(result.iduser);

                                }
                                else{
                                    app.parametres.set({"nbloginrestant": app.parametres.nbloginrestant-1});    
                                    app.utils.hideloader();
                                }
                                callback(result);
                            }
                            else{
                                app.utils.showInfoMessage("Erreur de connexion, veuillez ré-essayer l'authentification");
                                
                                if($("body").pagecontainer("getActivePage").attr("id")!="loginpage"){
                                    setTimeout(function () {                                                        
                                        app.utils.hideloader();
                                        $( ":mobile-pagecontainer" ).pagecontainer( "change", "login.html", { reload: false} );

                                    }, 500);
                                }
                            }
                        
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
                    
            },
            deconnexionUtilisateur: function(email, callback){
                
                if(app.parametres.modeconnexion=="facebook"){
                    facebookConnectPlugin.logout(function(){
                        
                        app.utils.clearTimeOutAndData();

                        $( ":mobile-pagecontainer" ).pagecontainer( "change", "login.html", { reload: false, showLoadMsg: true, changeHash:true } );

                        callback();
                    }, function(){
                        $("#deconnexion").removeClass ("ui-icon-loader-mee");
                        $("#deconnexion").addClass ("ui-icon-power");
                    });
                }
                else{
                    console.log("URL="+app.parametres.serviceUrl+'/api/v1/user/deconnexion/'+email+'/Meetooth.json');
                    try{
                        $.ajax({
                            // adresse du service de récupération de mot de passe
                            url: app.parametres.serviceUrl+'/api/v1/user/deconnexion/'+email+'/Meetooth.json',

                            dataType: 'json', 

                            timeout: app.parametres.timeoutdelay,

                            success: function (res){
                                
                                app.utils.clearTimeOutAndData();
                                
                                callback(res); 
                                
                                $( ":mobile-pagecontainer" ).pagecontainer( "change", "login.html", { reload: false, showLoadMsg: true, changeHash:true } );

                            },

                            error: function(resultat, statut, erreur){
                                $("#deconnexion").removeClass ("ui-icon-loader-mee");
                                $("#deconnexion").addClass ("ui-icon-power");
                                app.utils.handleAjaxErrors(resultat, statut, erreur, "deconnexionUtilisateur");
                                
                            }

                        });
                    
                    }
                    catch(exception){
                        console.log("Meetooth decnnexion Erreur: "+exception);
                    }
                }
                
            },
            // rechercher les utilisateurs en ligne
            listerUtilisateursEnligne: function(identifiant, callback){
                                
                var error=false;
                var result;
                console.log("URL="+app.parametres.serviceUrl+'/api/v1/user/listeruserconnectes.json');
                try{
                    $.ajax({
                        // adresse du service de récupération de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/user/listeruserconnectes.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,
                        success: function (res){
                            result=res;
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "listerUtilisateursEnligne");
                        },
                        complete: function(){
                            if(!error){
                                
                                var users=[];
                                
                                app.parametres.utilisateurs=[];
                                
                                for(var iduser in result){
                                    if(result[iduser].identifiant!=identifiant){
                                        app.parametres.utilisateurs.push({value: result[iduser].pseudo, data: result[iduser].identifiant});
                                        users.push(result[iduser]);
                                    }
                                                                       
                                }
                                
                                if($.isFunction(callback))
                                    callback(users);
                            
                            }                            
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            // Liste les utilisateurs connectés sur internet, prend ces infos dans la BD locale
            listerUtilisateursOnNet: function(identifiant, callback){
                 accessDB.rechercherUtilisateursOnNet(identifiant, callback);
            },
            rechercherUtilisateurOnline: function(identifiant, callback){                
                accessDB.rechercherUtilisateursOnline(identifiant, callback);
            },
            // modifie le profil d'un utilisateur
            modifierProfilUtilisateur: function(nom, prenom, identifiant, email, sexe, datenaissance, pseudo, description, criterescompatibilite, temoinevt, criteresevenement, activerjob, annoncejob, complementinformationsjob, activerme, annonceme ,complementinformationsme, callbackaction){
                
                console.log("URL=");
                try{
                    $.ajax({

                        // adresse du service d'enregistrement
                        url: app.parametres.serviceUrl+"/api/v1/user/modifier/"+nom+"/"+prenom+"/"+pseudo+"/"+sexe+"/"+datenaissance+"/"+identifiant+"/"+description+"/"+annoncejob+"/"+complementinformationsjob+"/"+activerjob+"/"+annonceme+"/"+complementinformationsme+"/"+activerme+"/"+criterescompatibilite+"/"+temoinevt+"/"+criteresevenement+".json",
                                                                                                                        
                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            if(res===1){
                                
                                app.user.set({ identifiant: identifiant, nom: decodeURIComponent(nom), pseudo: decodeURIComponent(pseudo), prenom: decodeURIComponent(prenom), mail: decodeURIComponent(email), naissance: app.utils.parseNaissance(datenaissance), description: decodeURIComponent(description), sexe: decodeURIComponent(sexe)});
                                
                            }
                            
                            callbackaction(res);                
                        },

                        error: function(resultat, statut, erreur){
                            app.utils.showInfoMessage("Erreur, modification non effectuée");
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "modifierProfilUtilisateur");
                        }

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            
            // Change la photo d'un utilisaeur
            changerPhotoUtilisateur: function(ImageURI, identifiantutilisateur, callback){
                
                var photoname = identifiantutilisateur;
                
                var filepath = ImageURI;

                var photoSent = function (r) {
                    console.log("Code = " + r.responseCode);
                    console.log("Response = " + r.response);
                    console.log("Sent = " + r.bytesSent);
                    app.utils.showInfoMessage("Chargement de la photo terminé");
                    app.utils.hideloader();
                    callback();
                    
                }

                var photoError = function (error) {
                    console.log("An error has occurred: Code = " + error.code);
                    console.log("upload error source " + error.source);
                    console.log("upload error target " + error.target);
                    app.utils.showInfoMessage("Echec du chargement de la photo");
                    app.utils.hideloader();
                    callback();
                }

                var uri = app.parametres.serviceUrl+"/api/v1/user/photo.json";

                uri = encodeURI(uri.replace("https","http"));

                var options = new FileUploadOptions();

                options.fileKey = "photofile";

                options.fileName = photoname+".jpg";
                
                options.mimeType = "image/jpeg";
                
                //options.chunkedMode = false;
                options.headers = {
                    Connection: "close"
                };
                
                options.params = {identifiant: decodeURIComponent(identifiantutilisateur)};
                
                var ft = new FileTransfer();

                ft.onprogress = function(progressEvent) {

                    if (progressEvent.lengthComputable) {
                        app.utils.showloader("Envoi de la photo... "+ Math.floor((progressEvent.loaded / progressEvent.total) *100)+"%");
                        
                    } 
                    else {
                        app.utils.showloader("Envoi de la photo...");
                        
                    }

                };
                
                //Lance l'upload du fichier
                ft.upload(filepath, uri, photoSent, photoError, options, true);
                    
            },
            
            rechercherUtilisateur: function(identifiant, callback, errorcallback){
                var result, error=false;
                console.log("URL=");
                try{
                    $.ajax({

                        // adresse du service de recherche d'un utilisateur
                        url: app.parametres.serviceUrl+'/api/v1/user/searchinfo/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            result=res;  
                            
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            if($.isFunction(errorcallback)){ // is the error callback is send as parameter, use it
                                errorcallback(); //call the errorcallback
                            }
                            else{                                
                                accessDB.rechercherUser(identifiant, callback);
                                //call the default error callback
                                app.utils.handleAjaxErrors(resultat, statut, erreur, "rechercherUtilisateur");
                            }
                        },
                        complete: function(){
                            if(!error){
                                callback(result);
                                // save the infos the the local DB
                                accessDB.saveUser(result);
                            }
                            
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            //rechercher un utilisateurs et charge ses données lors de sa connexion; repete la tache jusqu'à ce qu'il nyait plus d'erreur    
            rechercherUtilisateurConnexion: function(identifiant, callback){
                var error=false;    // No error, by default
                console.log("URL="+app.parametres.serviceUrl+'/api/v1/user/searchinfo/'+identifiant+'/Meetooth.json');
                try{
                    $.ajax({

                        // adresse du service de recherche d'un utilisateur
                        url: app.parametres.serviceUrl+'/api/v1/user/searchinfo/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            callback(res);
                            // save the infos the the local DB
                            accessDB.saveUser(res);                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                        },
                        complete: function(){
                            if(error){
                                $.ajax({

                                    // adresse du service de recherche d'un utilisateur
                                    url: app.parametres.serviceUrl+'/api/v1/user/searchinfo/'+identifiant+'/Meetooth.json',

                                    dataType: 'json', 
                                    
                                    timeout: app.parametres.timeoutdelay,

                                    success: function (res){
                                        callback(res);
                                        // save the infos the the local DB
                                        accessDB.saveUser(res);                              
                                    },

                                    error: function(resultat, statut, erreur){      
                                        app.utils.showInfoMessage("Erreur de connexion, veuillez vous authentifier à nouveau");
                                        $( ":mobile-pagecontainer" ).pagecontainer( "change", "login.html", { reload: false, showLoadMsg: true, changeHash:true } );
                                    }

                                });
                            }
                            
                        }

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            rechercherUtilisateurparEmail: function(email, callback){
                var user, error=false;
                
                console.log("URL="+app.parametres.serviceUrl+'/api/v1/user/searchinfoemail/'+email+'/Meetooth.json');
                try{
                    $.ajax({

                        // adresse du service de recherche d'un utilisateur
                        url: app.parametres.serviceUrl+'/api/v1/user/searchinfoemail/'+email+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            user=res;                              
                        },

                        error: function(resultat, statut, erreur){                                                        
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "rechercherUtilisateurparEmail");
                        },
                        complete: function(){
                            if(!error){
                                callback(user);
                                // save the infos the the local DB
                                accessDB.saveUser(user);                                
                            }
                        }

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            // recherche les critères d'événements pour l'utilisateur dont l'identifiant est passé en paramètres
            rechercherCriteresEvenements :function(identifiant, callback){
                var error=false;
                var data;
                
                console.log("URL="+app.parametres.serviceUrl+'/api/v1/user/getcriteresevenement/'+identifiant+'/Meetooth.json');
                try{
                    $.ajax({

                        // adresse du service
                        url: app.parametres.serviceUrl+'/api/v1/user/getcriteresevenement/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                
                        },

                        error: function(resultat, statut, erreur){
                            error = true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "rechercherCriteresEvenements");
                        },
                        complete: function(){
                            if(! error){
                                callback(data);
                                accessDB.saveCriteresEventsUser(identifiant, data);
                                //met à jour la liste locale des critères d'évenements
                                app.parametres.criteres=[];
                                for(var critere in data){
                                    app.parametres.criteres.push(data[critere].nom);
                                }
                            }
                            else{
                                accessDB.rechercherCriteresEventsUser(identifiant, callback);
                            }
                        }

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            rechercherCriteresCompatibilite:function(identifiant, callback){
                var error=false;
                var result;
                
                console.log("URL="+app.parametres.serviceUrl+'/api/v1/user/getcriterescompatibilite/'+identifiant+'/Meetooth.json');
                try{
                    $.ajax({

                        // adresse du service de recherche d'un utilisateur
                        url: app.parametres.serviceUrl+'/api/v1/user/getcriterescompatibilite/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            result=res;               
                        },

                        error: function(resultat, statut, erreur){
                            error = true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "rechercherCriteresCompatibilite");
                        },
                        complete: function(){
                            if(! error){
                                callback(result);
                                accessDB.saveCriteresCompUser(identifiant, result);
                                
                            }
                            else{
                                accessDB.rechercherCriteresCompUser(identifiant, callback);
                            }
                        }

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
                
            },
            
            listerCriteresEvenements :function(callback){
                var error=false;
                var data;
                console.log("URL=");
                try{
                    $.ajax({

                        // adresse du service de recherche d'un utilisateur
                        url: app.parametres.serviceUrl+'/api/v1/criteresevenements/geteventcriteres.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;     
                            
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "listerCriteresEvenements");
                        },
                        complete: function(){
                            if(! error){
                                callback(data);
                                
                                //met à jour la liste locale des critères d'évenements
                                app.parametres.criteres=[];
                                for(var critere in data){
                                    app.parametres.criteres.push(data[critere].nom);
                                }
                            }
                            else{
                                accessDB.rechercherCriteresEvent( callback);
                            }
                        }                        

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            //Lister tous les critères de compatibiltés de la BD
            listerCriteresCompatibilite:function(callback){
                var error=false;
                var data;
                console.log("URL=");
                try{
                    $.ajax({
                        // adresse du service de recherche des critères de compatibilité
                        url: app.parametres.serviceUrl+'/api/v1/criterescompatibilite/getcompatibilitecriteres.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "listerCriteresCompatibilite");
                        },
                        
                        complete: function(){
                            if(! error){
                                callback(data);
                            }
                            else{
                                accessDB.rechercherCriteresComp(callback);
                            }
                        }

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            
            // Envoie un meet à un utilisateur dont l'identifiant est passé en paramètre
            sendMeet: function(recepteur, callback, completecallback){
                var error=false;
                var data;
                console.log("URL=");
                try{
                    $.ajax({
                        // adresse du service de recherche des critères de compatibilité
                        url: app.parametres.serviceUrl+'/api/v1/meet/send/'+app.user.get("identifiant")+'/'+recepteur+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "sendMeet");
                        },
                        complete: function(){
                            if(! error){
                                callback(data);
                            }
                            else{
                                callback(4);
                            }
                            
                            if($.isFunction(completecallback)){
                                completecallback();
                            }
                        }

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            // Fonction de calcul de compatibilité
            // recepteur: celui avec qui on calcule la compatibilité de l'utilisateur connecté
            calculerCompatibilite: function(utilisateur2, callback){
                // appeler le callback là quand tu as lu dans accesDB
                
                // sil nya pas la vas, tu recherches alors online
                
                accessDB.rechercherCompatibilite(app.user.get("identifiant"), utilisateur2, callback);
                console.log("URL=");
                try{
                    $.ajax({
                        // adresse du service de recherche des critères de compatibilité
                        url: app.parametres.serviceUrl+'/api/v1/users/calculcompatibilite/'+app.user.get("identifiant")+'/'+utilisateur2+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){                          
                            //callback(res); 
                            accessDB.SaveCompatibilite(app.user.get("identifiant"), utilisateur2, res);
                        },

                        error: function(resultat, statut, erreur){
                            app.utils.handleAjaxErrors(resultat, statut, erreur,"calculerCompatibilite");
                        }

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            
            rechercherDescriptionUser: function(identifiant, callback){
                var data;
                var error=false;
                
                console.log("URL="+app.parametres.serviceUrl+'/api/v1/user/getdescription/'+identifiant+'/Meetooth.json');
                try{
                    $.ajax({
                        // adresse du service de recherche de la description d'un utilisateur
                        url: app.parametres.serviceUrl+'/api/v1/user/getdescription/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res; 
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "rechercherDescriptionUser");
                        },
                        complete: function(){
                            if(! error){
                                callback(data);
                                accessDB.saveDescriptionUser(identifiant, data);
                            }
                            else{
                                accessDB.rechercherDescriptionUser(identifiant, callback);
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }    
            },
            // récupérer les notifications de personnes en ligne qui nous sont compatibles 
            recevoirNotificationOnlineandEvents: function(identifiant, callbackonline, callbackevents){
                var dataonline=[];
                var dataevents=[];
                
                console.log("URL="+app.parametres.serviceUrl+'/api/v1/notification/receivenotificationnonvues/'+identifiant+'/Meetooth.json');
                try{
                    $.ajax({
                        // adresse du service de recherche des notifications non vues
                        url: app.parametres.serviceUrl+'/api/v1/notification/receivenotificationnonvues/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            for(var i=0;i<res.length;i++){
                                if(res[i].type.indexOf("online")!=-1){
                                    dataonline.push(res[i]);
                                }
                                else{
                                    dataevents.push(res[i]);
                                }
                            }
                            
                            callbackonline(dataonline);
                            
                            // save data events
                            callbackevents(dataevents);
                        },

                        error: function(resultat, statut, erreur){
                            console.log("URL="+app.parametres.serviceUrl+'/api/v1/notification/receivenotificationnonvues/'+identifiant+'/Meetooth.json');
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "recevoirNotificationOnlineandEvents");
                        }

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            //Récupérer toutes les notifications d'événements non encore reçues
            listerEvenementsaVenir: function(identifiant, callback){
                
//                 va dans la BD chercher les evenements non encore lus et les affiche
                accessDB.listEvents(identifiant, callback);
            },
            
            // Envoyer une noftification à l'utilisateur dont l'adresse MAC est fournie, pourqu'il sache que je suis là, pas loin.
            notifierNouveauxComptatibles: function(identifiant, addresse, callback){
                var error=false;
                var data;
                console.log("URL="+app.parametres.serviceUrl+'/api/v1/users/notifiernouveauxuserscomptatibles/'+identifiant+'/'+app.parametres.seuilnotifications+'/'+encodeURIComponent(addresse)+'.json');
                try{
                    $.ajax({
                        // adresse du service de recherche des critères de compatibilité
                        url: app.parametres.serviceUrl+'/api/v1/users/notifiernouveauxuserscomptatibles/'+identifiant+'/'+app.parametres.seuilnotifications+'/'+encodeURIComponent(addresse)+'.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "notifierNouveauxComptatibles");
                        },
                        
                        complete: function(){
                            if(!error){
                                callback(data);                                
                            }
                            
                        }

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            
            // recherche les meets non lus de l'utilisateur
            listerMeetsNonlus: function(identifiant, callback){
                var error=false;
                var data;
                
                console.log("URL=");
                try{
                    $.ajax({
                        // adresse du service de recherche des critères de compatibilité
                        url: app.parametres.serviceUrl+'/api/v1/meet/listemeetsuser/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;   
                            if(res.length>0){
                                app.parametres.meets.push(res);
                                accessDB.saveMeets(res, app.user.get("identifiant"));
                            }
                                
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "listerMeetsNonlus");
                        },
                        
                        complete: function(){
                            if(! error){
                                callback(data);
                            }
                        }

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            // recherche tous les meets d'un utilisateur
            rechercherMeets: function(identifiant, callback){
                var error=false;
                var data;
                console.log("URL=");
                try{
                    $.ajax({
                        // adresse du service de recherche des meets d'un utilisateur'
                        url: app.parametres.serviceUrl+'/api/v1/meet/listemeetsuser/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;   
                            if(res.length>0)
                                app.parametres.meets.push(res);
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "rechercherMeets");
                        },
                        
                        complete: function(){
                            if(! error){
                                callback(data);
                            }                          
                        }

                    });


                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            //Permet à un utilisateur de changer son mot de passe
            changerMotDePasse: function(identifiant, oldpass, newpass, callback){
                var error=false;
                var data;
                
                console.log("URL=");
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/user/setmotdepasse/'+identifiant+'/'+oldpass+'/'+newpass+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "changerMotDePasse");
                        },
                        
                        complete: function(){
                            if(! error){
                                callback(data);
                            }
                            
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            //Change le device utilisé par un utilisateur
            modifierDeviceUtilisateur: function(identifiant){
                var error = false;
                
                var result;
                
                var address, nomdevice, osdevice;
                
                if(! window.device ){
                    
                    address="A0:12:AA:AF:0F:AA";
                    nomdevice=identifiant;
                    osdevice=navigator.platform;
                }
                
                address=encodeURIComponent(app.parametres.address);
                
                nomdevice=encodeURIComponent(app.parametres.bluetoothName);
                
                osdevice=encodeURIComponent(app.parametres.Os);                
                
                console.log("URL=");
                
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/device/couplage/'+identifiant+'/'+address+'/'+nomdevice+'/'+osdevice+'.json',

                        dataType: 'json', 
                        
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            result = res;
                        },

                        error: function(resultat, statut, erreur){
                            error = true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "modifierDeviceUtilisateur");
                        },
                        
                        complete: function(){
                            if(! error){
                                
                                if(result==1){
                                    // save the conf in the DB
                                    accessDB.saveDeviceUser(identifiant, address);
                                }
                            }
                            
                        }

                    });
                }
                catch (exception){
                    console.log("Erreur: "+exception);
                }
            },
            rechercherMobile: function(address, callback){
                var error=false;
                var data;
                console.log("URL="+app.parametres.serviceUrl+'/api/v1/device/search/'+address+'.json');
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/device/search/'+address+'.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "rechercherMobile");
                        },
                        
                        complete: function(){
                            if(! error){
                                callback(data);
                                accessDB.saveDeviceUser(data.identifiant, address);
                            }
                            else{
                                accessDB.rechercherMobile(address, callback);
                                
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            //recherche du device d'un utilisateur
            rechercherDeviceUtilisateur: function(identifiant, callback){
                var error=false;
                var data;
                
                console.log("URL=");
                
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/device/getlastdeviceuser/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "rechercherDeviceUtilisateur");
                        },
                        
                        complete: function(){
                            if(! error){
                                callback(data);
                                accessDB.saveDeviceUser(identifiant, data.adresse);
                            }
                            else{
                                accessDB.rechercherUser(identifiant, callback);
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            //Recherche des evenements auxquels l'utilisateur est inscrit
            rechercherEvenementsUtilisateur: function(identifiant, callback){
                var error=false;
                var data;
                console.log("URL="+app.parametres.serviceUrl+'/api/v1/user/evenement/liste/'+identifiant+'/Meetooth.json');
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/user/evenement/liste/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "rechercherEvenementsUtilisateur");
                            
                        },
                        
                        complete: function(){
                            if(! error){
                                callback(data);
                                accessDB.saveEventsUser(identifiant, data);
                            }
                            else{
                                accessDB.rechercherEvenementsUtilisateur(identifiant, callback);
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            rechercherEvenement: function(idevt, callback){
                var error=false;
                var data;
                console.log('URL='+ app.parametres.serviceUrl+'/api/v1/evenement/getevent/'+idevt+'.json');
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/evenement/getevent/'+idevt+'.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "rechercherEvenement");
                            
                        },
                        
                        complete: function(){
                            if(! error){
                                callback(data);
                            }
                            else{
                                accessDB.rechercherEvenement(idevt, callback);
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            //Rechercher tous les énénements enregistrés, liés à un utlisateur pas sa participation ou non participation
            rechercherAllEvenementsUser: function(identifiant, callback){
                var error=false;
                
                var data;
                console.log("URL="+app.parametres.serviceUrl+'/api/v1/users/listeralleventsutilisateur/'+identifiant+'/Meetooth.json');
                            
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/users/listeralleventsutilisateur/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(JSON.stringify(resultat), statut, erreur, "rechercherAllEvenementsUser");
                        },
                        
                        complete: function(){
                            if(! error){                                
                                // save envents in the DB
                                accessDB.saveEvents(data, identifiant);
                                callback(data);
                            }
                            else{
                                
                                // rechercher en local
                                accessDB.rechercherAllEvenementsUser(identifiant, callback);
                                
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            // inscription à un evenement
            inscrireEvenement: function(identifiant, idevent, callback){
                var error=false;
                var data;
                console.log("URL=");
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/evenement/inscrireevent/'+identifiant+'/'+idevent+'.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur,"inscrireEvenement");
                        },
                        
                        complete: function(){
                            if(! error){
                                callback(data);
                                if(data==1){
                                    accessDB.saveParticipationEvent(identifiant, idevent);
                                }
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            //Annulation d'inscription à un evenement
            DesinscrireEvenements: function(identifiant, idevent, callback){
                var error=false;
                var data;
                
                console.log("URL=");
                
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/evenement/desinscrireevent/'+identifiant+'/'+idevent+'.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur, "DesinscrireEvenements");
                        },
                        
                        complete: function(){
                            if(! error){
                                callback(data);
                                if(data==1){
                                    accessDB.cancelParticipationEvent(identifiant, idevent);
                                }
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            // regarde sur le serveur s'il ya de nouveaux evenements et le signale dans la table des notifications
            NotifierNouveauxEvenements: function(identifiant, callback){
                var error=false;
                var data;
                
                console.log("URL=");
                
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/users/notifierevenement/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            
                        },
                        
                        complete: function(){
                            if(! error){                                
                                callback(data);                                
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            
            },
            // Supprimer un favoris
            supprimerFavoris: function(identifiant, iduser,callback){
                var error=false;
                var data;
                
                console.log("URL=");
                
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/favoris/supprimer/'+iduser+'/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur,"supprimerFavoris");
                        },
                        
                        complete: function(){
                            if(! error){                                
                                app.services.rechercherFavoris(identifiant, null);
                                callback(data);
                                
                                if(data==1){
                                    accessDB.deleteFavoris(identifiant, iduser);
                                }
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            
            },
            //recherche le type de formule d'un utilisateur
            rechercherTypeFormule: function(login, callback){
                var error=false;
                var data;
                console.log("URL=");
                
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/formule/typeformule/'+login+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur);
                        },
                        
                        complete: function(){
                            if(! error){
                                callback(data);
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            
            },
            //Activer la formule premium
            activerPremium: function(identifiant, code, callback){
                
                var error=false;
                var data;
                
                console.log("URL=");
                
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/formule/souscriptionprem/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur);
                        },
                        
                        complete: function(){
                            if(! error && data==1){
                                app.utils.updateUiFormule(data);
                                app.utils.showInfoMessage('Souscription à la formule premium de Meetooth validée');
                            }
                            else{
                                app.utils.showInfoMessage('Souscription à la formule premium de Meetooth non validée');
                            }
                            callback(data);
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            //Ajouter un favoris à un utilisateur
            ajouterFavoris: function(monidentifiant, sonidentifiant, callback){
                var error=false;
                var data;
                console.log("URL=");
                
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/favoris/ajouter/'+sonidentifiant+'/'+monidentifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                            app.utils.handleAjaxErrors(resultat, statut, erreur);
                        },
                        
                        complete: function(){
                            if(! error ){
                                app.services.rechercherFavoris(monidentifiant, null);
                                callback(data);
                                if(data==1){
                                    accessDB.saveFavoris(monidentifiant, [{username: data}]);
                                    app.parametres.favoris.push({username: sonidentifiant});
                                }
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            //rechercher des favoris de l'utilisateur connecté
            rechercherFavoris: function(identifiant, callback){
                var error=false;
                var data;
                
                console.log("URL=");
                
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/favoris/liste/'+identifiant+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;     
                            
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                        },
                        
                        complete: function(){
                            if(! error ){
                                if($.isFunction( callback)){
                                    callback(data);
                                }
                                
                                accessDB.saveFavoris(identifiant, data);
                                
                                var favoris=[];
                                
                                for(var id in data){
                                    favoris.push({"username": data[id].username});                                   
                                }
                                
                                app.parametres.favoris=favoris;
                                                                
                            }
                            else{
                                accessDB.rechercherFavoris(identifiant, callback);
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            // Envoyer un message à un utilisateur
            sendMessageTo: function(idemetteur, idrecepteur ,texte,callback){
                var error=false;
                var data;
                console.log("URL=");
                
                texte=encodeURIComponent(texte);
                
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/message/send/'+idemetteur+'/'+idrecepteur+'/'+texte+'.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                        },
                        
                        complete: function(){
                            if(! error ){
                                if($.isFunction( callback)){
                                    callback(data);
                                }
                            }
                            else{
                                callback(0);//appelles le callback en lui disant que le message n'a pas été envoyé'
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            // lister les messages reçus non lus entre deux utilisateurs
            receiveMessagesFrom: function( idrecepteur, idemetteur, callback){
                var error=false;
                var data;
                console.log("URL=");                
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/message/listermessageemetteurrecepteur/'+idemetteur+'/'+idrecepteur+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                        },
                        
                        complete: function(){
                            if(! error ){
                                if($.isFunction( callback)){
                                    callback(data);
                                }
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            //Lister les echanges de message récenste ntre deux tuilisateurs
            listerMessagesRecents: function(utilisateur1, utilisateur2, seuilinf, seuilsup, callback){
                var error=false;
                var data;
                console.log("URL=");                
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/message/listermessageemetteurrecepteur/'+utilisateur1+'/'+utilisateur2+'/Meetooth.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                        },
                        
                        complete: function(){
                            if(! error ){
                                if($.isFunction( callback)){
                                    callback(data);
                                }
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }
            },
            // recherche les question de la faq
            rechercherQuestionsFAQ: function(callback){
                var error=false;
                var data;
                console.log("URL=");
                try{
                    $.ajax({
                        // adresse du service qui chage de mot de passe
                        url: app.parametres.serviceUrl+'/api/v1/getfaqs.json',

                        dataType: 'json', 
                        timeout: app.parametres.timeoutdelay,

                        success: function (res){
                            data=res;                              
                        },

                        error: function(resultat, statut, erreur){
                            error=true;
                        },

                        complete: function(){
                            if(! error ){
                                if($.isFunction( callback)){
                                    callback(data);
                                    // save questions in the the DB
                                    accessDB.updateQuestions(data);
                                }
                            }
                            else{
                                accessDB.rechercherQuestions(callback);
                            }
                        }

                    });

                }
                catch(exception){
                    console.log("Erreur: "+exception);
                }

            },
            rechercherQuestion: function(idquestion, callback){
                accessDB.rechercherQuestion(idquestion, callback);
            }
                        
        },
        utils:{
             showInfoMessage: function(message){ // affiche un message en info bulle
        
                if(window.plugins && window.plugins.toast){
                    window.plugins.toast.showShortCenter(message, function(){}, function(){});
                    console.log("show short");
                }
                else{
                    console.log("display box");
                    app.utils.displayBox(
                    "<div class='ui-corner-all info'>"
                        +message+
                    "</div>", app.constants.dialog.info);
                    
                }
        
            },
            showInfoMessageLong: function(message){ // affiche un message en info bulle
        
                if(window.plugins && window.plugins.toast){
                    window.plugins.toast.showLongCenter(message, function(a){console.log('toast success 1: ' + a);}, function(b){console.log('toast error2: ' + b);});
                    
                }
                else{
                    
                    app.utils.displayBox(
                    "<div class='ui-corner-all info'>"
                        +message+
                    "</div>", app.constants.dialog.infolong);
                    
                }
        
            },
            
            displayBox: function(box, typebox){      // Affiche une boite de dialogue ou une info pop à l'ecran
                
                box=$(box).css({ 
                            "display": "none",
                            "opacity": 0.96,
                            "position":"absolute"
                        })
                .appendTo( $.mobile.pageContainer );

                var windowHeight = $(window).height();
                var windowWidth = $(window).width();
                var elementHeight = box.height();
                var elementWidth = box.width();

                var elementTop, elementLeft;
//                
                // calcul de la bonne position centrée
                if (windowHeight <= elementHeight) {
                    elementTop = $(window).scrollTop();
                } 
                else {
                    elementTop = ((windowHeight - elementHeight) / 2) + $(window).scrollTop();
                }

                if (windowWidth <= elementWidth) {
                    elementLeft = $(window).scrollLeft();
                } 
                else {
                    elementLeft = ((windowWidth - elementWidth) / 2) + $(window).scrollLeft();
                }
                
                box.css({"top": elementTop,"left":elementLeft });
                
                switch(typebox){ // Selon le type de box qu'on veut afficher'
                    
                    // Message d'information
                    case app.constants.dialog.info: box.fadeIn(600).delay( 2000 )
                                                            .fadeOut( 600, function(){
                                                                $(this).remove();
                                                            }); 
                                                            break;
                    // Message d'information
                    case app.constants.dialog.infolong: box.fadeIn(600).delay( 4000 )
                                                            .fadeOut( 600, function(){
                                                                $(this).remove();
                                                            }); 
                                                            break;
                                                            
                    // Pop up, affichage simple                                        
                    case app.constants.dialog.popup: box.show();
                                                             break;
                                                             
                    // Meet, affichage et retrait apres 1500ms                                         
                    case app.constants.dialog.meet: box.show(700).delay( 11800 )
                                                            .fadeOut( 600, function(){
                                                                $(this).remove();
                                                            }); 
                                                            
                                                            break;
                       
                }
                    
            },
            confirm: function(message, callback, titre){
                if(navigator && navigator.notification && navigator.notification.confirm){
                    navigator.notification.confirm(
                            message
                          , function(button) {
                                if (button == 1) {
                                    callback();
                                }
                            }
                          , titre? titre: app.parametres.apptitle
                          , ["Oui", "Non"]
                    );
                    //navigator.notification.confirm(message, Ondeleteclick,app.parametres.apptitle , 'Oui,Non');

                }
                else{
                    if(confirm(message)==true){
                        callback();
                    }

                }
                
            },
            
            alert: function(message, title) {
                if (navigator.notification) {
                    navigator.notification.alert(message, null, title, 'OK');
                } else {
                    alert(title ? (title + ": " + message) : message);
                }
            },
            
            handleAjaxErrors: function(resultat, statut, erreur, service){
                app.utils.hideloader();
                
                try{
                    if(navigator.connection && navigator.connection.type==Connection.NONE){

                        app.utils.showInfoMessage('Vous êtes déconnecté du réseau internet');

                    }
                    else{
                        //var activePage = $("body").pagecontainer("getActivePage");

                        var message="Oups, une erreur inconnue s'est produite";

                        if (statut === 0) {
                            message="Erreur de connexion, verifier le réseau.";
                            console.log('Erreur de connexion.\n Verifier le réseau.\n');
                        } else if (statut == 404) {
                            message="Erreur, Page non trouvée";
                            console.log('Page non trouvée.');
                        } else if (statut == 500) {
                            message="Erreur Interne du serveur";
                            // Erreur interne
                            console.log('Erreur Interne du serveur');
                        }
                        else {
                                if(erreur=='timeout'){
                                    message="Erreur de connexion, cette dernière semble trop faible !";
                                    console.log('Erreur de connexion.\n Verifier le réseau.\n');
                                }
                                else{
                                    console.log('Erreur innatendue.\n');
                                }
                        }

                        //app.utils.showInfoMessage(message);
                        console.log("++++++++++++++++RESULTAT="+JSON.stringify(resultat)+"+++++++++Erruer:"+erreur+" Statut:"+statut+" Service:"+service+"  message:"+message);
                    }
                }
                catch(e){
                    console.log(e);
                }
                
            },
            split:function ( val ) {
                return val.split( /;\s*/ );
            },
   
            extractLast:function ( term ) {
                return split( term ).pop();
            }, 
            
            // fonction de validation de date
            validerEmail :function(email){
                var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                return re.test(email);
            },
            validerIdentifiant: function(identifiant){
                return /^[a-zA-Z0-9-_]*$/.test(identifiant);
            },            
            // fonction de validation de pseudo
            validerPseudo :function(pseudo){
                return /^[a-zA-Z0-9-_ ]*$/.test(pseudo);
            },
            // fonction de validation de date
            validerDate :function(dtValue){
                var dtRegex = new RegExp(/\b\d{1,2}[\-]\d{1,2}[\-]\d{4}\b/);
                return dtRegex.test(dtValue);
            },
            calculerAge: function(datenaissance){
                if(datenaissance != null){
                    
                    var today=new Date();                                                                // Le date d'ouverture de la page (aujourd'hui)
                    
                    var yn = parseInt(datenaissance.substring(6, 10), 10);
                    var mn = parseInt(datenaissance.substring(3, 5), 10)-1;
                    var dn = parseInt(datenaissance.substring(0, 2), 10);
                    
                    datenaissance = new Date(yn, mn, dn);                                                // creation d'un objet date avec la date fournie
                    
                    var diff = (today.getTime() - datenaissance.getTime()) / 86400000;                   //calcul de la difference en nombre de jours

                    return Math.floor(diff/365.25);                                                      //determination du nombre d'années
                    
                }
                else{
                    return "*";
                }
                
            },
            //prends une date au format aaaa-MM-jj hh:mm et la renvoie au format jj-MM-aaaa
            parseNaissance: function(datenaissance){
                try{
                    if(datenaissance){
                    return (datenaissance.substring(0, 2)+"-"+datenaissance.substring(3, 5)+"-"+datenaissance.substring(6, 10)); 
                    }                
                    else{
                        return "";
                    }
                }
                catch(e){
                    console.log("Error "+e);
                    return "";
                }
                
            },
            
            ui_updateDiscoveredDevices:function(){
                var ul= $('#devicelist');
                
                var devicesNumber=localbluetooth.devicesDiscovered.length;
                
                ul.html("<li data-role='list-divider'>Périph&eacute;riques trouv&eacute;s<span class='ui-li-count'>"+devicesNumber+"</span></li>");
                
                for(var device in localbluetooth.devicesDiscovered){
                    ul.append("<li>"+
                                '<a href="dialogue.html?devicename='+encodeURIComponent(device.name)+'&address='+encodeURIComponent(device.address)+'" data-prefetch="true">'+

                                     "<h2>"+device.name+"</h2>"+
                                     "<p>"+device.address+"</p>"+
                                 "</a>"+
                                 "<a href='parametre.html?devicename="+encodeURIComponent(device.name)+"&address="+encodeURIComponent(device.address)+"' >Param&egrave;tres</a>"+
                             "</li>");                
                 }
                
                ul.listview("refresh");
                
            },
            // met à jour le bouton de menu sur le plan graphique
            updateMenuButton: function(){
                var idpage= $("body").pagecontainer("getActivePage").attr("id");
                
                if(app.utils.isSecuredPage(idpage)){
                    var nbNotifications=app.parametres.unreads.meets+app.parametres.unreads.events+app.parametres.unreads.messages;
                    
                    if(nbNotifications>0){
                        $("body").pagecontainer("getActivePage").find(".ui-header a.ui-btn-right").html(
                            '<div>'+
                                '<i class="fa fa-bars"></i> '+
                                '<div class="noti_bubble">'+nbNotifications+'</div>'+
                            '</div>');
                    }
                    else{
                        $("body").pagecontainer("getActivePage").find(".ui-header a.ui-btn-right").html(
                            '<i class="fa fa-bars"></i> ' );
                    }
                    
                }
                
            },
            updateMenu: function(){
                var idpage= $("body").pagecontainer("getActivePage").attr("id");
                var menudroite=$("#menudroit>div>ul");
                
                if(app.utils.isSecuredPage(idpage)){
                                        
                    if(app.parametres.unreads.meets>0){
                        app.utils.ui_NotifyState($("#menudroit>div>ul>li i.fa-heart"));
                    }
                    else{
                        app.utils.ui_DeNotifyState($("#menudroit>div>ul>li i.fa-heart"));
                    }
                    
                    if(app.parametres.unreads.events>0){
                        app.utils.ui_NotifyState($("#menudroit>div>ul .ui-icon-calendar").find(">span"));
                        app.utils.ui_NotifyState($("#menudroit>div>ul>li i.fa-ticket"));
                    }
                    else{
                        app.utils.ui_DeNotifyState($("#menudroit>div>ul .ui-icon-calendar").find(">span"));
                        app.utils.ui_DeNotifyState($("#menudroit>div>ul>li i.fa-ticket"));
                    }
                    
                    if(app.parametres.unreads.messages>0){
                        app.utils.ui_NotifyState($("#menudroit>div>ul>li i.fa-comments"));                    
                    }
                    else{
                        app.utils.ui_DeNotifyState($("#menudroit>div>ul>li i.fa-comments")); 
                    }                    
                }
                
                
                menudroite.enhanceWithin();
                menudroite.listview("refresh");
                $("#menudroit").panel();
                $("#menudroit" ).trigger( "updatelayout" );
                    
            },
            //change l'affichage des photos en fonction du type de formule
            updateUiFormule: function(formule_premium){
                if(formule_premium==1){
                    $("#cssformule").remove(); // retire le flou sur les visages
                }
                else{//ajoute le flou sur les visages
                    $("<style id='cssformule'>")
                    .prop("type", "text/css")
                    .html(".row .photouser img{"+
                        "filter: url(css/flou.svg#blur);"+
                        "-webkit-filter: blur(6px);"+
                        "-moz-filter: blur(6px);"+
                        "-o-filter: blur(6px);"+
                        "-ms-filter: blur(6px);}")
                    .appendTo("head");
                }
            },
            // Dessine les messages sur la page de discussion
            addMessagesToUI: function(listemessages){
                
                var messages=$('#discussion .conversations');
                
                var today = new Date();

                var yesterday = new Date();
                yesterday.setDate(today.getDate() - 1); // date de la veille            

                var messagesContent="";   // chaque message

                for(var idmsg in listemessages){

                    var date = new Date(Date.parse(listemessages[idmsg].dateenvoie));

                    //tester si la date c'est aujourdhui
                    if(date.toDateString() == today.toDateString()){
                         date = ""+date.getHours()+":"+date.getMinutes();

                    }
                    else if(date.toDateString() == yesterday.toDateString()){ // Teste si c'est hier
                         date = "Hier à "+date.getHours()+":"+date.getMinutes();

                    }
                    else{
                         date = "Le "+date.getDate()+"/"+date.getMonth()+"/"+date.getFullYear()+" à "+date.getHours()+":"+date.getMinutes();

                    }
                    var photouser = app.user.get("photo");
        
                    if(!photouser || (photouser.lastIndexOf("/") > photouser.lastIndexOf("."))){
                        photouser="images/default.jpg";
                    }
                    
                    if(listemessages[idmsg].idemetteur == app.user.get("identifiant")){
                        
                        messagesContent += '<div class="message-left">'+

                                                '<div class="current-user">'+
                                                        '<div class="photo vcentered">'+
                                                            '<img src="'+photouser+'"/>'+
                                                            '<div class="nom homme">Moi</div>'+
                                                        '</div>'+

                                                        '<i class="connected fa fa-circle vcentered"></i>  '+                      
                                                '</div>'+

                                                '<div class="message-content">'+
                                                    '<div class="bubble-content">'+
                                                        '<div class="bubble">'+
                                                            '<span class="contenu">'+
                                                                listemessages[idmsg].contenu+"<br/>"+
                                                                '<span style="font-size: 10px;">'+
                                                                    date+
                                                                '</span>'+

                                                            '</span>'+
                                                        '</div>'+
                                                   ' </div>'+
                                                '</div>'+

                                            '</div>';
                    }
                    else{   // Si je ne suis pas l'emetteur
                        
                        if(!listemessages[idmsg].photoemetteur || (listemessages[idmsg].photoemetteur.lastIndexOf("/") > listemessages[idmsg].photoemetteur.lastIndexOf("."))){
                            listemessages[idmsg].photoemetteur="images/default.jpg";
                        }
                        
                        messagesContent += '<div class="message-right">'+

                                                '<div class="current-user">'+
                                                        '<div class="photo vcentered">'+
                                                            '<img src="'+listemessages[idmsg].photoemetteur+'"/>'+
                                                            '<div class="nom homme">'+listemessages[idmsg].pseudoemetteur+'</div>'+
                                                        '</div>'+

                                                        '<i class="connected fa fa-circle vcentered"></i>  '+                      
                                                '</div>'+

                                                '<div class="message-content">'+
                                                    '<div class="bubble-content">'+
                                                        '<div class="bubble">'+
                                                            '<span class="contenu">'+
                                                                listemessages[idmsg].contenu+"<br/>"+
                                                                '<span style="font-size: 10px;">'+
                                                                    date+
                                                                '</span>'+

                                                            '</span>'+
                                                        '</div>'+
                                                   ' </div>'+
                                                '</div>'+

                                            '</div>';
                    }
                    
                }

                messages.html(messagesContent);

                app.parametres.unreads.messages=0;            

                // Supprimer l'image du loader sur cette page
                $("img.loader").remove();

                //  ainsi que sur le bouton de raffraichissement en haut
                $("#discussion>div.toplink >a.recherchermsgrecents img").replaceWith('<i class="fa fa-history"></i>');
                
                if($("div.message-left:last").length != 0){
                    var last_msg = $("div.message-left:last").offset().top;
                    setTimeout(function () {
                        $.mobile.silentScroll(last_msg);
                    }, 50);
                }
                
                
            },
            addMeetsToUI: function(meets){
                var meetarea=$("#meetsrecus").empty();
        
                app.parametres.unreads.meets=0;
                
                app.utils.updateMenuButton();
                
                app.utils.updateMenu();
                
                if(meets.length>0){
                    
                    $.each(meets, function(index, meet){
                        
                        if(!meet.photoemetteur || (meet.photoemetteur.lastIndexOf("/") > meet.photoemetteur.lastIndexOf("."))){
                            meet.photoemetteur="images/default.jpg";
                        }
                        
                        meetarea.append(
                            '<div class="row userswipe '+(! meet.notification?' notification':'')+'">'+
                                '<div class="photouser">'+
                                        '<img src="'+meet.photoemetteur+'" class="photo-small"/>'+
                                        '<div class="nom homme"><span>'+meet.pseudoemetteur+'</span></div>'+
                                '</div>'+

                                '<div class="icons single" style="top: 15%">'+
                                    '<small>Reçu le '+meet.dateenvoie.split(" ")[0]+ ' à '+meet.dateenvoie.split(" ")[1]+'</small>'+
                               ' </div>'+
                            '</div>');
                    });
                }
                else{
                    meetarea.append("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucun Meet trouv&eacute;</span></div>");
                }          

                // Supprimer l'image du loader sur cette page
                $("img.loader").remove();

                //  ainsi que sur le bouton de raffraichissement en haut
                $("#meetsrecents img").replaceWith('<i class="fa fa-history"></i>');
                
                var last_msg = $("div.row.userswipe:last").offset().top;
                
                setTimeout(function () {
                    $.mobile.silentScroll(last_msg);
                }, 50);
            },
            showloader : function (message){
        
                var msgText = message || $.mobile.loader.prototype.options.text;
                var textVisible = msgText? true:false;

                $.mobile.loading( 'show', {        
                    text: msgText,
                    textVisible: textVisible,
                    theme: 'a'
                });
            },
            hideloader: function(){
                $.mobile.loading( "hide" );
            },
            // recherche les nouveaux événements, et les utilisateurs hautement compatibles online, et le signale à l'utlisateur connecté
            lookupEventsAndOnline: function(){
                // Si l'utilisateur est bien connecté
                
                if(app.user.get("identifiant")!=null){
                    
                    //notifie les cas d'utilisateurs compatibles               
                    var findNotifications=function(){
                        
                        //recherche les notification des users en ligne
                        var notifyOnlines=function(users){
                            for(var i=0; i<users.length; i++){
                                
                                (function (index) {                  
                                    
                                    setTimeout(function () {      
                                        app.utils.beep(1);
                                              
                                    }, index*2000);                     //timeout receives a local temp[z] which
                                }(i));
                            }
                                                        
                        };
                        
                        // notify les cas d'evenements intéressants
                        var notifyEvents=function(evts){
                            var i=0;
                            
                            for(i=0; i< evts.length; i++){
                                
                                (function (index, idevt) {                  
                                    
                                    setTimeout(function () {      
                                        
                                        app.services.rechercherEvenement(idevt, function(evt){
                                            
                                            var activePage = $("body").pagecontainer("getActivePage");

                                            if(app.utils.isSecuredPage(activePage.attr("id"))){
                                                activePage.find("div.ui-content div.evtinfo").remove();
                                                activePage.find("div.ui-content").prepend(
                                                            '<div class="evtinfo" style="color:red; font-style: italic; text-shadow:none; border-bottom: 1px solid #CCCCCC; background-color:'+(evt.couleur=="red"?'#FCC200':evt.couleur)+'; width:100%; height:1.5em; display:none; padding-left: 0.5em;overflow: hidden;position: relative; text-align: left;text-overflow: ellipsis">'+
                                                                    "<i class='fa fa-calendar'> "+evt.nom+" ("+evt.date.substr(0, 10)+")</i> "+
                                                            '</div>');

                                                        activePage.find("div.ui-content div.evtinfo").slideDown(1000, function(){
                                                            setTimeout(function(){
                                                                    activePage.find("div.ui-content div.evtinfo").slideUp(1000, null);
                                                                },
                                                                3500);
                                                        });
                                                    }
                                        });       
                                    }, index*8000);                     //timeout receives a local temp[z] which
                                }(i, evts[i].type.split("-")[1]));

                            }
                            
                            // update the number of unseen events
                            app.parametres.unreads.events+=evts.length;
                            
                            //update the UI button
                            app.utils.updateMenuButton();
                            
                            app.utils.updateMenu();
                        }
                        
                        app.services.recevoirNotificationOnlineandEvents(app.user.get("identifiant"), notifyOnlines, notifyEvents);
                    }

                    app.parametres.notificationstimer=setInterval(findNotifications, app.parametres.timerinterval);
                }                
                
            },
            // recherche la liste des meets non encore notifiés, ayant pour destinataire l'utilisateur identifiant 
            lookupMeets: function(){
                
                if(app.user.get("identifiant")!=null){
                    
                    var updateMeets=function(){
                        app.services.listerMeetsNonlus(app.user.get("identifiant"), function(data){                        
                            
                            if(data.length>0){

                                var activePage = $("body").pagecontainer("getActivePage");
                                
                                var idpage=activePage.attr("id");
                                
                                var forbidden= (idpage=="loginpage" ||idpage=="aideloginpage" ||idpage=="indexpage" ||idpage=="inscriptionpage" ||idpage=="passoubliepage"||idpage=="aideloginpage");

                                if(! forbidden){                                   

                                    app.utils.ui_NotifyState($("#menudroit>div>ul>li i.fa-heart"));
                                    //affiche un message pour ton meet là
                                    if(data.length==1){
                                        // fais ton bip du meet
                                        app.utils.beep(2);
                                        app.utils.showInfoMessage("Nouveau Meet reçu!");
                                    }
                                    else{
                                        // fais ton bip du meet
                                        app.utils.beep(4);
                                        app.utils.showInfoMessage(data.length+" nouveaux Meet reçux!");
                                    }
                                    
                                }

                                app.parametres.unreads.meets+=data.length;                                

                            }

                            app.utils.updateMenuButton();
                            
                            app.utils.updateMenu();
                        });
                    }
                    // A chaque fois, il faut lister les événements à venir, et afficher ceux qui ne l'ont pas encore été
                    app.parametres.meettimer=setInterval(updateMeets, app.parametres.timerinterval);
                }
            },
            
            lookupContacts: function(){
                if(app.user.get("identifiant")!=null){
                    
                    
                    var updateContactsOnline=function(){
                        // lister les utilisateurs supposés connectés à l'appli via internet
                        app.services.listerUtilisateursOnNet(app.user.get("identifiant"), function(utilisateurs){
                            
                            var devices=localbluetooth.devicesDiscovered;// recupere les devices à proximité au sens bluetooth
                            console.log("------------------------nearest devices found ="+JSON.stringify(devices));
                            
                            var contacts=[];
                            
                            // retrouve les contacts qui sont à la fois à proximités et connectés via internet
                            for(var i=0;i<utilisateurs.length; i++){
                                for(var j=0; j<devices.length; j++){
                                    if(devices[j].address == utilisateurs[i].adresse){
                                        contacts.push({
                                            identifiant: utilisateurs[i].identifiant,
                                            nom: utilisateurs[i].nom, 
                                            prenom: utilisateurs[i].prenom,
                                            sexe: utilisateurs[i].sexe,
                                            online: 1
                                        });
                                    }
                                    
                                }
                                
                            }
                            // mets alors à jour la liste des users sauvegardés en BD
                            // save ces contacts comme en ligne
                            accessDB.saveContactsOnline(contacts);
                            console.log("------------------------contacts saved as online ="+JSON.stringify(contacts));
                        });
                        
                        // recupère tous les gars connectés via internet (via le service adéquat)
                        app.services.listerUtilisateursEnligne(app.user.get("identifiant"), function(utilisateurs){

                            var contactsOnnet=[];

                            for(var i=0;i<utilisateurs.length; i++){
                                contactsOnnet.push({
                                            identifiant: utilisateurs[i].identifiant,
                                            nom: utilisateurs[i].nom, 
                                            pseudo: utilisateurs[i].pseudo, 
                                            prenom: utilisateurs[i].prenom,
                                            datenaissance: utilisateurs[i].datenaissance,
                                            adresse: utilisateurs[i].adresse,
                                            photo: utilisateurs[i].photo,
                                            sexe: utilisateurs[i].sexe,
                                            onnet: 1
                                        });

                            }

                            // s'il y a au moins un contact, on l'enregistre dans la BD en disant qu'ils sont en ligne
                            accessDB.saveContactsOnNet(contactsOnnet);

                            console.log("------------------------contacts found on internet="+JSON.stringify(contactsOnnet));
                            
                        });
                        
                                                
                        // lookup favourites users
                        app.services.rechercherFavoris(app.user.get("identifiant"));
                        
                    }
                    updateContactsOnline();
                    
                    app.parametres.contacttimer=setInterval(updateContactsOnline, app.parametres.timerinterval);
                }
            },
            // recherche les périphériques à proximités
            lookupNearerDevices: function(){
                try{
                    
                    if(app.user.get("identifiant")!=null){
                        
                        var searchDevices=function(){
                            
                            if(localbluetooth.isDiscovering==false){ // si le gars n'est pas déjà entrain de rechercher
                                // decouvrir les devices
                                var devices=[];
                                
                                var usersDevices = [];
                                
                                localbluetooth.isDiscovering=true;
                                
                                if($("body").pagecontainer("getActivePage").attr("id")=="appareilspage"){
                                    $('#devicelist')
                                }

                                var onDeviceDiscovered=function (device){
                                    if(!device.name){
                                        device.name="Anonyme";
                                    }
                                    
                                    // si l'adresse ci n'est pas dans les derniers scans
                                    // On essaie de notifier sa présence sur la toile
                                    accessDB.deviceHasBeenFound(device.address, function(){

                                        app.services.notifierNouveauxComptatibles(app.user.get("identifiant"), device.address, function(res){
                                            if(res.trouve==1){                                        
                                                devices.push({name: device.name, address: device.address});
                                            }
                                        });

                                    });
                                    
                                    usersDevices.push({name: device.name, address: device.address});
                                    
                                    accessDB.saveContactOnline({name: device.name, address: device.address});
                                    
                                    // si la page est la page de devices, tu ajoutes ca sur cette page là
                                    
                                    if($("body").pagecontainer("getActivePage").attr("id")=="appareilspage"){
                                        
                                        app.utils.showDeviceFound({name: device.name, address: device.address}, usersDevices.length);
                                    }
                                };
                                
                                
                                // Call back executed when the discovering process ends
                                var onDiscoveryFinished=function (){
                                    //met à jour la liste des contacts sauvegardés
                                    // vide la table des device proches
                                    
                                    accessDB.savedevicesDiscovered(devices);
                                    
                                    localbluetooth.devicesDiscovered = usersDevices;
                                    
                                    localbluetooth.isDiscovering=false;
                                    
                                    if($("body").pagecontainer("getActivePage").attr("id")=="appareilspage"){
                                        $('#loaderbtn').buttonMarkup({ icon: "recycle", iconpos: "right" });
                                        
                                        if(usersDevices.length===0){

                                            $('#devicelist').html("<li data-role='list-divider'>Aucun périph&eacute;rique trouv&eacute;</li>");
                                            $('#devicelist').listview("refresh");
                                        }
                                    }
                                    
                                };

                                // Callback executed when an error accure when discovering devices
                                var onErrorDiscovering=function (error){
                                    
                                    console.log(JSON.stringify("Meetooth error while searching devices "+error));
                                };
                                
                                // lance la découverte des devices
                                //                              
                                if($("body").pagecontainer("getActivePage").attr("id")=="appareilspage"){
                                    $('#loaderbtn').buttonMarkup({ icon: "loader-mee", iconpos: "right" }); 
                                    $('#devicelist').empty();
                                }
                                    
                                localbluetooth.plugin.startDiscovery(onDeviceDiscovered, onDiscoveryFinished, onErrorDiscovering);
                                
                            }
                            

                        };
                        
                        searchDevices();
                        //recherche les périphériques toutes les 2 minutes 20 secondes
                        app.parametres.discoverDevicetimer=setInterval(searchDevices, app.parametres.longtimerinterval);
                    }
                
                }
                catch(exception){
                    console.log(exception);
                }
            },
            
            showDeviceFound: function(device, length){
                var ul= $('#devicelist');
                if(ul.find("li:first span.ui-li-count").length!=0){
                    ul.find("li:first span.ui-li-count").html(length);
                }
                else{
                    ul.html("<li data-role='list-divider'>Récemment trouv&eacute;<span class='ui-li-count'>"+length+"</span></li>");
                }
                //parametre
                ul.append(  
                            "<li><a href='viewdevice.html?devicename="+encodeURIComponent(device.name)+"&address="+encodeURIComponent(device.address)+"' id='de-"+device.address+"'>"+
                                    "<h2>"+device.name+"</h2>"+
                                    "</p>"+device.address+"</p>"+
                                "</a>"+
                            "</li>");
                ul.listview("refresh");
            },
            
            // Demande au serveur de regarder tous les événement dont je pourrais être intéréssé, puis de créer des notifications pour cela
            notifyEvents: function(){
                var checkEvent=function(){
                    // Notifie les nouveaux événements ausx utilisateurs interéssés
                    app.services.NotifierNouveauxEvenements(app.user.get("identifiant"), function(resultat){
                        //Bien passé ou pas, je ne fais rien. c'est pas grave dailleurs, il y aura un autre essaie dans quelques minutes
                    });
                }
                checkEvent();
                app.parametres.notifyevttimer=setInterval(checkEvent, app.parametres.longtimerinterval);
                
            },
            //Recherche les messages toutes les 30 secondes
            startLookupMessages: function(usersender, callback){
                var checkMessages=function(){
                    app.services.receiveMessagesFrom(app.user.get("identifiant"),usersender, callback);
                }
                
                app.parametres.notifymessagestimer=setInterval(checkMessages, app.parametres.shortinterval);
            },
            // fais quelques petits beeps pour notifier des choses
            beep: function(times){
                if(navigator && navigator.notification&& navigator.notification.beep)
                    navigator.notification.beep(times);
            },
            
            ui_NotifyState: function(element){
                
                //change le menu pour avoir la ligne de meet colorée
                element.addClass('color-red');
                if(element.parent().find("i.fa-exclamation-circle.color-red").length==0){
                    element.parent().prepend('<i class="fa fa-exclamation-circle color-red"></i> ');
                }
                
                //element.parent().remove("i.fa-exclamation-circle");
                
            },
            
            ui_DeNotifyState: function(element){
                
                //change le menu pour avoir la ligne de meet colorée
                element.removeClass('color-red');
                
                //element.parent().prepend('<i class="fa fa-exclamation-circle color-red"></i> ');
                element.parent().remove("i.fa-exclamation-circle");
                
            },
            
            estFavoris: function(identifiantuser){
                var favoris = app.parametres.favoris;
                for(var id in favoris){
                    if(favoris[id].username==identifiantuser){
                        return true;
                    }
                }
                return false;
            },
            // Is the page secured or not
            isSecuredPage: function(idpage){
                return idpage=="devicepage" || idpage=="dialoguepage"||idpage=="profilcontactpage"||idpage=="accueilpage"||idpage=="allevenementspage"||idpage=="appareilspage"||idpage=="changepasswordpage"||idpage=="compatibilitepage"||idpage=="desinscriptionpage"||idpage=="evenementspage"||idpage=="historiqueuserselectpage"||idpage=="historiquepage"||idpage=="meetspage"||idpage=="parametreuserselectpage"||idpage=="parametrepage"||idpage=="profilpersopage";
            },
            // Lance les fonctions de recherche périodique de données comme les meets, les évenements, les online
            loadPeriodicalDataAtConnection: function(login){
                // recherche les meets
                app.utils.lookupMeets();

                // recherche les évènements et les utilisateurs en ligne
                app.utils.lookupEventsAndOnline();

                // Recherche les contats en ligne(internet)
                app.utils.lookupContacts();

                app.utils.lookupNearerDevices();

                // look on the server if there are new events to notify to users interested, and notify them
                app.utils.notifyEvents();

                // lookup favourites users
                app.services.rechercherFavoris(login);

                app.services.rechercherTypeFormule(login, function(formul){
                    if(formul==1){
                        app.parametres.set({formule_premium: formul});
                        app.utils.updateUiFormule(formul);
                    }
                    else{
                        app.parametres.set({formule_premium: 0});
                        app.utils.updateUiFormule(0);
                    }

                });
                
                // Dis en ligne qu'un gars s'est connecté avec un appareil de cette marque, ce model et cette adresse MAC Bluetooth
                app.services.modifierDeviceUtilisateur(login);
            },
            
            clearTimeOutAndData: function(){
                //Met fin aux recherches de notifications
                clearTimeout(app.parametres.evtinfotimer);

                clearTimeout(app.parametres.meettimer);

                clearInterval(app.parametres.contacttimer);

                clearInterval(app.parametres.notificationstimer);

                clearInterval(app.parametres.discoverDevicetimer);

                clearInterval(app.parametres.evtcheckonlineusers);

                clearInterval(app.parametres.notifyevttimer);

                clearInterval(app.parametres.notifymessagestimer);

                app.parametres.favoris=[];
                
                app.parametres.contacts= [];
                
                app.parametres.meets= [];
                
                app.parametres.utilisateurs= [];
                
                app.parametres.unreads= { meets: 0, messages: 0, events: 0 };

                app.clearHistory();
                
                // retruit le remember-me data
                window.localStorage.clear("rememberme");
                
                app.parametres.rememberme = false;

            }

        }

    }   // fin meetoothapp
     
     
    /**
    * jQuery.fn.sortElements
    * --------------
    * @param Function comparator:
    *   Exactly the same behaviour as [1,2,3].sort(comparator)
    *   
    * @param Function getSortable
    *   A function that should return the element that is
    *   to be sorted. The comparator will run on the
    *   current collection, but you may want the actual
    *   resulting sort to occur on a parent or another
    *   associated element.
    *   
    *   E.g. $('td').sortElements(comparator, function(){
    *      return this.parentNode; 
    *   })
    *   
    *   The <td>'s parent (<tr>) will be sorted instead
    *   of the <td> itself.
    */
   jQuery.fn.sortElements = (function(){

       var sort = [].sort;

       return function(comparator, getSortable) {

           getSortable = getSortable || function(){return this;};

           var placements = this.map(function(){

               var sortElement = getSortable.call(this),
                   parentNode = sortElement.parentNode,

                   // Since the element itself will change position, we have
                   // to have some way of storing its original position in
                   // the DOM. The easiest way is to have a 'flag' node:
                   nextSibling = parentNode.insertBefore(
                       document.createTextNode(''),
                       sortElement.nextSibling
                   );

               return function() {

                   if (parentNode === this) {
                       throw new Error(
                           "You can't sort elements if any one is a descendant of another."
                       );
                   }

                   // Insert before flag:
                   parentNode.insertBefore(this, nextSibling);
                   // Remove flag:
                   parentNode.removeChild(nextSibling);

               };

           });

           return sort.call(this, comparator).each(function(i){
               placements[i].call(getSortable.call(this));
           });

       };

   })();


//Initialisation de jquery mobile
$(document).on("mobileinit", function(){
    
    $.mobile.loader.prototype.options.text = "Chargement...";
    $.mobile.loader.prototype.options.textVisible = false;
    $.mobile.loader.prototype.options.theme = "a";
    $.mobile.loader.prototype.options.html = "";
    $.mobile.buttonMarkup.hoverDelay = 0;
    $.mobile.defaultPageTransition="fade";
    $.mobile.pageLoadErrorMessage ="Erreur lors du chargement";
    $.mobile.phonegapNavigationEnabled=true;
    $.mobile.defaultPageTransition="slide";
    $.mobile.touchOverflowEnabled = true;
    
});
    

var onDeviceReady = function(){
    // Si la connexion part, message popup pour le signaler
    document.addEventListener("offline", function(){
        app.utils.showInfoMessage('Vous êtes déconnecté du réseau internet',app.constants.dialog.infoLong);        
    }, false);
    
    var attachFastClick=function(){
        FastClick.attach(document.body);
    }
    window.addEventListener('load', attachFastClick, false);
    
    app.initialize();
    
    localbluetooth.initialize();

    accessDB.initialize();
};

document.addEventListener("deviceready", onDeviceReady, false);

// prevent the back to the index page
document.addEventListener("backbutton", function(){
    
    // si la page courante est index ou accueil sans historique, alors sors de l'application
    var idpage= $("body").pagecontainer("getActivePage").attr("id");
    
    if (idpage == 'indexpage' || idpage == 'loginpage' || (idpage == 'accueilpage' && $.mobile.navigate.history.activeIndex==0)) {
                        
        navigator.app.exitApp();
        
    } 
    else{
        $.mobile.back();
    }
    
}, true);
