    
    // Objet that handle bluetooth actions
    var localbluetooth = {
        
        states:["on","off","busy", "ready","paired","unknown"],  //states of the bluetooth
        
        currentstate:"unknown", //current state
        
        plugin: null, // bluetooth plugin
        
        isEnabled: null,

        isConnected:false,
        
        isDiscovering: false,
        
        devicesDiscovered: [],
        
        connectionManager: null,
                
        // fonction d'initialisation
        initialize: function() {
                        
            var getInfoSuccess=function(info){
                app.parametres.address=info.address;
                app.parametres.bluetoothName=info.name;
                app.parametres.Os=window.device.platform;
            }
            
            var getInfoError=function(){
                app.parametres.address=window.device.uuid;
                app.parametres.bluetoothName=window.device.name;
                app.parametres.Os=window.device.platform;
                
            }
            
            
            try{
                
                localbluetooth.enable(localbluetooth.monitor);
                
            }
            catch(e){
                console.log('MeetoothLog- Enable error'+e.message);
            }
            
            
            try{
                this.plugin=window.bluetooth;                
                this.plugin.getLocalinfo(getInfoSuccess, getInfoError);
                
            }
            catch(e){
                console.log('error'+e.message);
            }
           
        },
        
        enable : function(sucesscallback){
            
            var testEnabled=function(result){   // invoked if when the test of bluetooth enabled stated is made sucessfully
               
                if(!result){ // non activé, j'active now
                    localbluetooth.plugin.enable( sucesscallback,                        
                        function(error){         // si on ne réussit pas à l'enable                   
                            navigator.app.exitApp();
                        }
                    );
                }
                else{   //deja activé
                    //alert("already activated");
                    sucesscallback();
                }
            };
            
            var errorCallback=function(error){  // invoked when an error occur when looking for the bluetooth enabled state
                app.utils.showInfoMessage("Erreur lors du controle sur l'activation"+error);
                console.log("MeetoothLog- Erreur lors du controle sur l'activation"+error);
                //alert("error="+error);
            };
            
            //alert("before, plugin="+localbluetooth.plugin);
            // test if the bluetooth is enabled, and enable it if not yet done
            window.bluetooth.isEnabled(testEnabled, errorCallback);
            //alert("after");
            
        },
        
        startDiscovery : function(){
            
            var devices=[];
                        
            localbluetooth.isDiscovering=true;
            
            var ul= $('#devicelist').empty();
            
            // Call back executed when a device is discovered
            $('#loaderbtn').buttonMarkup({ icon: "loader-mee", iconpos: "right" });
            
            var onDeviceDiscovered=function (device){
                
                if(!device.name){
                    device.name="Anonyme";
                }
                
                devices.push({name: device.name, address: device.address});
                
                app.utils.showDeviceFound({name: device.name, address: device.address}, devices.length);                
                
            };
        
            // Call back executed when the discovering process ends
            var onDiscoveryFinished=function (){
                
                $('#loaderbtn').buttonMarkup({ icon: "recycle", iconpos: "right" });
                
                localbluetooth.isDiscovering=false;
                
                if(devices.length===0){
                    
                    ul.html("<li data-role='list-divider'>Aucun périph&eacute;rique trouv&eacute;</li>");
                    ul.listview("refresh");
                }
                else{
                    // update the list of devices discovered
                    localbluetooth.devicesDiscovered=devices;
                }
                
            };

            // Callback executed when an error accure when discovering devices
            var onErrorDiscovering=function (error){
                //console.log("Erreur lors de la recherche de périphériques "+ JSON.stringify(error));
                console.log(JSON.stringify(error));
            };
            // si cest entrain de découvrir, stop dabord
            localbluetooth.plugin.startDiscovery(onDeviceDiscovered, onDiscoveryFinished, onErrorDiscovering);

        },
        
        stopDiscovery: function(successCallback){
            var Ondiscoverystopped=function(){
                $('#loaderbtn').buttonMarkup({ icon: "recycle", iconpos: "right" });
                localbluetooth.isDiscovering=false;
            };
            var OndiscoverystoppedError=function(){
                $('#loaderbtn').buttonMarkup({ icon: "loader-mee", iconpos: "right" });

            };
            
            localbluetooth.plugin.stopDiscovery(Ondiscoverystopped, OndiscoverystoppedError);
        },
        
        onMessage: function( message){
                        
            var sender={id: message.split(":")[0], prenom: message.split(":")[1], pseudo: message.split(":")[2]};
            
            var read=0;
            
            message=message.substring(message.split(":", 3).join(":").length+1);
                    
            // si la page courante est la page de discussion, alors affiche
            
            var page=$("body").pagecontainer("getActivePage").attr("id");
                        
            var showMessage = function(user){
                var photocontact = "images/default.jpg";
                
                if(user){
                    photocontact= user.photo;
                    
                    if(! photocontact || (photocontact.lastIndexOf("/") > photocontact.lastIndexOf("."))){
                        photocontact="images/default.jpg";
                    }
                    sender.photo = photocontact;
                }
                
                if(app.utils.isSecuredPage(page)){
                    if(page=="dialoguepage" ){ 
                    //Page de discussion affichée

                        read=1;

                        // On y ajoute le message
                        var messages=$('#discussion .conversations');

                        var div=messages.find(">div:last");

                        if(div.hasClass("message-right")){
                            messages.find(" div.message-right:last .message-content span.contenu").append("<br/>"+message);
                        }
                        else{
                             messages.append('<div class="message-right">'+

                                '<div class="current-user">'+
                                        '<div class="photo vcentered">'+
                                            '<img src="'+photocontact+'"/>'+
                                            '<div class="nom homme">'+sender.pseudo+'</div>'+
                                        '</div>'+

                                        '<i class="connected fa fa-circle vcentered"></i>  '+                      
                                '</div>'+

                                '<div class="message-content">'+
                                    '<div class="bubble-content">'+
                                        '<div class="bubble">'+
                                            '<span class="contenu">'+
                                                message+
                                            '</span>'+
                                        '</div>'+
                                   ' </div>'+
                                '</div>'+

                            '</div>');
                        }

                        //Scroll la fenêtre vers le bas
                        var last_msg = $("div.message-left:last").offset().top;
                        setTimeout(function () {
                            $.mobile.silentScroll(last_msg);
                        }, 50);
                    }
                    else{
                        // page autre que celle de dialogue, enregistre ça dans les messages non lus, 

                        // incremente les notifications
                        app.parametres.unreads.messages+=1;

                        app.utils.updateMenu();

                        app.utils.updateMenuButton();

                        //Emet un petit signal sonore
                        app.utils.beep(1);

                        if($.mobile.activePage.find("#popup-infomessage").length == 0){
                            var h=$(window).scrollTop() - 40;
                            var popup='<div data-role="popup" id="popup-infomessage" class="dialog pagediscussion" style="min-height: 50%; max-height:'+h+'px;" data-theme="a" data-dismissible="false">'+
                                '<div class="ui-corner-all custom-box">'+
                                    '<div class="ui-bar ui-bar-a">'+
                                        '<h3>Nouveaux messages reçus</h3>'+
                                    '</div>'+

                                    '<div class="ui-body ui-body-a .conversations" style="padding: 0.4em 0">'+
                                        '<div class="message-right">'+

                                            '<div class="current-user">'+
                                                    '<div class="photo vcentered">'+
                                                        '<img src="'+photocontact+'"/>'+
                                                        '<div class="nom homme">'+sender.pseudo+'</div>'+
                                                    '</div>'+

                                                    '<i class="connected fa fa-circle vcentered"></i>  '+                      
                                            '</div>'+

                                            '<div class="message-content">'+
                                                '<div class="bubble-content">'+
                                                    '<div class="bubble">'+
                                                        '<span class="contenu">'+
                                                            message+
                                                        '</span>'+
                                                    '</div>'+
                                               ' </div>'+
                                            '</div>'+

                                        '</div>'+
                                    '</div>'+

                                    '<div data-role="controlgroup" data-type="horizontal" class="ui-field-contain centered button ui-bar-f ui-bar-a" >'+
                                        '<a href="#" class="ui-btn ui-corner-all ui-btn-b ui-icon-delete ui-btn-icon-left" data-rel="back">'+
                                            'Fermer'+
                                        '</a>'+

                                        '<a href="dialogue.html?id='+sender.id+'" class="ui-btn ui-corner-all ui-btn-b ui-icon-comment ui-btn-icon-right">'+
                                            'Voir'+
                                        '</a>'+
                                    '</div>'+
                                '</div>'+
                            '</div>';

                            $( popup ).appendTo( $.mobile.activePage ).popup();
                            $( "#popup-infomessage").enhanceWithin();

                            setTimeout(function () {
                              $( "#popup-infomessage").popup( "open");
                            }, 200); 


                            //retirer le popup après sa fermeture
                            $( document ).on( "popupafterclose", "#popup-infomessage", function() {
                              $( this ).remove();
                            });

                            //retirer le popup après sa fermeture
    //                        $( document ).on( "click", "#popup-infomessage a", function(e) {
    //                            e.preventDefault();
    //                            e.stopPropagation();
    //                          $( "#popup-infomessage" ).close();
    //                        });

                        }
                        else{
                            $( "#popup-infomessage div.ui-body").append('<div class="message-right">'+

                                '<div class="current-user">'+
                                        '<div class="photo vcentered">'+
                                            '<img src="'+photocontact+'"/>'+
                                            '<div class="nom homme">'+sender.pseudo+'</div>'+
                                        '</div>'+

                                        '<i class="connected fa fa-circle vcentered"></i>  '+                      
                                '</div>'+

                                '<div class="message-content">'+
                                    '<div class="bubble-content">'+
                                        '<div class="bubble">'+
                                            '<span class="contenu">'+
                                                message+
                                            '</span>'+
                                        '</div>'+
                                   ' </div>'+
                                '</div>'+

                            '</div>');
                        }

                    }

                    //Enregistre le message dans la BD
                    accessDB.saveMessage(sender, message, read, app.user.get("identifiant"));
                }
                
            };
            
            
            accessDB.rechercherUser(sender.id, showMessage, showMessage);
            
        },
                
        // Fonction de connexion à un un device, s'il ne l'est pas déjà
        connect: function(address, callbackSuccess, callbackError) {
                        
            var checkConnected=function(connected){
                
                var connectedSuccess= function() {   // succès de la connexion
                    localbluetooth.isConnected=true;
                    app.utils.showInfoMessage("Connexion réussie");
                    
                    if($.isFunction(callbackSuccess)){
                        callbackSuccess();
                    }
                };
                
                var connectedFailed=function(){
                    localbluetooth.isConnected=false;
                    app.utils.showInfoMessage("Echec de la connexion");
                    
                    if($.isFunction(callbackError)){
                        callbackError();
                    }
                };
                
                if(connected.result==true && connected.device== address){
                    
                    callbackSuccess();
                }
                else if(connected.result==true && connected.device!= address){
                    
                    var disconnectRequest = function(){
                        // me déconnecte dabord
                        var disconnectedSuccess=function(){
                            // Bien déconnecté, je peux me reconnecter
                            localbluetooth.plugin.connect( connectedSuccess, localbluetooth.error, {address: address, uuid: null});
                        };

                        localbluetooth.plugin.disconnect(disconnectedSuccess, localbluetooth.error);
                    }
                    
                    // je suis connecté à un autre device, je demande s'il vaut de déconnecter
                    app.utils.confirm("Vous êtes connectés à un autre contact!\n Voulez vous vous déconnecter?", disconnectRequest);
                    
                }
                else if(connected.result==false){
                    // non connecté, je me connecte une fois
                    
                    localbluetooth.isConnected=false;
                    
                    localbluetooth.plugin.connect( connectedSuccess, connectedFailed, {address: address, uuid: null});
                }
            }
             
            localbluetooth.plugin.isConnected(checkConnected, localbluetooth.error);
            
        },
        
        disconnect: function() {
            var onFail = function() {   // echec de la connexion
                app.utils.showInfoMessage("Erreur lors de la tentative de déconnexion");
            };
            
            var onDisconnect= function() {   // succès de la connexion
                localbluetooth.isConnected=false;
                app.utils.showInfoMessage("Succès lors de la déconnexion");
            };
            
            localbluetooth.plugin.disconnect(onDisconnect, onFail);
	},
        
        // check if the device is connected with another
        ifIsConnected: function(connected, disconnected){
            localbluetooth.plugin.isConnected(function(connState){
                if(connState.result==true){
                    connected();
                }
                else{
                    disconnected();
                }
            }, localbluetooth.error);
        },
            
        sendData: function(message, callbackSuccess, callbackError, recepteur) {
            // Text to send=lastname+username+data to send
            var text = app.user.get("identifiant")+":"+app.user.get("prenom")+":"+app.user.get("pseudo")+":"+message+ "\n";
                        
            var isconnected=function(result){
                if(result){
                    // callback called when data has been sent
                    var successWriting = function () {
                        callbackSuccess();
                        
                        accessDB.saveMessage({id:app.user.get("identifiant") , pseudo: app.user.get("pseudo"), photo: app.user.get("photo")}, message, 0, recepteur);
                    };
                    
                    var errorWriting=function(){
                        if(callbackError === undefined)
                            callbackError = localbluetooth.error;
                        callbackError();
                    };
                    
                    //Write data on the bluetooth socket
                    localbluetooth.plugin.write(successWriting, errorWriting,text, "UTF-8", true);
                }
                else{
                    app.utils.showInfoMessage("Echec de l'envoi, non connecté au destinataire");
                }
            }
            
            // check if the device is connected before writing any message
            localbluetooth.plugin.isConnected(isconnected, localbluetooth.error);
            
            
        },
        // Ecoute des messages
        monitor :function() {
            
            localbluetooth.plugin.startConnectionManager(localbluetooth.onMessage, localbluetooth.error);
            
        },
        
        autodiscover: function(){
            
        },
        
        error: function(error){
            console.log("error="+JSON.stringify(error));
        },
        
        utilsFunction: {
            // General function to handle errors
            genErrorFunction: function(error){
                //console.log("error type="+error.error+": "+error.message);
            }
        }
        
    };
    
    var accessDB={
        dbref: null,                // reference à la BD
        dbname: "Metooth_DB",       // nom de la BD
        dbversion: "1.0",           // Version dela BD
        resultlist: [],             // List of results returned by a query
        TableDeviceFound: "DEVICEFOUND",
        
        createDB: function(tx){
            var creTabUser="CREATE TABLE IF NOT EXISTS UTILISATEUR ("+
                            "identifiant VARCHAR PRIMARY KEY NOT NULL,"+
                            "nom VARCHAR NOT NULL,"+
                            "prenom VARCHAR,"+
                            "photo VARCHAR,"+
                            "pseudo VARCHAR,"+
                            "email VARCHAR,"+
                            "sexe VARCHAR,"+
                            "datenaissance DATE,"+
                            "password VARCHAR NOT NULL,"+
                            "description VARCHAR,"+
                            "online BOOLEAN DEFAULT 0,"+
                            "onnet BOOLEAN DEFAULT 0,"+
                            "activerme BOOLEAN DEFAULT 0,"+
                            "activerjob BOOLEAN DEFAULT 0,"+
                            "annonceme VARCHAR,"+
                            "annoncejob VARCHAR,"+
                            "complementinformationsjob VARCHAR,"+
                            "complementinformationsme VARCHAR,"+
                            "lastactivity TIMESTAMP,"+
                            "adresse VARCHAR)";
                        
            var creTabMessage="CREATE TABLE IF NOT EXISTS MESSAGE ("+
                            "id INTEGER NOT NULL PRIMARY KEY,"+
                            "contenu VARCHAR,"+
                            "dateenvoie TIMESTAMP NOT NULL,"+
                            "datelecture TIMESTAMP,"+
                            "notification BOOLEAN NOT NULL DEFAULT 0,"+
                            "iduseremetteur INTEGER NOT NULL,"+
                            "pseudoemetteur INTEGER NOT NULL,"+  
                            "photoemetteur VARCHAR,"+
                            "iduserrecepteur INTEGER NOT NULL)";
            
            var creTabDevice="CREATE TABLE IF NOT EXISTS DEVICE ("+
                            "id INTEGER NOT NULL UNIQUE PRIMARY KEY,"+
                            "adresse VARCHAR UNIQUE,"+
                            "nom VARCHAR,"+
                            "systeme VARCHAR,"+
                            "idutilisateur INTEGER NOT NULL,"+
                            "FOREIGN KEY (idutilisateur) REFERENCES UTILISATEUR(id))";
                        
            var creTabDeviceFound="CREATE TABLE IF NOT EXISTS DEVICEFOUND ("+
                            "adresse NOT NULL UNIQUE PRIMARY KEY,"+
                            "nom VARCHAR,"+
                            "systeme VARCHAR,"+
                            "idutilisateur INTEGER)";
                        
            var creTabFaq="CREATE TABLE IF NOT EXISTS FAQ ("+
                            "id INTEGER NOT NULL PRIMARY KEY,"+
                            "libelle VARCHAR UNIQUE,"+
                            "reponse VARCHAR)";
            
            var creTabMeet="CREATE TABLE IF NOT EXISTS MEET ("+
                            "id INTEGER NOT NULL PRIMARY KEY,"+
                            "dateenvoie TIMESTAMP,"+
                            "notification BOOLEAN DEFAULT 0,"+
                            "idemetteur VARCHAR NOT NULL,"+
                            "pseudoemetteur VARCHAR NOT NULL,"+
                            "photoemetteur VARCHAR NOT NULL,"+
                            "idrecepteur VARCHAR NOT NULL)";
            
            var creTabNotification="CREATE TABLE IF NOT EXISTS NOTIFICATION ("+
                            "id INTEGER NOT NULL PRIMARY KEY,"+
                            "type VARCHAR NOT NULL,"+
                            "idevent INTEGER NOT NULL,"+
                            "read BOOLEAN NOT NULL,"+
                            "idrecepteur VARCHAR NOT NULL)";
            
            var creTabFavoris="CREATE TABLE IF NOT EXISTS FAVORIS ("+
                            "iduser VARCHAR NOT NULL,"+
                            "iduserfavoris VARCHAR NOT NULL,"+
                            "PRIMARY KEY (iduser, iduserfavoris))";
            
            var creTabFormule="CREATE TABLE IF NOT EXISTS FORMULE ("+
                            "id INTEGER NOT NULL PRIMARY KEY,"+
                            "iduser INTEGER NOT NULL,"+
                            "type VARCHAR,"+
                            "FOREIGN KEY (iduser) REFERENCES UTILISATEUR(id))";
            
            var creTabEvenement="CREATE TABLE IF NOT EXISTS EVENEMENT ("+
                            "id INTEGER NOT NULL PRIMARY KEY,"+
                            "idevt INTEGER NOT NULL,"+
                            "nom VARCHAR NOT NULL,"+
                            "lieu VARCHAR,"+
                            "date TIMESTAMP,"+
                            "couleur VARCHAR,"+
                            "nbparticipants INTEGER,"+
                            "identifiant VARCHAR,"+
                            "participe BOOLEAN DEFAULT 0,"+
                            "detail VARCHAR)";
            
            var creTabParticipation="CREATE TABLE IF NOT EXISTS PARTICIPATION ("+
                            "id INTEGER NOT NULL PRIMARY KEY,"+
                            "iduser INTEGER NOT NULL,"+
                            "idevent VARCHAR,"+
                            "annule BOOLEAN,"+
                            "FOREIGN KEY (idevent) REFERENCES EVENEMENT(id),"+
                            "FOREIGN KEY (iduser) REFERENCES UTILISATEUR(id))";
            
            var creTabRefcriteresCom="CREATE TABLE IF NOT EXISTS CRITERECOMP ("+
                            "idcritere INTEGER NOT NULL,"+
                            "identifiant INTEGER NOT NULL,"+
                            "nomcritere INTEGER,"+
                            "valeur INTEGER,"+
                            "PRIMARY KEY (idcritere, identifiant))";
            
            var creTabCritereEvt="CREATE TABLE IF NOT EXISTS CRITEREEVT ("+
                            "idcritere INTEGER NOT NULL,"+
                            "identifiant INTEGER NOT NULL,"+
                            "nomcritere INTEGER,"+
                            "valeur INTEGER,"+
                            "PRIMARY KEY (idcritere, identifiant))";
                        
            var creTabCompatibilite="CREATE TABLE IF NOT EXISTS COMPATIBILITE ("+
                            "user1 VARCHAR ,"+
                            "user2 VARCHAR ,"+
                            "valeur INTEGER,"+
                            "PRIMARY KEY (user1, user2))";
            
            // Part la suite, créer toutes ces tables;
            // tester l'enregistrement des devices après chaque listing, et chargement sur la page d'accueil

//            tx.executeSql('DROP TABLE IF EXISTS CRITEREEVT');
//            tx.executeSql('DROP TABLE IF EXISTS REFCRITERECOM');
//            tx.executeSql('DROP TABLE IF EXISTS REFCRITEREEVT');
//            tx.executeSql('DROP TABLE IF EXISTS PARTICIPATION');
//            tx.executeSql('DROP TABLE IF EXISTS EVENEMENT');
//            tx.executeSql('DROP TABLE IF EXISTS FORMULE');
//            tx.executeSql('DROP TABLE IF EXISTS FAVORIS');
//            tx.executeSql('DROP TABLE IF EXISTS NOTIFICATION');
//            tx.executeSql('DROP TABLE IF EXISTS FAQ');
//            tx.executeSql('DROP TABLE IF EXISTS MEET');
//            tx.executeSql('DROP TABLE IF EXISTS DEVICE');
//            tx.executeSql('DROP TABLE IF EXISTS MESSAGE');

//            
//            tx.executeSql('DROP TABLE IF EXISTS UTILISATEUR');
//            tx.executeSql('DROP TABLE IF EXISTS DEVICEFOUND');
            
            tx.executeSql(creTabUser);
            tx.executeSql(creTabMessage);
            tx.executeSql(creTabDevice);
            tx.executeSql(creTabDeviceFound);
            
            tx.executeSql(creTabFaq);
            tx.executeSql(creTabMeet);
            
            tx.executeSql(creTabNotification);
            tx.executeSql(creTabFavoris);
            tx.executeSql(creTabFormule);
            tx.executeSql(creTabEvenement);
            tx.executeSql(creTabParticipation);
            
            tx.executeSql(creTabRefcriteresCom);
            tx.executeSql(creTabCritereEvt);
            
            tx.executeSql(creTabCompatibilite);
            
            
        },
        initialize: function(){     // Fonction d'initialisation de la BD
            try{
                this.dbref= window.openDatabase(this.dbname, this.dbversion, this.dbname, 5000000);
                this.dbref.transaction(this.createDB, this.errorOnExecution, this.successOnExecution);  

            }
            catch(e){
               console.log("Error when trying to create the database"); 
            }
        },
        
        errorOnExecution: function(err){
            console.log("Erreur: "+JSON.stringify(err));
            //alert("erreur sqlite="+JSON.stringify(err));
        },
        successOnExecution: function(){
            app.utils.showInfoMessage("Bienvenue sur Meetooth");
        },
        // recherche un device, sil est en ligne ou pas et fait quelque cheose de precis dans ce cas
        deviceHasBeenFound: function(address, notYetPresentcallback){
            
            try{
                var selectDevice=function(tx){
                                
                    tx.executeSql('SELECT * FROM UTILISATEUR WHERE adresse=?', [ address], function(tx, results){
                        var len = results.rows.length;

                        if(len>=1 && results.rows.item(0).online == 0){   // The user has not yet been seen near of me
                            notYetPresentcallback();
                        }

                    }, this.errorOnExecution);

                    //tx.executeSql('UPDATE UTILISATEUR SET online=1 WHERE adresse=?', [ address]);                
                }
            
                this.dbref.transaction(selectDevice, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
            
        },
        // sauvegarde l'adresse de périphérique utilisée par un utilisateur
        saveDeviceUser: function(identifiant, address){
            try{
                var updateDevice=function(tx){
                    tx.executeSql('UPDATE UTILISATEUR SET adresse = ? WHERE identifiant= ?', [address, identifiant]);                    
                }

                this.dbref.transaction(updateDevice,this.errorOnExecution);
            }
            catch(e){
                console.log(e);
            }            
        },
        // enregistre une liste de contacts
        saveContactsOnNet: function(contacts){
            
            try{
                
                var addContact= function(contact, tx){
                      
                    tx.executeSql('SELECT * FROM UTILISATEUR WHERE identifiant = ?', [contact.identifiant], function(tx, results){

                        var len = results.rows.length;

                        if(len!=0){
                            if(results.rows.item(0).online==1){
                                tx.executeSql('UPDATE UTILISATEUR SET nom=?, prenom=?, pseudo=?, datenaissance=?, adresse=?, onnet=?, photo=?, sexe=?, lastactivity=? WHERE identifiant = ?', [contact.nom, contact.prenom, contact.pseudo, contact.datenaissance, contact.adresse, contact.onnet, contact.photo, contact.sexe, new Date(), contact.identifiant]);
                            }
                            else{
                                tx.executeSql('UPDATE UTILISATEUR SET nom=?, prenom=?, pseudo=?, datenaissance=?, adresse=?, onnet=?, photo=?, sexe=? WHERE identifiant = ?', [contact.nom, contact.prenom, contact.pseudo, contact.datenaissance, contact.adresse, contact.onnet, contact.photo, contact.sexe, contact.identifiant]);
                            }

                        }
                        else{

                            tx.executeSql('INSERT INTO UTILISATEUR (identifiant, nom, prenom, pseudo, password, datenaissance, adresse, onnet, photo, sexe) VALUES(?, ?, ?, ?, "xxxxxxxx", ?, ?, ?, ?, ?)', [contact.identifiant, contact.nom, contact.prenom, contact.pseudo, contact.datenaissance, contact.adresse, contact.onnet, contact.photo, contact.sexe]);

                        }

                    }, this.errorOnExecution);
                }
                    
                this.dbref.transaction(function(tx){
                    tx.executeSql('UPDATE UTILISATEUR SET onnet = 0 WHERE 1');
                    
                    for(var id in contacts){
                        (function (contact, tx) {                  
                            
                            addContact(contact, tx);

                        }(contacts[id], tx));

                    }
                },this.errorOnExecution);  
                
                
                                
            }
            catch(e){
                console.log(e);
            }
        },
        // enregistre une liste de contacts
        saveContactsOnline: function(contacts){
            
            try{
                
                var updateContact= function(tx){
                    tx.executeSql('UPDATE UTILISATEUR SET online = 0 WHERE 1');
                    
                    for(var i=0; i<contacts.length; i++){
                        
                        (function (contact) {                  

                            tx.executeSql('UPDATE UTILISATEUR SET online=1, lastactivity=? WHERE identifiant = ?', [ new Date(), contact.identifiant]);                     //timeout receives a local temp[z] which
                        
                        }(contacts[i]));
                    }
                                        
                }
                
                accessDB.dbref.transaction(updateContact,this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        //Enregistre un contact en ligne
        saveContactOnline: function(contact){
            try{
                                
                var updateContact= function(tx){
                    tx.executeSql('UPDATE UTILISATEUR SET online=1, lastactivity=? WHERE adresse = ? and onnet=1', [ new Date(), contact.address]);
                }
                
                accessDB.dbref.transaction(updateContact,this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        saveUser: function(user){
            console.log("*****************************saving user");            
            
            try{
                
                var selectUserAndUpdate=function(tx){

                    tx.executeSql('SELECT * FROM UTILISATEUR WHERE identifiant=?', [user.identifiant], function(tx, results){
                        var len = results.rows.length;

                        if(len!=0){
                            tx.executeSql('UPDATE UTILISATEUR SET nom=?, prenom=?, photo=?, email=?, datenaissance=?, description=?, sexe=?, adresse=?, password=?, activerme=?, activerjob=?, annonceme=?, annoncejob=?, complementinformationsme=?, complementinformationsjob=?, pseudo=? WHERE identifiant=?', [user.nom, user.prenom, user.photo, user.email, app.utils.parseNaissance(user.datenaissance), user.description, user.sexe, user.adresse, user.motdepasse , user.activerme, user.activerjob, user.annonceme, user.annoncejob, user.complementinformationsme, user.complementinformationsjob , user.pseudo, user.identifiant]);
                        }
                        else{
                            tx.executeSql('INSERT INTO UTILISATEUR (identifiant, pseudo, nom, prenom, photo, email, datenaissance, description, sexe, adresse, password, activerme, activerjob, annonceme, annoncejob, complementinformationsme, complementinformationsjob) VALUES(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?, ?)', [user.identifiant , user.pseudo, user.nom, user.prenom, user.photo, user.email, app.utils.parseNaissance(user.datenaissance), user.description, user.sexe, user.adresse, user.motdepasse, user.activerme, user.activerjob, user.annonceme, user.annoncejob, user.complementinformationsme, user.complementinformationsjob]);

                        }

                    }, this.errorOnExecution);

                }

                this.dbref.transaction(selectUserAndUpdate, this.errorOnExecution);
            }
            catch(e){
                console.log(e);
            }            
            
        },
        // Supprime l'utilisateur de la BD
        deleteUser: function(identifiant){
            try{
                
                var delUser=function(tx){

                    tx.executeSql('DELETE FROM UTILISATEUR WHERE identifiant=?', [identifiant]);

                }

                this.dbref.transaction(delUser, this.errorOnExecution);
            }
            catch(e){
                console.log(e);
            }            
        },
        // recherche un utilisateur
        rechercherUser: function(identifiant, callback, errorcallback){
            var selectUser=function(tx){
                
                var user;

                tx.executeSql('SELECT * FROM UTILISATEUR WHERE identifiant=?', [identifiant], function(tx, results){
                    var len = results.rows.length;
                    if(len!=0){
                        user = {
                            identifiant: results.rows.item(0).identifiant,
                            nom: results.rows.item(0).nom,
                            prenom : results.rows.item(0).prenom,
                            photo : results.rows.item(0).photo,
                            email : results.rows.item(0).email,
                            pseudo: results.rows.item(0).pseudo,
                            sexe : results.rows.item(0).sexe,
                            datenaissance : results.rows.item(0).datenaissance,
                            password : results.rows.item(0).password,
                            description : results.rows.item(0).description,
                            adresse : results.rows.item(0).adresse,
                            activerme : results.rows.item(0).activerme ,
                            activerjob : results.rows.item(0).activerjob ,
                            annonceme : results.rows.item(0).annonceme ,
                            annoncejob : results.rows.item(0).annoncejob ,
                            complementinformationsme : results.rows.item(0).complementinformationsme ,
                            complementinformationsjob : results.rows.item(0).complementinformationsjob 
                        }

                        callback(user);
                    }
                    else{   // user not found
                        if ($.isFunction(errorcallback)){ //error callback passed as parameter
                            errorcallback();
                        }
                        else{   //error callback not passed as parameter, use the web search by default
                            app.services.rechercherUtilisateur(identifiant, callback);
                        }
                        
                    }

                    
                }, this.errorOnExecution);

            };
            
            this.dbref.transaction(selectUser, this.errorOnExecution);
        },
        rechercherUserParMail: function(email, callback, errorcallback){
            var selectUser=function(tx){
                
                var user;

                tx.executeSql('SELECT * FROM UTILISATEUR WHERE email=?', [email], function(tx, results){
                    var len = results.rows.length;
                    if(len!=0){
                        user = {
                            identifiant: results.rows.item(0).identifiant,
                            nom: results.rows.item(0).nom,
                            prenom : results.rows.item(0).prenom,
                            photo : results.rows.item(0).photo,
                            pseudo: results.rows.item(0).pseudo,
                            email : results.rows.item(0).email,
                            sexe : results.rows.item(0).sexe,
                            datenaissance : results.rows.item(0).datenaissance,
                            password : results.rows.item(0).password,
                            description : results.rows.item(0).description,
                            adresse : results.rows.item(0).adresse,
                            activerme : results.rows.item(0).activerme ,
                            activerjob : results.rows.item(0).activerjob ,
                            annonceme : results.rows.item(0).annonceme ,
                            annoncejob : results.rows.item(0).annoncejob ,
                            complementinformationsme : results.rows.item(0).complementinformationsme ,
                            complementinformationsjob : results.rows.item(0).complementinformationsjob 
                        }

                        callback(user);
                    }
                    else{   // user not found
                        if ($.isFunction(errorcallback)){ //error callback passed as parameter
                            errorcallback();
                        }
                        else{   //error callback not passed as parameter, use the web search by default
                            app.services.rechercherUtilisateurparEmail(email, callback);
                        }
                        
                    }

                    
                }, this.errorOnExecution);

            };
            
            this.dbref.transaction(selectUser, this.errorOnExecution);
        },
        //recherche les utilsateurs connectés surinternet
        rechercherUtilisateursOnNet: function(identifiant, callback){
            var selectUsersOnNet=function(tx){
                
                var users=[];
                
                tx.executeSql('SELECT * FROM UTILISATEUR WHERE identifiant != ? AND onnet = 1', [identifiant], function(tx, results){
                    try{
                        var len = results.rows.length;
                        
                        for (var i=0; i<len; i++){
                            users.push({ identifiant: results.rows.item(i).identifiant,
                                            nom: results.rows.item(i).nom,
                                            prenom: results.rows.item(i).prenom,
                                            pseudo: results.rows.item(i).pseudo,
                                            sexe: results.rows.item(i).sexe,
                                            photo: results.rows.item(i).photo,
                                            adresse: results.rows.item(i).adresse,
                                            onnet: results.rows.item(i).onnet}); 
                        }
                    }
                    catch(e){
                        console.log(e);
                    }
                    
                    callback(users);
                                        
                  
                }, this.errorOnExecution);

            }
            
            this.dbref.transaction(selectUsersOnNet, this.errorOnExecution);
        },
        //recherche les utilisateurs connectés en relation avec un autre utilisateur
        rechercherUtilisateursOnline: function(identifiant, callback){
            
            var selectUsersOnline=function(tx){
                
                var users=[];
                
                tx.executeSql('SELECT * FROM UTILISATEUR WHERE identifiant != ? AND online = 1', [identifiant], function(tx, results){
                //tx.executeSql('SELECT * FROM UTILISATEUR WHERE identifiant != ? AND onnet = 1', [identifiant], function(tx, results){
                    try{
                        var len = results.rows.length;
                        
                        for (var i=0; i<len; i++){
                            users.push({ identifiant: results.rows.item(i).identifiant,
                                            nom: results.rows.item(i).nom,
                                            pseudo: results.rows.item(i).pseudo,
                                            prenom: results.rows.item(i).prenom,
                                            favoris: results.rows.item(i).favoris,
                                            sexe: results.rows.item(i).sexe,
                                            datenaissance: results.rows.item(i).datenaissance,
                                            photo: results.rows.item(i).photo,
                                            adresse: results.rows.item(i).adresse,
                                            online: results.rows.item(i).online}); 
                        }
                    }
                    catch(e){
                        console.log(e);
                    }
                    
                    console.log("MeetoothLog----------------------------LOCALBD: recherche des users onlines ------ pour "+identifiant+"---------------"+JSON.stringify(users));
                    
                    callback(users);
                                        
                  
                }, this.errorOnExecution);

            }
            
            this.dbref.transaction(selectUsersOnline, this.errorOnExecution);
            
        },
        //recherche les utilisateurs connectés en relation avec un autre utilisateur
        rechercherUtilisateursOffline: function(identifiant, callback){
            
            var selectUsersOffline = function(tx){
                
                var users=[];
                var previoushour = new Date();
                previoushour.setHours(previoushour.getHours() - 1);
                
                tx.executeSql('SELECT * FROM UTILISATEUR WHERE identifiant != ? AND online = 0 AND lastactivity!=? AND (lastactivity BETWEEN ? AND ?)', [identifiant, null, previoushour, new Date()], function(tx, results){
                    try{
                        var len = results.rows.length;
                        
                        for (var i=0; i<len; i++){
                            
                            users.push({ identifiant: results.rows.item(i).identifiant,
                                            nom: results.rows.item(i).nom,
                                            prenom: results.rows.item(i).prenom,
                                            favoris: results.rows.item(i).favoris,
                                            sexe: results.rows.item(i).sexe,
                                            datenaissance: results.rows.item(i).datenaissance,
                                            photo: results.rows.item(i).photo,
                                            pseudo: results.rows.item(i).pseudo,
                                            adresse: results.rows.item(i).adresse,
                                            online: results.rows.item(i).online}); 
                        }
                    }
                    catch(e){
                        console.log(e);
                    }
                
                    callback(users);
                  
                }, this.errorOnExecution);

            }
            
            this.dbref.transaction(selectUsersOffline, this.errorOnExecution);
            
        },
        //recherche l'utilisateur dont on a l'adresse du mobile
        rechercherMobile: function(address, callback){
            //adresse, nomdevice, système, identifiant, nom, prenom, datenaissance, sexe, description, online
            var searchDeviceUser=function(tx){
                
                var user;
                
                tx.executeSql('SELECT * FROM UTILISATEUR WHERE adresse = ?', [address], function(tx, results){
                    try{
                        var len = results.rows.length;
                        
                        if(len>0){  // device trouve
                            
                            len-=1; // prend le dernier device
                            
                            user=   {   identifiant: results.rows.item(len).identifiant,
                                        pseudo: results.rows.item(len).pseudo,
                                        nomdevice: results.rows.item(len).nomdevice,
                                        systeme: results.rows.item(len).systeme,
                                        adresse: results.rows.item(len).adresse,
                                        nom: results.rows.item(len).nom,
                                        prenom: results.rows.item(len).prenom,
                                        sexe: results.rows.item(len).sexe,
                                        datenaissance: results.rows.item(len).datenaissance,
                                        photo: results.rows.item(len).photo,
                                        description: results.rows.item(len).description,
                                        activerme : results.rows.item(0).activerme ,
                                        activerjob : results.rows.item(0).activerjob ,
                                        annonceme : results.rows.item(0).annonceme ,
                                        annoncejob : results.rows.item(0).annoncejob ,
                                        complementinformationsme : results.rows.item(0).complementinformationsme ,
                                        complementinformationsjob : results.rows.item(0).complementinformationsjob,
                                        
                                        online: results.rows.item(len).online
                                    };
                                 
                            callback(user);
      
                        }
                        else{ // device non trouve
                            callback(0);
                            console.log("NOT found "+address)  ;  
                        }
                                                
                    }
                    catch(e){
                        console.log(e);
                    }
                
                    
                  
                }, this.errorOnExecution);

            }
            
            this.dbref.transaction(searchDeviceUser, this.errorOnExecution)
        },
        
        // Enregistre la description d'un utilisateur                        
        saveDescriptionUser: function(identifiant, description){
            try{
                
                var UpdateUser=function(tx){

                    tx.executeSql('UPDATE UTILISATEUR SET description=? WHERE identifiant=?', [description , identifiant]);

                }

                this.dbref.transaction(UpdateUser, this.errorOnExecution);
            }
            catch(e){
                console.log(e);
            }         
        },
        rechercherDescriptionUser: function(identifiant, callback){
            try{
                
                var UpdateUser=function(tx){

                    tx.executeSql('SELECT description FROM UTILISATEUR WHERE identifiant=?', [identifiant], function(tx, results){
                        var len = results.rows.length;

                        if(len != 0){
                            
                            callback(results.rows.item(0).description);
                        }
                        
                    }, this.errorOnExecution);
                }

                this.dbref.transaction(UpdateUser, this.errorOnExecution);
            }
            catch(e){
                console.log(e);
            }         
        },
        //Met a jour la photo de l'utilisateur
        changerPhotoUtilisateur: function(identifiant, urlphoto){
            try{
                
                var UpdateUser=function(tx){

                    tx.executeSql('UPDATE UTILISATEUR SET photo=? WHERE identifiant=?', [urlphoto , identifiant]);

                }

                this.dbref.transaction(UpdateUser, this.errorOnExecution);
            }
            catch(e){
                console.log(e);
            }     
        },
        saveFavoris: function(identifiant, data){
            try{
                        
                var updateFavoris = function(tx){
                    for (var id in data){
                        tx.executeSql('DELETE FROM FAVORIS WHERE (iduser = ? and iduserfavoris = ?) OR (iduser = ? and iduserfavoris = ?)', [identifiant, data[id].username, data[id].username, identifiant], function(tx, results){

                            tx.executeSql('INSERT INTO FAVORIS(iduser, iduserfavoris) VALUES ( ?, ?)', [identifiant, data[id].username]);

                        }, this.errorOnExecution);
                                            
                    }                 
                    
                }
                
                this.dbref.transaction(updateFavoris, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        rechercherFavoris : function(identifiant, callback){
            var selectFavoris=function(tx){
                
                    var favoris=[];

                    tx.executeSql('SELECT * FROM FAVORIS WHERE (iduser=?) OR (iduserfavoris=? ) ', [identifiant, identifiant], function(tx, results){
                        var len = results.rows.length;
                        
                        for (var i=0; i<len; i++){
                            if(results.rows.item(i).iduserfavoris==identifiant){
                                favoris.push({ username: results.rows.item(i).iduser});
                            }
                            else{
                                favoris.push({ username: results.rows.item(i).iduserfavoris });
                            }
                            
                        }
                        
                        if($.isFunction(callback)){
                            callback(favoris);
                        }
                        
                    }, this.errorOnExecution);

                };
                
                this.dbref.transaction(selectFavoris, this.errorOnExecution);
        },
        deleteFavoris: function(identifiant, identifiant2){
            try{
                        
                var deleteFavoris = function(tx){
                    
                        tx.executeSql('DELETE FROM FAVORIS WHERE (iduser = ? and iduserfavoris = ?) OR (iduser = ? and iduserfavoris = ?)', [identifiant, identifiant2, identifiant2, identifiant], function(tx, results){
                        }, this.errorOnExecution);
                  
                }
                
                this.dbref.transaction(deleteFavoris, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        // Locally save a message
        saveMessage: function(sender, message, read, receiver){
            console.log("******************************************saving message from "+sender.id+" to "+receiver);            
            try{
                var populateMsg=function(tx){
                    tx.executeSql('INSERT INTO MESSAGE (contenu, dateenvoie, datelecture, notification, iduseremetteur, pseudoemetteur, photoemetteur, iduserrecepteur) '+
                        'VALUES ("'+message+'", "'+new Date()+'",'+null+', '+read+',"'+ sender.id+'","'+ sender.pseudo+'","'+sender.photo+'","'+ receiver+'")')
                    
                };
                
                var messageSaved = function(){
                    console.log("message enregistré: "+message);
                };
                
                this.dbref.transaction(populateMsg, this.errorOnExecution, messageSaved);
            }
            catch(e){
                console.log(e);
                
            }
        },
        // retreive the saved messages
        rechercherMessagesNonlus: function(callback, identifiantcontact){
            
            var selectMsgDb;
            
            if(identifiantcontact!==undefined){
                // recupérer tous les messages non lus de cet utilisateur
                selectMsgDb=function(tx){
                
                    var messages=[];

                    tx.executeSql('SELECT * FROM MESSAGE WHERE notification=0 AND iduserrecepteur=? and iduseremetteur=? ORDER BY dateenvoie ASC', [app.user.get("identifiant"), identifiantcontact], function(tx, results){
                        var len = results.rows.length;

                        for (var i=0; i<len; i++){

                            messages.push({ contenu: results.rows.item(i).contenu,
                                            dateenvoie: results.rows.item(i).dateenvoie,
                                            notification: results.rows.item(i).notification,
                                            idemetteur: results.rows.item(i).iduseremetteur,
                                            pseudoemetteur: results.rows.item(i).pseudoemetteur,
                                            photoemetteur: results.rows.item(i).photoemetteur,
                                            idrecepteur: results.rows.item(i).iduserrecepteur
                            }); 
                            
                        }

                        callback(messages);
                    }, this.errorOnExecution);

                    tx.executeSql('UPDATE MESSAGE SET notification=1, datelecture="'+new Date()+'" WHERE iduserrecepteur=? and iduseremetteur=?', [app.user.get("identifiant"), identifiantcontact]);

                }
            }
            else{
                // recupérer tous les messages non lus tout simplement
                selectMsgDb=function(tx){
                
                    var messages=[];

                    tx.executeSql('SELECT * FROM MESSAGE WHERE notification=0 AND iduserrecepteur=? ORDER BY dateenvoie ASC', [app.user.get("identifiant")], function(tx, results){
                        var len = results.rows.length;

                        for (var i=0; i<len; i++){
                            // add this message to the data set
                            messages.push({ contenu: results.rows.item(i).contenu,
                                            dateenvoie: results.rows.item(i).dateenvoie,
                                            notification: results.rows.item(i).notification,
                                            idemetteur: results.rows.item(i).iduseremetteur,
                                            pseudoemetteur: results.rows.item(i).pseudoemetteur,
                                            photoemetteur: results.rows.item(i).photoemetteur,
                                            idrecepteur: results.rows.item(i).iduserrecepteur
                            }); 
                            
                        }

                        callback(messages);
                    }, this.errorOnExecution);

                    tx.executeSql('UPDATE MESSAGE SET notification=1, datelecture="'+new Date()+'" WHERE iduserrecepteur=?', [app.user.get("identifiant")]);

                }
            }
            try{                
                
                this.dbref.transaction(selectMsgDb, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
            
        },
        // Recherche tous les messages d'un utilisateur vers celui en cours
        rechercherMessages: function(callback, identifiantcontact, nombre){
            var selectMsgDb;
            
            if(identifiantcontact!==undefined){
                // recupérer tous les messages non lus de cet utilisateur
                selectMsgDb=function(tx){
                
                    var messages=[];

                    tx.executeSql('SELECT * FROM MESSAGE WHERE (iduserrecepteur=? and iduseremetteur=?) OR (iduserrecepteur=? and iduseremetteur=?) ORDER BY dateenvoie ASC', [app.user.get("identifiant"), identifiantcontact, identifiantcontact, app.user.get("identifiant")], function(tx, results){
                        var len = results.rows.length;
                        
                        for (var i=0; i<len; i++){

                            messages.push({ contenu: results.rows.item(i).contenu,
                                            dateenvoie: results.rows.item(i).dateenvoie,
                                            notification: results.rows.item(i).notification,
                                            idemetteur: results.rows.item(i).iduseremetteur,
                                            pseudoemetteur: results.rows.item(i).pseudoemetteur,
                                            photoemetteur: results.rows.item(i).photoemetteur,
                                            idrecepteur: results.rows.item(i).iduserrecepteur
                            }); 

                        }
                            
                        if(nombre!==undefined){
                            
                            if(nombre < len){
                                // prend les  #nombre derniers messages
                                messages = messages.slice((-1 * nombre));
                            }
                        }
                                                

                        callback(messages);
                    }, this.errorOnExecution);

                    tx.executeSql('UPDATE MESSAGE SET notification=1, datelecture="'+new Date()+'" WHERE iduserrecepteur=? and iduseremetteur=?', [app.user.get("identifiant"), identifiantcontact]);

                }
            }
            else{
                // recupérer tous les messages non lus tout simplement
                selectMsgDb=function(tx){
                
                    var messages=[];

                    tx.executeSql('SELECT * FROM MESSAGE WHERE iduserrecepteur = ? or iduseremetteur=? ORDER BY dateenvoie ASC', [app.user.get("identifiant"), app.user.get("identifiant")], function(tx, results){
                        var len = results.rows.length;

                        for (var i=0; i<len; i++){
                            // add this message to the data set
                            messages.push({ contenu: results.rows.item(i).contenu,
                                            dateenvoie: results.rows.item(i).dateenvoie,
                                            notification: results.rows.item(i).notification,
                                            idemetteur: results.rows.item(i).iduseremetteur,
                                            pseudoemetteur: results.rows.item(i).pseudoemetteur,
                                            photoemetteur: results.rows.item(i).photoemetteur,
                                            idrecepteur: results.rows.item(i).iduserrecepteur
                            }); 
                            
                        }
                        
                        if(nombre!==undefined){
                            
                            if(nombre < len){
                                // prend les  #nombre derniers messages
                                messages = messages.slice((-1 * nombre));
                            }
                        }

                        callback(messages);
                    }, this.errorOnExecution);

                    tx.executeSql('UPDATE MESSAGE SET notification=1, datelecture="'+new Date()+'" WHERE iduserrecepteur=?', [app.user.get("identifiant")]);

                }
            }
            
            try{
                
                this.dbref.transaction(selectMsgDb, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        savedevicesDiscovered: function(devices){
            console.log("*****************************saving devices");
            try{
                var populatNewDevices=function(tx){
                    
                    tx.executeSql('DELETE FROM DEVICEFOUND WHERE 1', [], function(){console.log("emptied table device found");}, this.errorOnExecution);
                    
                    for(var device in devices){
                        tx.executeSql('INSERT INTO DEVICEFOUND (adresse, nom, systeme) VALUES ("'+device.address+'", "'+device.name+'","'+ device.address+'")', []);
                    }

                }

                this.dbref.transaction(populatNewDevices,this.errorOnExecution);
            }
            catch(e){
                console.log("*********************ERROR*****************************"+e);
            }
            
        },
        // enregistre dans la BD les question de la FAQ
        updateQuestions: function(questions){
            
            try{
                var populateQuestions=function(tx){
                    
                    tx.executeSql('DELETE FROM FAQ WHERE 1', []);
                    
                    for(var idq in questions){
                        tx.executeSql('INSERT INTO FAQ (id, libelle, reponse) VALUES ('+questions[idq].id+', "'+questions[idq].libelle+'","'+ questions[idq].reponse+'")', [], function(){console.log("done");}, this.errorOnExecution);
                    }

                }

                this.dbref.transaction(populateQuestions,this.errorOnExecution);
            }
            catch(e){
                console.log("**************************************************"+e);
            }
            
        },
        // rechercher les question de la FAQ
        rechercherQuestions: function(callback){
            try{
                            
                var selectQuestions = function(tx){

                    var questions=[];

                    tx.executeSql('SELECT * FROM FAQ', [], function(tx, results){

                        var len = results.rows.length;

                        for (var i=0; i<len; i++){

                            questions.push({ id: results.rows.item(i).id,
                                            libelle: results.rows.item(i).libelle,
                                            reponse: results.rows.item(i).reponse
                            });                    
                        }

                        callback(questions);
                    }, this.errorOnExecution);
                    
                }
                
                this.dbref.transaction(selectQuestions, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        }, 
        // rechercher une question
        rechercherQuestion: function(idquestion, callback){
            
            try{
                            
                var selectQuestion = function(tx){

                    var question=[];

                    tx.executeSql('SELECT * FROM FAQ WHERE id=?', [idquestion], function(tx, results){

                        var len = results.rows.length;

                        for (var i=0; i<len; i++){

                            question={ id: results.rows.item(i).id,
                                            libelle: results.rows.item(i).libelle,
                                            reponse: results.rows.item(i).reponse

                            };                    
                        }

                        callback(question);
                    }, this.errorOnExecution);
                    
                }
                
                this.dbref.transaction(selectQuestion, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
            
        },
        rechercherAllEvenementsUser: function(identifiant, callback){
            
            try{
                            
                var selectEventsDb = function(tx){

                    var events=[];

                    tx.executeSql('SELECT DISTINCT idevt, nom, lieu, date, detail, couleur, participe, nbparticipants FROM EVENEMENT WHERE identifiant=?', [identifiant], function(tx, results){

                        var len = results.rows.length;

                        for (var i=0; i<len; i++){

                            events.push({   id: results.rows.item(i).idevt,
                                            nom: results.rows.item(i).nom,
                                            lieu: results.rows.item(i).lieu,
                                            date: results.rows.item(i).date,
                                            detail: results.rows.item(i).detail,
                                            couleur: results.rows.item(i).couleur,
                                            participe: results.rows.item(i).participe,
                                            nbparticipants: results.rows.item(i).nbparticipants
                            });                    
                        }

                        callback(events);
                    }, this.errorOnExecution);
                    
                }
                
                this.dbref.transaction(selectEventsDb, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        listEvents: function(identifiant, callback){
                        
            try{
                            
                var selectEventsDb = function(tx){

                    var notifs=[];

                    tx.executeSql('SELECT * FROM NOTIFICATION WHERE type="event" AND idrecepteur=? AND read=?', [identifiant, 0], function(tx, results){

                        var len = results.rows.length;

                        for (var i=0; i<len; i++){

                            notifs.push({ id: results.rows.item(i).id,
                                            type: results.rows.item(i).type,
                                            idevent: results.rows.item(i).idevent

                            });                    
                        }

                        callback(notifs);
                    }, this.errorOnExecution);
                    tx.executeSql('UPDATE NOTIFICATION SET read=? WHERE type="event" AND idrecepteur=?', [1,identifiant]);

                }
                
                this.dbref.transaction(selectEventsDb, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
            
             
        },
        saveEvents: function(evenements, identifiant){
            try{
                
                var populateEvents=function(tx){
                        
                        try{
                            for(var id in evenements){   
                                tx.executeSql('SELECT * FROM EVENEMENT WHERE idevt=? AND identifiant=?', [evenements[id].id, identifiant], function(tx, results){
                                    var len = results.rows.length;
                                    if(len!=0){
                                        
                                        tx.executeSql('UPDATE EVENEMENT SET nom = ?, lieu = ?, nbparticipants = ?, date = ?,couleur = ?, detail = ?, participe=? WHERE id = ?', [evenements[id].nom,evenements[id].lieu, evenements[id].nbparticipants, evenements[id].date, evenements[id].couleur, evenements[id].detail, evenements[id].participe, evenements[id].id]);
                                    }
                                    else{
                                        tx.executeSql('INSERT INTO EVENEMENT (idevt, nom, lieu, nbparticipants, date, couleur, identifiant, detail, participe) VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?)', [evenements[id].id, evenements[id].nom, evenements[id].lieu, evenements[id].nbparticipants, evenements[id].date, evenements[id].couleur, identifiant, evenements[id].detail, evenements[id].participe]);
                                    }

                                }, this.errorOnExecution);
                    
                                
                            }
                        }
                        catch(e){
                            console.log("error="+e);
                        }
                        
                    }
                    
                    this.dbref.transaction(populateEvents,this.errorOnExecution);
                
                
            }
            catch(e){
                console.log(e);
                console.log(e);
            }            
            
        },
        // enregistre les evenements auquels participe un utilisateur
        saveEventsUser: function (identifiant, evenements){
            try{
                
                var populateEvents=function(tx){
                        
                        try{
                            for(var id in evenements){   
                                tx.executeSql('SELECT * FROM EVENEMENT WHERE idevt=? AND identifiant=?', [evenements[id].id, identifiant], function(tx, results){
                                    var len = results.rows.length;
                                    
                                    if(len!=0){
                                        
                                        tx.executeSql('UPDATE EVENEMENT SET lieu = ?, date = ?, couleur = ?, detail = ?, participe=? WHERE id = ?', [evenements[id].lieu ,evenements[id].date, evenements[id].couleur,evenements[id].detail, 1, evenements[id].id]);
                                    }
                                    else{
                                        tx.executeSql('INSERT INTO EVENEMENT (idevt, lieu, date, couleur, identifiant, detail, participe) VALUES(?, ?, ?, ?, ?, ?, ?)', [evenements[id].id , evenements[id].lieu, evenements[id].date, evenements[id].couleur, identifiant, evenements[id].detail, 1]);
                                    }

                                }, this.errorOnExecution);
                    
                                
                            }
                        }
                        catch(e){
                            console.log("error="+e);
                        }
                        
                    }
                    
                    this.dbref.transaction(populateEvents,this.errorOnExecution);
                
                
            }
            catch(e){
                console.log(e);
                console.log(e);
            }
        },
        //recherche un évenement en local
        rechercherEvenement: function(idevt, callback){
            var selectEvt=function(tx){
               
                tx.executeSql('SELECT * FROM EVENEMENT WHERE idevt=?', [idevt], function(tx, results){
                    var len = results.rows.length;
                    if( len !=0){                                                
                        callback({id:
                            results.rows.item(len - 1).idevt,
                            lieu:results.rows.item(len - 1).lieu,
                            date:results.rows.item(len - 1).date,
                            detail:results.rows.item(len - 1).detail,
                            couleur:results.rows.item(len - 1).couleur
                        });
                        
                    }
                    
                }, this.errorOnExecution);

            }
            
            this.dbref.transaction(selectEvt, this.errorOnExecution);
        },
        //recherche les événements auquel a choisi de participer un utilisateur
        rechercherEvenementsUtilisateur: function(identifiant, callback){
            var selectEvt=function(tx){
               
                tx.executeSql('SELECT * FROM EVENEMENT WHERE identifiant=? AND participe=1', [identifiant], function(tx, results){
                    var len = results.rows.length;
                    var evts=[];
                    for (var i=0; i<len; i++){                                              
                        evts.push({id:
                            results.rows.item(i).idevt,
                            lieu:results.rows.item(i).lieu,
                            date:results.rows.item(i).date,
                            detail:results.rows.item(i).detail,
                            couleur:results.rows.item(i).couleur
                        });
                        
                    }
                    
                    callback(evts);
                    
                }, this.errorOnExecution);
            }
            
            this.dbref.transaction(selectEvt, this.errorOnExecution);
            
        },
        //enregistrer la participation dun utilisateur à un evt
        saveParticipationEvent : function(identifiant, idevent){
            try{
                var saveattend=function(tx){
                    
                    tx.executeSql('UPDATE EVENEMENT SET participe=1 WHERE identifiant=? and idevt=?', [ identifiant, idevent]);                
                }
            
                this.dbref.transaction(saveattend, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        
        //annuler la participation dun utilisateur à un evt
        cancelParticipationEvent : function(identifiant, idevent){
            try{
                var cancelattend=function(tx){
                    
                    tx.executeSql('UPDATE EVENEMENT SET participe=0 WHERE identifiant=? and idevt=?', [ identifiant, idevent]);                
                }
            
                this.dbref.transaction(cancelattend, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        // sauvegarder les critères d'événements d'un utilisateur
        saveCriteresEventsUser: function(identifiant, data){
            
            try{
                            
                var updateCriteria = function(tx){

                    tx.executeSql('DELETE FROM * FROM CRITEREEVT WHERE identifiant=?', [identifiant]);
                    
                    for (var id=0 in data){

                        tx.executeSql('INSERT INTO CRITEREEVT (idcritere, identifiant,  nomcritere, valeur) '+
                        'VALUES ("'+data[id].id+'", "'+identifiant+'","'+data[id].nom+'","'+data[id].valeur+'")');

                    }

                };
                
                this.dbref.transaction(updateCriteria, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        // rechercher les critères d'événements d'un utilisateur
        rechercherCriteresEventsUser : function(identifiant, callback){
                        
            try{
                            
                var selectCriterias = function(tx){

                    var criteres=[];

                    tx.executeSql('SELECT * FROM CRITEREEVT WHERE identifiant=?', [identifiant], function(tx, results){

                        var len = results.rows.length;

                        for (var i=0; i<len; i++){

                            criteres.push({    id: results.rows.item(i).idcritere,
                                                nom: results.rows.item(i).nomcritere,
                                                valeur: results.rows.item(i).valeur
                            });                    
                        }

                        callback(criteres);
                    }, this.errorOnExecution);
                    
                }
                
                this.dbref.transaction(selectCriterias, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        // rechercher tous les critères d'événements
        rechercherCriteresEvent: function(callback){
                        
            try{
                            
                var selectCriterias = function(tx){

                    var criteres=[];

                    tx.executeSql('SELECT DISTINCT idcritere, nomcritere FROM CRITEREEVT WHERE identifiant=?', [], function(tx, results){

                        var len = results.rows.length;

                        for (var i=0; i<len; i++){

                            criteres.push({    id: results.rows.item(i).idcritere,
                                                nom: results.rows.item(i).nomcritere
                            });                    
                        }

                        callback(criteres);
                    }, this.errorOnExecution);
                    
                }
                
                this.dbref.transaction(selectCriterias, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        //rechercher la compatibilité entre deux utilisateurs
        rechercherCompatibilite: function(user1, user2, callback){
            var selectCompatibilite=function(tx){
               
                tx.executeSql('SELECT * FROM COMPATIBILITE WHERE (user1=? and user2=?) OR (user1=? and user2=?)', [user1, user2, user2, user1], function(tx, results){
                    
                    if(results.rows.length !=0){                                                
                        callback(results.rows.item(0).valeur);
                    }
                    
                }, this.errorOnExecution);

            }
            
            this.dbref.transaction(selectCompatibilite, this.errorOnExecution);
        },
        // définir la compatibilité entre deux utilisateurs
        SaveCompatibilite: function(user1, user2, valeur){
            
            try{
                
                var UpdateCompatibilite=function(tx){
                    tx.executeSql('SELECT * FROM COMPATIBILITE WHERE ((user1=? and user2=?) OR (user1=? and user2=?))', [user1, user2, user2, user1], function(tx, results){
                        var len = results.rows.length;
                        if(len!=0){
                            tx.executeSql('UPDATE COMPATIBILITE SET valeur=? WHERE ((user1=? and user2=?) OR (user1=? and user2=?))', [valeur, user1, user2, user2, user1]);
                        }
                        else{
                            tx.executeSql('INSERT INTO COMPATIBILITE (user1, user2, valeur) VALUES(?,?,?)', [user1, user2, valeur]);
                        }

                    }, this.errorOnExecution);
                
                }

                this.dbref.transaction(UpdateCompatibilite, this.errorOnExecution);
            }
            catch(e){
                console.log(e);
            }
            
        },
        // sauvegarder les critères d'événements d'un utilisateur
        saveCriteresCompUser: function(identifiant, data){
            
            try{
                            
                var selectCriteria = function(tx){

                    tx.executeSql('DELETE FROM * FROM CRITERECOMP WHERE identifiant=?', [identifiant]);
                    var id;
                    for (id=0; id < data.length; id++){

                        tx.executeSql('INSERT INTO CRITERECOMP (idcritere, identifiant,  nomcritere, valeur) '+
                        'VALUES ("'+data[id].id+'", "'+identifiant+'","'+data[id].nom+'","'+data[id].valeur+'")');

                    }

                };
                
                this.dbref.transaction(selectCriteria, this.errorOnExecution);
                
            }
            catch(e){
                console.log("Meetooth-Error: saveCriteresCompUser "+e);
            }
        },
        // rechercher les critères d'événements d'un utilisateur
        rechercherCriteresCompUser : function(identifiant, callback){
                        
            try{
                            
                var selectCriterias = function(tx){

                    var criteres=[];

                    tx.executeSql('SELECT * FROM CRITERECOMP WHERE identifiant=?', [identifiant], function(tx, results){

                        var len = results.rows.length;

                        for (var i=0; i<len; i++){

                            criteres.push({    id: results.rows.item(i).idcritere,
                                                nom: results.rows.item(i).nomcritere,
                                                valeur: results.rows.item(i).valeur
                            });                    
                        }

                        callback(criteres);
                        console.log("criteres trouvés= "+JSON.stringify(criteres));
                    }, this.errorOnExecution);
                    
                }
                
                this.dbref.transaction(selectCriterias, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        // rechercher les critères d'événements d'un utilisateur
        rechercherCriteresComp : function(callback){
                        
            try{
                            
                var selectCriterias = function(tx){

                    var criteres=[];

                    tx.executeSql('SELECT DISTINCT idcritere, nomcritere FROM CRITERECOMP', [], function(tx, results){

                        var len = results.rows.length;

                        for (var i=0; i<len; i++){

                            criteres.push({    id: results.rows.item(i).idcritere,
                                                nom: results.rows.item(i).nomcritere
                            });                    
                        }

                        callback(criteres);
                    }, this.errorOnExecution);
                    
                }
                
                this.dbref.transaction(selectCriterias, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        // Locally save a message
        saveMeets: function(meets, identifiant){
            
            try{
                var populateMeets=function(tx){
                    
                    for(var id in meets){
                        tx.executeSql('INSERT INTO MEET (dateenvoie, idemetteur,  pseudoemetteur, photoemetteur, idrecepteur, notification) '+
                        'VALUES ("'+meets[id].dateenvoie+'", "'+meets[id].idemetteur+'","'+meets[id].pseudoemetteur+'","'+meets[id].photoemetteur+'","'+identifiant+'",0)');
                    }
                    
                };

                this.dbref.transaction(populateMeets, this.errorOnExecution);
            }
            catch(e){
                console.log(e);
                
            }
        },
        
        rechercherMeets: function(identifiant, callback){
            
            try{
                            
                var selectMeets = function(tx){

                    var meets=[];

                    tx.executeSql('SELECT * FROM MEET WHERE idrecepteur=? ORDER BY dateenvoie ASC', [identifiant], function(tx, results){

                        var len = results.rows.length;

                        for (var i=0; i<len; i++){

                            meets.push({    idemetteur: results.rows.item(i).idemetteur,
                                            pseudoemetteur: results.rows.item(i).pseudoemetteur,
                                            photoemetteur: results.rows.item(i).photoemetteur,
                                            dateenvoie: results.rows.item(i).dateenvoie,
                                            notification: results.rows.item(i).notification
                            });                    
                        }
                        console.log("MEETS=="+JSON.stringify(meets));
                        callback(meets);
                    }, this.errorOnExecution);
                    
                    tx.executeSql('UPDATE MEET SET notification=1', []);

                }
                
                this.dbref.transaction(selectMeets, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
            
        },
        // Rechercher les meets non encore lus
        rechercherMeetsNonLus: function(identifiant, callback){
            try{
                            
                var selectMeets = function(tx){

                    var meets=[];

                    tx.executeSql('SELECT * FROM MEET WHERE idrecepteur=? and notification=?', [identifiant, 0], function(tx, results){

                        var len = results.rows.length;

                        for (var i=0; i<len; i++){

                            meets.push({    idemetteur: results.rows.item(i).idemetteur,
                                            pseudoemetteur: results.rows.item(i).pseudoemetteur,
                                            photoemetteur: results.rows.item(i).photoemetteur,
                                            dateenvoie: results.rows.item(i).dateenvoie,
                                            notification: results.rows.item(i).notification
                            });                    
                        }

                        callback(meets);
                    }, this.errorOnExecution);
                    
                    tx.executeSql('UPDATE MEET SET notification=1', []);

                }
                
                this.dbref.transaction(selectMeets, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
        },
        
        saveNotification: function(identifiant, callback){
            
            try{
                            
                var selectMeets = function(tx){

                    var meets=[];

                    tx.executeSql('SELECT * FROM MEET WHERE idrecepteur=?', [identifiant], function(tx, results){

                        var len = results.rows.length;

                        for (var i=0; i<len; i++){

                            meets.push({    idemetteur: results.rows.item(i).idemetteur,
                                            pseudoemetteur: results.rows.item(i).pseudoemetteur,
                                            dateenvoie: results.rows.item(i).dateenvoie,
                                            notification: results.rows.item(i).notification
                            });                    
                        }

                        callback(meets);
                    }, this.errorOnExecution);
                    
                    tx.executeSql('UPDATE MEET SET notification=1', []);

                };
                
                this.dbref.transaction(selectMeets, this.errorOnExecution);
                
            }
            catch(e){
                console.log(e);
            }
            // prends les meets, 
            // puis mets tous ces meets à lu
        }
        
        
    }
    

    /*
        Function: getUrlVars

        Extrait les paramètres passés vie une url.

        Parameters:

           url - Url dont on doit extraire les paramètres. Si non renseignée, c'est l'URL fournie par le navigateur web qui est utilisée
           
        Returns:

           Tableau associatif comprenant pour chacun des paramètres de l'url, la valeur correspondante

     */
    function getUrlVars(url) {
        var vars = [], hash, hashes;
        
        if(typeof url === 'undefined'){
            url=window.location.href;
        }
        
        hashes= url.slice(url.indexOf('?') + 1).split('&');
        
        for(var i = 0; i < hashes.length; i++)
        {
            hash = hashes[i].split('=');
            vars.push(hash[0]);
            vars[hash[0]] = hash[1];
        }
        return vars;
    }
 
    
    
    $(document).delegate('.ui-page', 'pagebeforeshow', function () {
        var page=$("body").pagecontainer("getActivePage").attr("id");
        
        var menudroite=$("#menudroit>div>ul");
        
//        Construction du menu de gauche
        if(menudroite.length!==0){
            menudroite.find("li").remove(":nth-child(n+2)");
            
            menudroite.append(
                '<li data-role="collapsible" data-inset="false" data-iconpos="right" data-collapsed-icon="gear" data-expanded-icon="carat-u">'+
                    '<h2>Paramètres </h2>'+
                    '<ul data-role="listview">'+
                        '<li data-icon="false"><a href="profil-personnel.html" >Mon profil <i class="fa fa-user icon-list"></i></a></li>'+
                        '<li data-icon="false">'+
                            '<a href="desinscription.html" >Me désinscrire '+
                                '<span class="fa-lg icon-list">'+
                                    '<i class="fa fa-user "></i>'+
                                    '<i class="fa fa-ban fa-stack-1x text-danger color-red"></i>'+
                                '</span>'+
                            '</a>'+
                        '</li>'+
                        (app.parametres.formule_premium==0?'<li data-icon="false">'+
                            '<a href="abonnement.html" >Formule premium '+
                                '<i class="fa fa-certificate icon-list"></i>'+
                            '</a>'+
                        '</li>':'')+
//                            '<li data-icon="false"><a href="annonces.html" >Mes annonces<i class="fa fa-unlock-alt icon-list"></i></a></li>'+

                        '<li data-icon="false"><a href="changepassword.html" >Changer de mot de passe<i class="fa fa-unlock-alt icon-list"></i></a></li>'+
                    '</ul>'+
                '</li>'+
                '<li data-role="collapsible" data-inset="false" data-iconpos="right" data-collapsed-icon="calendar" data-expanded-icon="carat-u">'+
                    '<h2>Evènements </h2>'+
                    '<ul data-role="listview">'+
                        '<li data-icon="false"><a href="evenements.html?identifiant='+app.user.get("identifiant")+'&pseudo='+app.user.get("pseudo")+'">Mes participations <i class="fa fa-calendar icon-list"></i></a></li>'+
                        '<li data-icon="false">'+
                            '<a href="allevenements.html" >A venir <i class="fa fa-ticket icon-list"></i></a>'+
                        '</li>'+
//                            
                    '</ul>'+
                '</li>'+
                '<li data-icon="false"><a href="meets.html">Meets <i class="fa fa-heart icon-list"></i></a></li>'+

                '<li data-icon="false"><a href="dialogue.html">Messages <i class="fa fa-comments icon-list"></i></a></li>'+

                '<li data-icon="false"><a href="appareils.html">Mobiles <span class="icon-list"><i class="fa fa-tablet"></i> /  <i class="fa fa-mobile-phone"></i></span></a></li>'+
                '<li data-role="collapsible" data-inset="false" data-iconpos="right" data-collapsed-icon="grid" data-expanded-icon="carat-u">'+
                    '<h2>Plus </h2>'+
                    '<ul data-role="listview">'+
                        '<li data-icon="false"><a href="conditionsutilisation.html" > C.G.U <i class="fa fa-globe icon-list"></i></a></li>'+

                        '<li data-icon="power"><a href="" id="deconnexion" >Quitter</a></li>'+
                    '</ul>'+
                '</li>'
                );
            
            // affiche le nombre de notifications sur le bouton de menu
            app.utils.updateMenuButton();
            
            menudroite.enhanceWithin();
            menudroite.listview("refresh");
            $("#menudroit").panel();
            $("#menudroit" ).trigger( "updatelayout" );
        }
        
    });
    
    
    $( document ).on( "pageshow", "#parametrepage", function() {
        
        var devicename=decodeURIComponent(getUrlVars()["devicename"]);
        var address=decodeURIComponent(getUrlVars()["address"]);
        $("#peripherique").val(devicename);
        $("#adresse").val(address);
        $("#pseudo").val(devicename);
        
        $("#pseudo").focus();
    });
    
    $( document ).on( "pageshow", "#indexpage", function(event) {
        
        try{
            if(app.parametres.getRememberme()===true){
                
                var login = app.user.get("identifiant");
                
                app.utils.showloader("Connexion...");
                
                // rechercher les infos sur l'utilisateur
                app.services.rechercherUtilisateurConnexion (login, function(user){
                    if(user){
                        console.log("2210 id="+login);
                        app.user.set({ identifiant: login, photo: user.photo, pseudo: user.pseudo, nom: user.nom, prenom: user.prenom, mail: user.email, password: user.motdepasse, naissance: app.utils.parseNaissance(user.datenaissance), description: user.description, sexe: user.sexe});
                        
                        //Appel des fonction de chargement des données là
                        app.utils.loadPeriodicalDataAtConnection(login);
                                                
                        $( ":mobile-pagecontainer" ).pagecontainer( "change", "accueil.html", { reload: false, showLoadMsg: true, changeHash:true } );

                    }
                    else{
                        app.utils.alert("Compte utilisateur non activé","Meetooth - Connexion");
                    }

                    
                    app.utils.hideloader();
                });
                
                //clear the history
                app.clearHistory();

            }
            else{
                setTimeout(function () {
                    $( ":mobile-pagecontainer" ).pagecontainer( "change", "login.html", { reload: false, reverse: false, showLoadMsg: false} );
                    
                }, 500); 

            }
        }
        catch(e){
            console.log(e);
        }
        
                
        event.preventDefault();
        event.stopPropagation();
    });
     
    $(document).on('click','#loginbtn', function(event) { 
         app.parametres.modeconnexion="meetooth";
    });
     
    $(document).on('tap','#facebookloginbtn', function(event) { 
        app.parametres.modeconnexion="facebook";
        
        app.utils.confirm("Nous ne publierons aucune donnée sur Facebook",function(){
            // si c'est connecté, je continue en bas
            var connexionFacebook=function(result){
                //La connexion s'est bien passée
                app.utils.showloader("Synchronisation...");
                // je recherche lutilisateur meetooth correspondant
                facebookConnectPlugin.api("me/?fields=id,email", ["email"],
                    function (fbuser){
                        app.services.rechercherUtilisateurparEmail(fbuser.email, function(user){ 
                            if(user){// si je le vois je le connecte
                                console.log("2293 id="+user.identifiant);
                                app.user.set({ identifiant: user.identifiant, photo: user.photo, nom: user.nom, prenom: user.prenom, mail: user.email, password: user.motdepasse, naissance: app.utils.parseNaissance(user.datenaissance), description: user.description, sexe: user.sexe});
                                
                                app.utils.loadPeriodicalDataAtConnection(user.identifiant);
                                
                                
                                $( ":mobile-pagecontainer" ).pagecontainer( "change", "accueil.html", { reload: false, showLoadMsg: true, changeHash:true } );

                                app.utils.hideloader();
                            }
                            else{ //sinon je lui dis de s'inscrire à l'application, je le redirige vers la page d'inscription
                                var message="";

                                $("#formlogin fieldset p.error").remove();

                                app.parametres.nbloginrestant -= 1;

                                switch(app.parametres.nbloginrestant){
                                    case 0: message='Param&egrave;tres incorrects, service bloqué';
                                            $( "#formlogin button" ).prop( "disabled", true ).toggleClass( "ui-state-disabled", true );
                                            break;
                                    case 1: message='Param&egrave;tres incorrects, dernier essai';
                                            break;
                                    default: message='Param&egrave;tres incorrects, '+app.parametres.nbloginrestant+' tentatives';

                                }
                                $("#formlogin fieldset").prepend('<p class="error">'+message+'</p>');
                            }
                        });                    
                    },
                    function (error) {
                        console.log("Failed: " + error);
                    }
                );
            };

            var connexionFacebookFailed= function(result){
                console.log("Facebook connexion failed "+JSON.stringify(result));
            };

            facebookConnectPlugin.login(["email"], connexionFacebook, connexionFacebookFailed);
        }, 'Connexion => Facebook');
        
    });
     
     
     $(document).on('submit','#formlogin', function(event) { 
            
        event.preventDefault();
        event.stopPropagation();
        //event.stopImmediatePropagation();
        
        var validerformulaire=function(){
            $("#formlogin fieldset p.error").remove();
            var result=true;
            
            var message="champs requis";
            
            $("#formlogin input").each(function(){
                if($(this).val()==""){
                    result=false;
                }
                
            });
            
            if(! app.utils.validerEmail($("#email").val())){
                result=false;
                message= "Email invalide";
            }
            if(!result){
                $("#formlogin fieldset p.error").remove();
                $("#formlogin fieldset").prepend('<p class="error">'+message+'</p>');
            }
            return result;
        }


        if(validerformulaire()){ // Le formulaire est valide, on peut lancer la connexion

            if(app.parametres.nbloginrestant>0){

                var rememberme=$("#formlogin input[name='remember-me']").is(':checked')?true:false;

                var login=$("#email").val();
                var pass=$("#pwd").val();

                app.utils.showloader("Connexion...");
                
                //appele le service de connexion
                app.services.connexionUtilisateur(login, pass, rememberme, function(res){

                    if(res.error!=0){ // s'il ya une erreur
                        // called if not good user
                        var message="";

                        $("#pwd").val("");
                        $("#formlogin fieldset p.error").remove();

                        switch(app.parametres.nbloginrestant){
                            case 0: message='Identifiants incorrects, service bloqué';
                                    $( "#formlogin button" ).prop( "disabled", true ).toggleClass( "ui-state-disabled", true );
                                    break;
                            case 1: message='Identifiants incorrects, dernier essai';
                                    break;
                            default: message='Identifiants incorrects, '+app.parametres.nbloginrestant+' tentatives';

                        }
                        $("#formlogin fieldset").prepend('<p class="error">'+message+'</p>');
                    }

                });

            }
            else{
                $("#formlogin fieldset p.error").remove();
                $("#formlogin fieldset").prepend('<p class="error">Application bloquée car 3 essais infructueux</p>');
            }

        }

    });

    
    $( document ).on( "pagebeforeshow", "#inscriptionpage", function(event) {
        
        
        try{
            
            app.services.listerCriteresCompatibilite( function(criteres){
                
                if(criteres){
                    var table=$("#forminscription .view3 table tbody").empty();

                    $.each(criteres, function(index,critere){
                        
                        table.append('<tr>'+
                            '<td>'+critere.nom+'</td>'+
                            '<td>'+
                                '<fieldset data-role="controlgroup" data-type="horizontal" data-mini="true">'+
                                    '<input name="cri'+critere.id+'" id="cri'+critere.id+'-1" value="1" type="radio">'+
                                    '<label for="cri'+critere.id+'-1">'+
                                        '<i class="fa fa-frown-o"></i>'+
                                    '</label>'+
                                    '<input name="cri'+critere.id+'" id="cri'+critere.id+'-2" value="2" checked type="radio">'+
                                    '<label for="cri'+critere.id+'-2"><i class="fa fa-meh-o"></i></label>'+
                                    '<input name="cri'+critere.id+'" id="cri'+critere.id+'-3" value="3"  type="radio">'+
                                    '<label for="cri'+critere.id+'-3"><i class="fa fa-smile-o"></i></label>'+
                                '</fieldset>'+
                            '</td>'+
                        '</tr>');
                    });
                    $("#forminscription .view3 table").enhanceWithin();
                }
                else{
                    $("#forminscription .view3").html("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucun sujet d'intérêt à vous proposer </span></div>");
                }
            });
                    
            
            app.services.listerCriteresEvenements(function(criteres){
                var area=$("#criteres-evt").empty();
                if(criteres.length>0){
                    
                    
                    $.each(criteres, function(index,critere){
                        area.append('<input type="checkbox" id="crievt-'+critere.id+'" checked><label for="crievt-'+critere.id+'">'+critere.nom+'</label>');
                    });
                    
                }
                else{
                    area.html("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucun intérêt d'événement à vous proposer </span></div>");
                }
                
                area.enhanceWithin();
            });
        }
        catch(e){
            $("#forminscription").replaceWith("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucune information trouvée sur vous! </span></div>")
        }
        

        // affichage des critères 
        $( document ).on( "change", "#forminscription input[name='infoevenement']", function(event) {
            event.preventDefault();
            event.stopPropagation();
            if($(this).val()==0){
                $("#criteres-evt").hide();
                $("#infoevenement2").parent().find("label").addClass("ui-last-child");
            }
            else if($(this).val()==1){
                $("#criteres-evt").show();
                $("#infoevenement2").parent().find("label").removeClass("ui-last-child");
            }
        });
        
    });
    
    
    // Go back button on the registration form
    $( document ).on( "click", "#forminscription a.back", function(event) {
        event.preventDefault();
        event.stopPropagation();

        // get the current viex id
        var view=$("#forminscription input[name='currentview']").val();

        // parse it to an integer
        try{
            view=parseInt(view);
        }
        catch (e){
            view=1;
        }

        // make ui changes depending on the view
        switch(view){

            case 2: $("#forminscription >.view2, #forminscription >.view3, #forminscription >.view4").hide(0);
                    $("#forminscription >.view1").show(1);
                    $("#forminscription input[name='currentview']").val(1);
                    $("#inscriptionpage>.ui-header>span").html(1);
                    $("#forminscription  fieldset.buttons a.back").addClass("ui-disabled");
                    break;
            case 3: $("#forminscription >.view1, #forminscription >.view3, #forminscription >.view4").hide(0);
                    $("#forminscription >.view2").show(1);
                    $("#forminscription input[name='currentview']").val(2);
                    $("#inscriptionpage>.ui-header>span").html(2);
                    break;
            case 4: $("#forminscription >.view1, #forminscription >.view2, #forminscription >.view4").hide();
                    $("#forminscription >.view3").show();
                    $("#forminscription input[name='currentview']").val(3);
                    $("#inscriptionpage>.ui-header>span").html(3);
                    $("#forminscription fieldset.buttons button").text("Suiv.");
                    $("#forminscription .icons fieldset.buttons button").text("");
                    $("#forminscription fieldset.buttons button").buttonMarkup({icon: "arrow-r"});
                    break;
            default:break;

        }
    });
    
    // Lancement du pop up de selection de la date
    $( document ).on( "focus", "#naissance", function(event) {
        event.preventDefault();
        event.stopPropagation();
                
        var currentfield=$(this);
        
        var oldDate= currentfield.val();
        
        var myNewDate;
        
        if(currentfield.val()){
            var parts=currentfield.val().split("-");
            myNewDate=new Date(parts[2], parts[1]-1, parts[0]);
        }
        else{
            myNewDate=new Date();
        }
                
        try{
            var options = {
                date: myNewDate,
                maxdate: new Date(),
                mode: 'date'
            };
            
            // Lance le plugin datePicker
            datePicker.show(options, function(date){
                // si la date contient le mot invalide; alors elle est invalide.
                //Sinon on entre dans ce si
                
                if(date!="Invalid Date"){
                    var newDate = new Date(date);
                    //Met à jour le champ date
                    currentfield.val((newDate.getDate()<10?('0'+newDate.getDate()):newDate.getDate())+'-'+((newDate.getMonth()+1)<10?('0'+(newDate.getMonth()+1)):(newDate.getMonth()+1))+'-'+newDate.getFullYear());

                }
                else{
                    currentfield.val(oldDate);
                }
                
                currentfield.blur();
                
            });
                        
        }
        catch(exception){
            console.log("error occured: "+exception);
        }
        
    });


    //Ecoute du clic sur le lien du type d'upload de photo
    $( document ).on( "click", "#popupChooseTypeImage a", function(event) {
                
        // if the camera API is registered, get the from to from the gallery with it
        if(navigator.camera){
            
            var sourcetype="";
            
            if($(this).attr("id")=="camera-chooser"){ // cliqué sur prendre une photo
                sourcetype=navigator.camera.PictureSourceType.CAMERA;
            }
            else if($(this).attr("id")=="gallery-chooser"){ //cliqué sur selectionner la photo
                sourcetype=navigator.camera.PictureSourceType.PHOTOLIBRARY;
            }
        
            var loadPhoto= function(imageURI){
                $("form input[name='imageURI']").val(imageURI);
                $("form >.row >.photouser >.photobox>img").attr("src", imageURI);
                
            }
            
            var errorLoad=function(error){
                app.utils.showInfoMessage("Impossible de charger la photo");
                console.log("Error while loading the photo: "+error);
            }
            
            navigator.camera.getPicture(loadPhoto, errorLoad,{
                        quality: 50,
                        correctOrientation: true,
                        destinationType: navigator.camera.DestinationType.FILE_URI,
                        sourceType: sourcetype,
                        targetWidth: 200,
                        targetHeight: 240
                }
            );
        }
        else{
            app.utils.showInfoMessage("Propriété non supportée par votre mobile");
        }
                
    });
    
    $( document ).on( "submit", "#forminscription", function(event) {
        
            event.preventDefault();
            event.stopPropagation();
            // get the current view id
            var view=$("#forminscription input[name='currentview']").val();
            var message="";
            $("#forminscription p.error").html("");
            
            var validerformulaire=function(idvue){
                var result=true;
                if(idvue==1){
                    message="";
                    
                    if($("#forminscription #nom").val()==""){
                        $("#forminscription #nom").parent().parent().find("label").css("color", "red");
                        result=false;
                        message+="Nom obligatoire<br/>";
                    }
                    else{
                        $("#forminscription #nom").parent().parent().find("label").css("color", "inherit");
                    }
                    
                    if($("#forminscription #prenom").val()==""){
                        $("#forminscription #prenom").parent().parent().find("label").css("color", "red");
                        result=false;
                        message+="Prénom obligatoire<br/>";
                    }
                    else{
                        $("#forminscription #prenom").parent().parent().find("label").css("color", "inherit");
                    }
                    
                    if($("#naissance").val()==''){
                        message+="Date de naissance obligatoire<br/>";
                        result=false;
                        $("#forminscription #naissance").parent().parent().find("label").css("color", "red");
                    }
                    else{
                        if(! app.utils.validerDate($("#naissance").val())){
                            result=false;
                            message+="Date de naissance invalide<br/>";
                            $("#naissance").parent().parent().find("label").css("color", "red");
                        }
                        else{
                            if(app.utils.calculerAge($("#naissance").val())<18){
                                result=false;
                                message+="Age minimum requis: 18 ans <br/>";
                                $("#naissance").parent().parent().find("label").css("color", "red");
                            }
                            else{
                                $("#naissance").parent().parent().find("label").css("color", "inherit");
                            }
                        } 
                    }
                                        
                }

                else if(idvue==2){
                    message="";
                    
                    if($("#email").val()==''){
                        result=false;
                        $("#email").parent().parent().find("label").css("color", "red");
                        message+="Email obligatoire<br/>";
                    }
                    else if(! app.utils.validerEmail($("#email").val())){
                        result=false;
                        $("#email").parent().parent().find("label").css("color", "red");
                        message+="Email invalide<br/>";
                    }
                    else{
                        $("#email").parent().parent().find("label").css("color", "inherit");
                    } 
                    
                    if($("#identifiant").val()==''){
                        result=false;
                        $("#identifiant").parent().parent().find("label").css("color", "red");
                        message+="Identifiant obligatoire<br/>";
                    }
                    else if(! app.utils.validerIdentifiant($("#identifiant").val())){
                            result=false;
                            $("#identifiant").parent().parent().find("label").css("color", "red");
                            message+="Caractères spéciaux non autorisés dans l'identifiant<br/>";

                    }
                    else{
                        $("#forminscription #identifiant").parent().parent().find("label").css("color", "inherit");
                    } 
                                        
                    if($("#password").val()=='' || $("#password2").val()==''){
                        if($("#password").val()==''){
                            message+="Mot de passe obligatoire<br/>";
                            result=false;
                            $("#password").parent().parent().find("label").css("color", "red");
                        }
                        else{
                            $("#password").parent().parent().find("label").css("color", "inherit");
                        }
                        
                        if($("#password2").val()==''){
                            message+="confirmation mot de passe obligatoire<br/>";
                            result=false; 
                            $("#password2").parent().parent().find("label").css("color", "red");
                        }  
                        else{
                            $("#password2").parent().parent().find("label").css("color", "inherit");
                        }
                    }
                    else{
                        if($("#password").val()!=$("#password2").val()){
                            result=false;
                            message+="Veuillez saisir des mots de passe identiques<br/>";
                            $("#password, #password2").parent().parent().find("label").css("color", "red");
                        }
                        else{
                            $("#password, #password2").parent().parent().find("label").css("color", "inherit");
                        }
                    }
                    
                    
                    if($("#pseudo").val()==''){
                        result=false;
                        $("#pseudo").parent().parent().find("label").css("color", "red");
                        message+="Pseudo obligatoire<br/>";
                    }
                    else if(! app.utils.validerPseudo($("#pseudo").val())){
                            result=false;
                            $("#pseudo").parent().parent().find("label").css("color", "red");
                            message+="Caractères spéciaux non autorisés dans le pseudo<br/>";
                    }
                    else{
                        $("#forminscription #pseudo").parent().parent().find("label").css("color", "inherit");
                    } 
                    
                    
                    if($("#forminscription #description").val()==""){
                        $("#forminscription #description").parent().find("label").css("color", "red");
                        result=false;
                        message+="Description obligatoire<br/>";
                    }
                    else{
                        $("#forminscription #description").parent().find("label").css("color", "inherit");
                    }
                    
                    if(result==false)
                        $("#forminscription p.error").html(message);
                    
                }
                else if(idvue==3 || idvue==4){
                    result=true;
                }
                
                if(result){
                    $("#forminscription p.error").html("");
                }
                else{
                    $("#forminscription p.error").html(message);
                }
                return result;
            };

            try{
                view=parseInt(view);
            }
            catch (e){
                view=1;
            }

            switch(view){
                case 1: if(validerformulaire(1)){
                            $("#forminscription >.view1, #forminscription >.view3, #forminscription >.view4").hide();
                            $("#forminscription >.view2").show();
                            $("#forminscription input[name='currentview']").val(2);
                            $("#inscriptionpage>.ui-header>span").html(2);
                            $("#forminscription  fieldset.buttons a.back").removeClass("ui-disabled");
                        }
                        break;

                case 2: if(validerformulaire(2)){
                            $("#forminscription >.view1, #forminscription >.view2, #forminscription >.view4").hide();
                            $("#forminscription >.view3").show();
                            $("#forminscription input[name='currentview']").val(3);
                            $("#inscriptionpage>.ui-header>span").html(3);
                        }
                        break;
                case 3: if(validerformulaire(3)){
                            $("#forminscription >.view1, #forminscription >.view2, #forminscription >.view3").hide(0);
                            $("#forminscription >.view4").show(1);
                            $("#forminscription input[name='currentview']").val(4);
                            $("#inscriptionpage>.ui-header>span").html(4);
                            $("#forminscription fieldset.buttons button").text("Valid.");
                            $("#forminscription .icons fieldset.buttons button").text("");
                            $("#forminscription fieldset.buttons button").buttonMarkup({icon: "check"});
                        }
                        break;
                case 4: //Dernière étape, il faut envoyer le formulaire
                        if(validerformulaire(4)){
                            
                            app.utils.showloader("Inscription...");
                            
                            var criteresevt=$("#forminscription input[name='infoevenement']:checked").val();
                            var criteres=[], criterescomp=[];

                            if(criteresevt==0){
                                $("#criteres-evt input[type='checkbox']").attr('checked', true);                            
                            }
                            
                            var id="";
                            // critères évenements
                            $("#criteres-evt input[type='checkbox']").each(function(){
                                id=$(this).attr("id");
                                
                                id=id.substring(7);
                                
                                if($(this).is(':checked')){
                                    criteres.push(""+id+":1");
                                    
                                }
                                else{

                                    criteres.push(""+id+":2");
                                }
                                
                            });
                            
                            // criteres compatibilités                            
                            $("#forminscription .view3 table input[type='radio']:checked").each(function(){
                                id=$(this).attr("id");
                                
                                id=id.substring(3, id.length-2);
                                
                                criterescomp.push(""+id+":"+$(this).val());

                            });

                                                        
                            if(criterescomp.join(",")==""){
                                criterescomp="-";
                            }
                            else{
                                criterescomp=criterescomp.join(",");
                            }
                            
                            if(criteres.join(",")==""){
                                criteres="-";
                            }
                            else{
                                criteres=criteres.join(",");
                            }
                            
                            var parametre={
                                nom: encodeURIComponent($("#forminscription input[name='nom']").val()),
                                prenom: encodeURIComponent($("#forminscription input[name='prenom']").val()),
                                mail: encodeURIComponent($("#forminscription input[name='email']").val()),                                
                                sexe: $("#forminscription #sexe").val(),
                                naissance: encodeURIComponent($("#forminscription input[name='naissance']").val()),
                                pseudo: encodeURIComponent($("#forminscription input[name='pseudo']").val()),
                                password: encodeURIComponent($("#forminscription input[name='password']").val()),                    
                                description: encodeURIComponent($("#forminscription textarea[name='description']").val()),
                                criterescomp: encodeURIComponent(criterescomp),
                                criteresevt: encodeURIComponent(criteres),
                                temoinevt: encodeURIComponent($("#forminscription input[name='infoevenement']:checked").val()),
                                identifiant: encodeURIComponent($("#forminscription input[name='identifiant']").val())
                            };
                            
                            app.services.inscriptionUtilisateur(parametre.nom, parametre.prenom, parametre.identifiant, parametre.mail, parametre.sexe, parametre.naissance, parametre.pseudo,parametre.password, parametre.description, parametre.criterescomp, parametre.temoinevt, parametre.criteresevt, function(res){
                                
                                if(res===1){// Connexion automatique
                                    
                                    //upload the photo file of the just registered user
                                    var imageURI=$("#forminscription input[name='imageURI']").val();
                                    
                                    //Si l'utilisateur a changé sa photo, uploade la nouvelle photo
                                    if(imageURI!=""){
                                        
                                        app.utils.showInfoMessage("Envoi de la photo...");

                                        app.utils.showloader("Envoi de la photo...");

                                        app.services.changerPhotoUtilisateur(imageURI, decodeURIComponent(parametre.identifiant), function(){
                                            
                                            //Change de page, retour à l'accueil
                                            app.utils.showloader("Photo envoyée!\n Authentification...");
                                            
                                            // Auto-connect the user
                                            app.services.connexionUtilisateur(parametre.mail, parametre.password, false, function(res){
                                                if(res.error!=0){
                                                    app.utils.showInfoMessage("Erreur, connexion impossible");
                                                    
                                                }

                                            });
                                            
                                            app.utils.alert("Inscription validée!\nBienvenue "+decodeURIComponent(parametre.pseudo),"Meetooth - Inscription");                                            
                                        });
                                    }
                                    else{
                                        app.utils.showloader("Authentification...");
                                        // Auto-connect the user
                                        app.services.connexionUtilisateur($("#forminscription input[name='email']").val(),$("#forminscription input[name='password']").val(), false, function(res){
                                            app.utils.hideloader();
                                            if(res.error!=0){
                                                app.utils.showInfoMessage("Erreur, connexion impossible");
                                            }

                                        });
                                        app.utils.alert("Inscription validée !\n Bienvenue, "+decodeURIComponent(parametre.pseudo),"Meetooth - Inscription");
                                    }
                                                                        
                                }
                                else{
                                    
                                    app.utils.alert("Echec de l'inscription","Meetooth - Inscription");
                                    app.utils.hideloader();
                                    if (res===2){ //erreur
                                        app.utils.showInfoMessage("Erreur, pseudo déjà enregistrée");
                                        $("p.error").html("Pseudo déjà enregistré");
                                    }
                                    else if (res===3){ //erreur
                                        app.utils.showInfoMessage("Erreur, adresse mail déjà enregistrée");
                                        $("p.error").html("Email déjà enregistré");
                                    }
                                    else if(res===5){
                                        app.utils.showInfoMessage("Erreur, identifiant déjà enregistré");
                                        $("p.error").html("Identifiant déjà enregistré");
                                    }
                                    else{ //erreur
                                        app.utils.showInfoMessage("Erreur lors de la création de l'utilisateur");
                                        $("p.error").html("Erreur lors de la création de l'utilisateur");
                                    }
                                }
                                
                            });
                        } 
                        break;
                default:$("#forminscription >.view2, #forminscription >.view3, #forminscription >.view4").hide(0);
                        $("#forminscription >.view1").show(1);
                        $("#forminscription input[name='currentview']").val(1);
                        $("#inscriptionpage>.ui-header>span").html("1");
                        $("#inscriptionpage fieldset.buttons>button").html(">>");

            }
        }); 

    // Deconnexion d'un utilisateur
    $(document).on('tap','#deconnexion',function (event){
        event.preventDefault();
        event.stopPropagation();
        
        var link=$("#deconnexion");
        
        link.removeClass ("ui-icon-power");
        link.addClass ("ui-icon-loader-mee");
        app.utils.showloader("Déconnexion...");
        
        app.services.deconnexionUtilisateur(app.user.get("mail"), function(){
            link.removeClass ("ui-icon-loader-mee");
            link.addClass ("ui-icon-power");
            app.utils.hideloader();
        });
         
        
    });
        
        
    $(document).on("change","#formprofilperso input[name='annonce']", function(){ // On change of radio buttons
        
        if ($(this).val()=="no") {
            $('#personnonceinfo').hide();
            $('#jobannonceinfo').hide();
        }
        else if($(this).val()=="perso"){
            $('#jobannonceinfo').hide();
            $('#personnonceinfo').show();

        }
        else if($(this).val()=="job"){
            $('#jobannonceinfo').show();
            $('#personnonceinfo').hide();
        }
    });
    
        
    //Controle 1er affichage page d'accueil'
    $( document ).on( "pageshow", "#accueilpage", function() {

        var tabs = '<div data-role="tabs" id="tabs" data-corner="false" class="separated">'+
                    '<div data-role="navbar" >'+
                      '<ul>'+
                        '<li><a href="#userconnecte" data-ajax="false" class="ui-btn-active">Connect&eacute;s</a></li>'+                        
                        '<li><a href="#manque" data-ajax="false">Manqu&eacute;s</a></li>'+
                        
                      '</ul>'+
                    '</div>'+
                    
                    '<div id="userconnecte" class="userstab">'+
                        '<div class="loader"> '+
                            '<img src="images/ajax-loader-spinner.gif" />'+
                        '</div>'+
                    '</div>'+
                    
                    '<div id="manque" class="userstab">'+
                        '<div class="loader"> '+
                            '<img src="images/ajax-loader-spinner.gif" />'+
                        '</div>'+
                        
                    '</div>'+
                '</div>';
        $("#accueilpage>div.ui-content").html(tabs);
        $("#accueilpage>div.ui-content").enhanceWithin();
        
        // rechercher les users en local. sil nya pas, allors rechercher en ligne, sinon laisser le process continuer
        var updateUsers=function(){
                      
            app.services.rechercherUtilisateurOnline(app.user.get("identifiant"), function(contacts){
                
                var onlines=$("#userconnecte").empty();                    
                 
                if(contacts.length == 0){
                    onlines.append(
                        '<div class="row" style="height: 40px">'+
                            '<span class="icon-list text"><i class="fa fa-users color-green"></i> Qui est en ligne?<span><img src="images/pointsloader.GIF"/>'+
                        '</div>');
                }
                else{
                    $.each(contacts, function(index, contact){
                        
                        // la contact  n'a pas de photo, alors on met la photo par défaut
                        if(! contact.photo || (contact.photo.lastIndexOf("/") > contact.photo.lastIndexOf("."))){
                            contact.photo="images/default.jpg";
                        }
                        
                        contact.favoris = app.utils.estFavoris(contact.identifiant);

                        onlines.append(
                            '<div class="row userswipe">'+
                                '<a href="profil-utilisateur.html?pseudo='+contact.pseudo+'&identifiant='+contact.identifiant+'&photo='+encodeURI(contact.photo) +'">'+
                                    '<div class="photouser">'+
                                        '<img src="'+contact.photo+'" class="photo-small"/>'+
                                        '<div class="nom '+(contact.sexe=='M'?'homme':'femme')+'"><span>'+contact.pseudo+'</span><span>'+app.utils.calculerAge(contact.datenaissance)+' ans</span></div>'+
                                    '</div>'+
                                '</a>'+

                                '<div class="icons list">'+
                                    '<a href="#" id="favoris-'+contact.identifiant+'" '+ (contact.favoris===true? 'class="favorislink"':'')+'>'+
                                        '<i class="fa fa-star fa-2x '+ (contact.favoris===true? 'colour-favoris':'colour-nonfavoris')+'" ></i>'+
                                    '</a>'+

                                    '<a href="#" id="chatbtn-'+contact.identifiant+'" class="chatbtn">'+
                                        'Discuter'+                                 
                                    '</a>'+

                                    '<a href="compatibilites.html?pseudo='+contact.pseudo+'&identifiant='+contact.identifiant+'&photo='+encodeURI(contact.photo) +'" class="compatbtn">'+
                                        '<div class="compat-'+contact.identifiant+'">'+
                                            '<div class="loader">'+
                                                '<img src="images/ajax-loader-spinner.gif" />'+
                                            '</div>'+
                                        '</div>'+
                                    '</a>'+

                                    '<div>'+
                                        '<i class="connected fa fa-circle"></i>'+
                                    '</div>'+
                               ' </div>'+
                            '</div>');

                        app.services.calculerCompatibilite( contact.identifiant, function(res){
                            onlines.find("div.compat-"+contact.identifiant).html((res>=0? (res+"%"):'-'));
                            //Ordonne les lignes par ordre croisssant
                            
                            $('#userconnecte div.row.userswipe').sortElements(function(a, b){

                                if($(a).find("div.compat-"+contact.identifiant).length ==0 ){
                                    return 1;
                                }
                                else if($(b).find("div.compat-"+contact.identifiant).length ==0){
                                    return -1;
                                }
                                else{
                                    return $(a).find("div.compat-"+contact.identifiant).html().split("%")[0] < $(b).find("div.compat-"+contact.identifiant).html().split("%")[0] ? 1 : -1;
                                }

                            });
                            
                        });
                    });
                }
                

            });
            
            accessDB.rechercherUtilisateursOffline(app.user.get("identifiant"), function(contacts){
                var missed=$("#manque").empty();
                
                if(contacts.length == 0){
                    missed.append(
                        '<div class="row" style="height: 40px">'+
                            '<span class="icon-list text"><i class="fa fa-users color-green"></i> Aucun ami en ligne récemment<span><img src="images/pointsloader.GIF"/>'+
                        '</div>');
                }
                else{
                    $.each(contacts, function(index, contact){
                    
                        if(! contact.photo || (contact.photo.lastIndexOf("/") > contact.photo.lastIndexOf("."))){
                            contact.photo="images/default.jpg";
                        }

                        contact.favoris = app.utils.estFavoris(contact.identifiant);

                        missed.append(
                            '<div class="row userswipe">'+
                                '<div class="photouser">'+
                                    '<img src="'+contact.photo+'" class="photo-small"/>'+
                                        '<div class="nom '+(contact.sexe=='M'?'homme':'femme')+'"><span>'+contact.pseudo+'</span><span>'+app.utils.calculerAge(contact.datenaissance)+' ans</span></div>'+
                                '</div>'+
                                '<div class="icons list">'+
                                    '<a href="#" id="favoris-'+contact.identifiant+'">'+
                                        '<i class="fa '+ (contact.favoris===true? 'fa-star fa-2x colour-favoris':'')+'" ></i>'+
                                    '</a>'+

                                    '<div>'+
                                        '<img class="image" src="images/empty.png"/>'+
                                    '</div>'+
                                    '<div>'+                                
                                        '<img class="image" src="images/empty.png"/>'+
                                    '</div>'+
                                    '<div>'+
                                        '<i class="disconnected fa fa-circle"></i>'+
                                    '</div>'+
                               ' </div>'+
                            '</div>');

                    });
                }
                

            });
        }
        // recherche les utilisateurs en ligne et met à jour la liste affichée
        updateUsers();
        
        app.parametres.evtcheckonlineusers=setInterval(updateUsers, app.parametres.timerinterval);
    });
    
    $( document ).on( "pagehide", "#accueilpage", function() {
        clearInterval(app.parametres.evtcheckonlineusers);
    });
    
     $( document ).on( "pageshow", "#appareilspage", function() {
        
        if(! localbluetooth.plugin){
            $('#devicelist').replaceWith("<div class='message-blocs'><img src='images/bluetooth-delete.png'/><span>Appareil incompatible </span></div>");
            
        }
        else{
            var ul= $('#devicelist').empty();
            
            ul.html("<li data-role='list-divider'>Récemment trouv&eacute;<span class='ui-li-count'>"+localbluetooth.devicesDiscovered.length+"</span></li>");
            
            for (var index in localbluetooth.devicesDiscovered){
                ul.append(  "<li><a href='viewdevice.html?devicename="+encodeURIComponent(localbluetooth.devicesDiscovered[index].name)+"&address="+encodeURIComponent(localbluetooth.devicesDiscovered[index].address)+"'>"+
                                    "<h2>"+localbluetooth.devicesDiscovered[index].name+"</h2>"+
                                    "</p>"+localbluetooth.devicesDiscovered[index].address+"</p>"+
                                "</a>"+
                            "</li>");
            }
            
            ul.listview("refresh");
            
            if(localbluetooth.isDiscovering){
                // Call back executed when a device is discovered
                $('#loaderbtn').buttonMarkup({ icon: "loader-mee", iconpos: "right" });
                
            }
                        
            $( document ).on( "click", "#loaderbtn", function() {
                // SI le gars est entrain de rechercher des periphériques on arrete tout ca
                
                if(localbluetooth.isDiscovering){
                    app.utils.showInfoMessage("Recherche des périphériques suspendue!");
                    localbluetooth.stopDiscovery();
                }
                else{                    
                    localbluetooth.startDiscovery();
                }
            });
        }
            
    });
    
    $( document ).on( "pagebeforechange", "#appareilspage", function() {
        
        if(localbluetooth.plugin && localbluetooth.isDiscovering){
            
            localbluetooth.stopDiscovery();
                
        }
            
    });
    
    $( document ).on( "pageshow", "#dialoguepage", function() {
        
        var messages = $('#discussion .conversations');
        
        var identifiantcontact = getUrlVars()["id"];
        
        var photocontact = "images/default.jpg",
        
        photouser = app.user.get("photo");
        
        if(!photouser || (photouser.lastIndexOf("/") > photouser.lastIndexOf("."))){
            photouser="images/default.jpg";
        }
                
        if(identifiantcontact){ // identifiant contact fourni
            
            var adresseContact; 
            
            // La connexion se passe bien
            var connectSuccess = function(){
                //enable the button
                $( "#formdiscussion textarea, #formdiscussion button" ).prop( "disabled", false );
                $( "#formdiscussion textarea, #formdiscussion button" ).removeClass("ui-state-disabled"); 

                $("#formdiscussion button>i").removeClass("fa-exclamation-triangle color-red");                        
                $("#formdiscussion button>i").addClass("fa-paper-plane-o");
                $('#formdiscussion textarea').focus();

            }

            // La connexion se passe mal
            var connectError = function(){
                
                $( "#formdiscussion textarea, #formdiscussion button" ).prop( "disabled", true );

                $("#formdiscussion button>i").removeClass("fa-paper-plane-o");
                $("#formdiscussion button>i").addClass("fa-exclamation-triangle color-red");
                var messages = $("#discussion div.conversations");

                messages.append(" <i class='fa fa-exclamation-triangle color-red'></i> Echec de la connexion");
                
                messages.append(" <button class='ui-btn ui-corner-all ui-icon-recycle ui-btn-icon-right'>Réessayer</button>");
            }
                        
             // le gars veut voir les messages d'un contact et discuter avec lui
            accessDB.rechercherUser(identifiantcontact, function(user){
                
                adresseContact = user.adresse;
                
                // lance la connexion à ce contact là
                localbluetooth.connect(adresseContact, connectSuccess,connectError);

                if(user.pseudo){
                    $("#dialoguepage> .ui-header >span").html(user.pseudo); 
                }
                
                accessDB.rechercherMessages(app.utils.addMessagesToUI, identifiantcontact, 20);
                 
            },
            function(){

                var messages=$("#discussion div.conversations");
                messages.html(" <i class='fa fa-exclamation-triangle color-red'></i> Utilisateur indisponible");
                
                messages.append(" <button class='ui-corner-all ui-btn ui-icon-recycle ui-btn-icon-right'>Réessayer</button>");
                
                $( "#formdiscussion textarea, #formdiscussion button" ).prop("disabled", true );

                $( "#formdiscussion textarea, #formdiscussion button" ).addClass("ui-state-disabled"); 

                $("#formdiscussion button>i").removeClass("fa-paper-plane-o");
                
                $("#formdiscussion button>i").addClass("fa-exclamation-triangle color-red");
            });
                      
        }
        else{   // Identifiant contact non fourni
            
            // sans utilisateur précis
            // trying to look unseen messages
             
            accessDB.rechercherMessagesNonlus(app.utils.addMessagesToUI);
            
            localbluetooth.ifIsConnected(function(){
                    $( "#formdiscussion textarea, #formdiscussion button" ).prop( "disabled", false );

                    $( "#formdiscussion textarea, #formdiscussion button" ).removeClass("ui-state-disabled"); 

                    $("#formdiscussion button>i").removeClass("fa-exclamation-triangle color-red");                        
                    $("#formdiscussion button>i").addClass("fa-paper-plane-o");
                    $('#formdiscussion textarea').focus();
                }, 
                function(){
                    $( "#formdiscussion textarea, #formdiscussion button" ).prop( "disabled", true );

                    $("#formdiscussion button>i").removeClass("fa-paper-plane-o");
                    $("#formdiscussion button>i").addClass("fa-exclamation-triangle color-red");
            });
            
            $('#discussion .conversations .message-left .photo img').attr("src", photouser);
            
            $('#discussion .conversations .message-right .photo img').attr("src", photocontact);
        }
        
        //scroll jusqu'en bas de la page
        if($("div.message-left:last").length!=0){
            var last_msg = $("div.message-left:last").offset().top;
            setTimeout(function () {
                $.mobile.silentScroll(last_msg);
            }, 50);
        }
        
    });
    
    $( "#discussion a.recherchermsgrecents" ).off("click").on( "click",function(event) {
        event.preventDefault();
        event.stopPropagation();
        event.stopImmediatePropagation();
        var identifiantcontact=getUrlVars()["id"];

        $("#discussion div.conversations").prepend('<div class="loader"> <img src="images/ajax-loader-spinner.gif" class="loader"></div>');

        $("#discussion>div.toplink >a.recherchermsgrecents i").replaceWith('<img src="images/ajax-loader-circle.gif"/>');

        accessDB.rechercherMessages(app.utils.addMessagesToUI, identifiantcontact);
        
        var photocontact = "images/default.jpg", photouser = app.user.get("photo");
        
        if(photouser || (photouser.lastIndexOf("/") > photouser.lastIndexOf("."))){
            photouser="images/default.jpg";
        }
        
        $('#discussion .conversations .message-left .photo img').attr("src", photouser);
            
        $('#discussion .conversations .message-right .photo img').attr("src", photocontact);
    });
                    
     //send the form on key type event
    $("#formdiscussion textarea").keyup(function(e){
        var code = (e.keyCode ? e.keyCode : e.which);
        if(code == 13) { //Enter keycode, submit the form
          $('#formdiscussion').trigger('submit');
        }
    });

    $(document).on('submit','#formdiscussion', function(event) {
        event.preventDefault();
        event.stopPropagation();
        var identifiantcontact=getUrlVars()["id"];
                
        var area=$('#formdiscussion textarea');

        var texte=area.val().trim();

        if(texte){
            var messages=$("#discussion div.conversations");

            area.val('');

            area.focus();
            
            var photouser = app.user.get("photo");
        
            if(! photouser || (photouser.lastIndexOf("/") > photouser.lastIndexOf("."))){
                photouser="images/default.jpg";
            }

            var onMessageSent=function(){

                messages.append('<div class="message-left">'+
                                    '<div class="current-user">'+
                                            '<div class="photo vcentered">'+
                                                '<img src="'+photouser+'"/>'+
                                                '<div class="nom '+(app.user.get("sexe")=='M'?'homme': 'femme')+'">Moi</div>'+
                                            '</div>'+

                                            '<i class="connected fa fa-circle vcentered"></i> '+                       
                                    '</div>'+

                                    '<div class="message-content">'+
                                        '<div class="bubble-content">'+
                                            '<div class="bubble">'+
                                                '<span class="contenu">'+
                                                    texte+ ' <i class="fa fa-check" style="font-size: 0.5em;"></i>'+
                                                '</span>'+
                                            '</div>'+
                                        '</div>'+
                                    '</div>'+
                               ' </div>');
                if($("div.message-left:last").length!=0){
                    var last_msg = $("div.message-left:last").offset().top;
                    setTimeout(function () {
                        $.mobile.silentScroll(last_msg);
                    }, 50);
                }

            };

            var onMessageNotSent=function(){
                messages.append('<div class="message-left">'+
                                    '<div class="current-user">'+
                                            '<div class="photo vcentered">'+
                                                '<img src="'+photouser+'"/>'+
                                                '<div class="nom '+(app.user.get("sexe")=='M'?'homme': 'femme')+'">Moi</div>'+
                                            '</div>'+

                                            '<i class="connected fa fa-circle vcentered"></i> '+                       
                                    '</div>'+

                                    '<div class="message-content">'+
                                        '<div class="bubble-content">'+
                                            '<div class="bubble">'+
                                                '<span class="contenu">'+
                                                    texte+ ' <i class="fa fa-exclamation-circle" style="font-size: 0.5em;"></i>'+
                                                '</span>'+
                                            '</div>'+
                                        '</div>'+
                                    '</div>'+
                               ' </div>');

                if($("div.message-left:last").length!=0){
                    var last_msg = $("div.message-left:last").offset().top;
                    setTimeout(function () {
                        $.mobile.silentScroll(last_msg);
                    }, 50);
                }


            };

            localbluetooth.sendData(texte, onMessageSent, onMessageNotSent, identifiantcontact);
        }

    });
    
    $( document ).on( "pagehide", "#dialoguepage", function() {
        clearInterval(app.parametres.notifymessagestimer);
        
    });
    
    
    $( document ).on( "click", "#resetaccount", function(event) {
        
        event.preventDefault();
        event.stopPropagation();
        
        var identifiant=$("#recover-identifiant").val();
        
        if(identifiant){
            app.utils.showloader("Régénération du mot de passe...");
            app.services.recupererMotdePasse(identifiant, function(result){
                
                if(result==1){
                    app.utils.showInfoMessage("Votre mot de passe a été regénéré");
                    $("#recover-identifiant").val("")
                    $( ":mobile-pagecontainer" ).pagecontainer( "change", "index.html", { reload: false} );
                }
                else if(result==2){
                    $("#passoubliepage p.error").html("Utilisateur non reconnu");
                    app.utils.showInfoMessage("Utilisateur non reconnu");
                }
                else{
                    app.utils.showInfoMessage("Erreur, impossible de réaliser l'opération");
                }
                app.utils.hideloader();
            });
        }
        else{
            $("#passoubliepage p.error").html("Veuillez saisir l'identifiant/email");
        }
        
    });
    
    $( document ).on( "click", "#activerpremium", function(event) {
        
        event.preventDefault();
        event.stopPropagation();
        
        var code =$("#codeactivation").val();
        
        if(code ){
            if(code=="NAG123"){
                if(app.parametres.formule_premium==0){
                    app.utils.showloader("...");

                    app.services.activerPremium(app.user.get("identifiant"), code,  function(res){

                        app.utils.hideloader();
                        if(res==1){
                            setTimeout(function () {
                                $( ":mobile-pagecontainer" ).pagecontainer( "change", "accueil.html", { reload: false} );
                            }, 2000);
                        }
                        
                    });
                }
            }
            else{

               $("p.error").html("Code invalide");
            }
        }
        else{
            $("#codeactivation").parent().css("border-color", "red");
        }
        
            
    });
    
    
    // déinscription, ecoute sur le clic du touton
    $( document ).on( "click", "#unregister", function(event) {
        // fonction de desinscription
        var unregister=function(){
            app.utils.showloader("Désinscription...");
        
            app.services.desinscrire(app.user.get("identifiant"));
        };
        
        // confirm dialog        
        app.utils.confirm("Voulez vous vraiment vous désinscrire?",unregister);
        
        event.preventDefault();
        event.stopPropagation();
    });
    
    
    
    $( document ).on( "pageshow", "#allevenementspage", function(event) {
                        
        app.services.rechercherAllEvenementsUser( app.user.get("identifiant"),function(evts){
            app.parametres.unreads.events= 0;
            
            app.utils.updateMenu();
            
            app.utils.updateMenuButton();
            
            var allevts=$("#listeallevts").empty();
            
            if(evts.length==0){
                allevts.html('<div class="item-zone">  '+              
                                    '<div class="titre">'+
                                        'Evénements'+
                                    '</div>'+

                                    '<div class="item-content">'+
                                       'Aucun évènement trouvé'+

                                    '</div>'+
                                '</div>');
            }
            else{
                allevts.append('<div data-role="collapsible-set" data-theme="a" data-content-theme="b">'+
                                    '<div class="filtre">'+
                                        '<input type="text" id="filtre" data-clear-btn="true"/>'+
                                    '</div>'+
                                '</div>');
                allevts.enhanceWithin();
                
                var areaevt=allevts.find(">div.ui-collapsible-set");
                                
                for(var evt in evts){
                    
                    areaevt.append('<div data-role="collapsible">'+
                        '<h4>'+evts[evt].nom+'<span class="ui-li-count">'+evts[evt].nbparticipants+'</span></h4>'+
                        '<div class="ui-body ui-body-a" style="border-color: '+evts[evt].couleur+'">'+     
                                '<p><strong>Détails</strong><a href="#" id="evtdetail-'+evts[evt].id+'" class="'+(evts[evt].participe===true?'desinscriptionevent':'inscriptionevent')+'"><span style="position: absolute; right: 1em; top: 0.0em; font-size: 0.8em;" class="native-link">'+(evts[evt].participe===true?'Je ne participe plus':'Je participe')+'</span></a></p>'+
                                '<p>'+evts[evt].detail+' </p><hr/>'+
                                '<p><i class="fa fa-map-marker"></i> '+evts[evt].lieu+'</p>'+
                                '<p><i class="fa fa-calendar"></i> '+evts[evt].date+
                                ' '+(evts[evt].participe===true?'<i class="fa fa-check"></i>':'')+
                                '</p> '   +                        
                        '</div>'+

                    '</div>');
                    
                }
            }
            
            allevts.enhanceWithin();
            
            
            $('#filtre').autocomplete({
                lookup: app.parametres.criteres,
                lookupLimit: 6,
                delimiter:"; ",
                autoSelectFirst: false,
                appendTo: "div.filtre",
                onSelect: function (suggestion) {
                    $( "div.ui-collapsible" ).show();
                    var terms = app.utils.split( this.value );
                    // remove the current input
                    terms.pop();
                    // add the selected item
                    terms.push( suggestion.value );

                    var css=terms.join(", .");
                    $( "div.ui-collapsible" ).not( "."+css).hide();
                    console.log("join="+css);
                    terms.push( "" );
                    this.value = terms.join( "; " );

                    return false;

                },
                formatResult: function (suggestion, currentValue) {
                    return suggestion.value;
                }
            });
        });    
        
    });
    
    // ecouteur d'evenement sur l'affichage de la page d'evenements'
    $( document ).on( "pageshow", "#evenementspage", function(event) {
        
        var identifiant = decodeURIComponent(getUrlVars()["identifiant"]);
        var pseudo = decodeURIComponent(getUrlVars()["pseudo"]);
        
        if(identifiant==app.user.get("identifiant")){
            $("#evenementspage .ui-header span").html("<i class='fa fa-calendar'></i> Moi");
        }
        else{
            $("#evenementspage .ui-header span").html("<i class='fa fa-calendar'></i> "+pseudo);
        }
        
        app.services.rechercherEvenementsUtilisateur(identifiant, function(evts){
            var eventlist=$("#listeevts").empty();
            
            if(evts.length==0){
                eventlist.html('<div class="item-zone">  '+              
                                    '<div class="titre">'+
                                        'Partitipations '+pseudo+
                                    '</div>'+

                                    '<div class="item-content">'+
                                       'Aucune activité trouvée'+

                                    '</div>'+
                                '</div>');
            }
            else{
                
                for(var evt in evts){
                    
                    eventlist.append('<div class="item-zone">  '+              
                                    '<div class="titre">'+
                                        evts[evt].nom+
                                    '</div>'+

                                    '<div class="item-content" id="content-evt-'+evts[evt].id+'">'+
                                        evts[evt].detail+'<br/>'+
                                        ' <i class="fa fa-map-marker color-red"></i> '+evts[evt].lieu+
                                        '<br/> <i class="fa fa-calendar color-red"></i> '+evts[evt].date+
                                        (identifiant==app.user.get("identifiant")?('<br/> <div class="filtre">'+
                                                    '<input type="text" class="filtreinput" placeholder="Avec..." data-clear-btn="true"/>'+
                                                '</div> '):'')+
                                        
                                    '</div>'+
                                '</div>');
                            
                    $('#evenementspage .filtreinput:last').autocomplete({
                        lookup: app.parametres.utilisateurs,
                        lookupLimit: 6,
                        delimiter:"; ",
                        autoSelectFirst: false,
                        appendTo: "#evenementspage div.filtre:last",
                        onSelect: function (suggestion) {

                            var terms = app.utils.split( this.value );
                            // remove the current input
                            terms.pop();
                            // add the selected item
                            terms.push( suggestion.value );

                            terms.push( "" );

                            this.value = terms.join( "; " );
                            
                            var div=$(this).parent();
                            
                            div.append('<img src="images/ajax-loader-spinner.gif" class="loader"/>');
                            
                            app.services.ajouterFavoris(app.user.get("identifiant"), suggestion.data, function(res){
                                if(res==1){
                                    app.utils.showInfoMessage(suggestion.value+" enregistré comme favoris");
                                    
                                }
                                else{
                                    app.utils.showInfoMessage("Favoris non enregistré");
                                }
                                div.find("img.loader").remove();
                            })
                            return false;

                        },
                        formatResult: function (suggestion, currentValue) {
                            return suggestion.value;
                        }
                    });
            
                }
                
            }
        });
    });
    
    $( document ).on( "pageshow", "#devicepage", function(event) {
        
        var devicename=decodeURIComponent(getUrlVars()["devicename"]);
        
        var address=decodeURIComponent(getUrlVars()["address"]);
        
        $("#nomappareil>span").html(devicename);
        
        $("#adresseappareil>span").html(address);
        
        app.services.rechercherMobile(address, function(contact){
            
            try{
                var area=$("#utilisateur"); // zone ou on doit ecrire tout ce profil
                
                area.find("div").remove(":nth-child(n+2)");
                
                // objet vide, contact non trouvé
                if(! contact || contact.identifiant == undefined){
                    area.append('<div class="item-content">'+
                                    'Contact introuvable sur Meetooth'+
                                '</div>');
                    
                }
                else{
                                        
                    if(!contact.photo || (contact.photo.lastIndexOf("/") > contact.photo.lastIndexOf("."))){
                        contact.photo="images/default.jpg";
                    }
                    
                    var details="";
                    
                    if(contact.annoncejob != contact.annonceme ){
                        
                        if(contact.activerjob ==1 ){
                            details+='<div class="item-zone"> '+               
                                '<div class="titre">'+
                                    contact.annoncejob+
                                '</div>'+

                                '<div class="item-content">'+
                                   contact.complementinformationsjob+
                                '</div>'+
                            '</div>';
                            
                        }
                        else if(contact.activerme ==1 ){
                            details+='<div class="item-zone"> '+               
                                '<div class="titre">'+
                                    contact.annonceme+
                                '</div>'+

                                '<div class="item-content">'+
                                   contact.complementinformationsme+
                                '</div>'+
                            '</div>';
                        }

                    }
                    else{
                        details+='<div class="item-zone"> '+               
                                    '<div class="titre">'+
                                        'Description'+
                                    '</div>'+

                                    '<div class="item-content">'+
                                       contact.description+
                                    '</div>'+
                                '</div>';
                    }
                    
                    
                    area.append(
                        '<div class="row">'+
                        '<div class="photouser">'+
                            '<div class="photobox homme">'+
                                '<img src="'+contact.photo+'" class="photo-normal"/>'+
                            '</div>'+
 
                            '<div class="nom">'+
                                '<div class="zonenom">'+
                                    contact.pseudo+
                                '</div>'+
                                '<div class="zoneage">'+
                                    app.utils.calculerAge(contact.datenaissance)+' ans'+
                                '</div>'+
                           ' </div>'+
                        '</div>'+
                         
                        '<div class="icons single" style="width: auto; top: 35%">'+
                            '<a href="#" class="chatbtn" id="chatbtn-'+contact.identifiant+'">'+
                                '<div>'+
                                    '<img src="images/logosmall.png"/>'+
                                '</div>'+ 
                            '</a>'+
                               
                            '<div>'+
                                '<i class="'+(contact.online==1?'connected':'disconnected')+' fa fa-circle"></i>'+
                            '</div>'+
                        '</div>'+
                        
                    '</div>'+                    
                    details);
                
                    area.after('<div class="row item-zone">'+
                        '<a href="profil-utilisateur.html?identifiant='+contact.identifiant+'" id="profil-link" class="ui-btn ui-corner-all"><span style="padding: 0.5em;">Voir son profil</span></a>'+
                    '</div>');
                }
            }
            catch(exception){
                
                console.log("erreur"+exception);
            }
            
                        
        });
    });
    
    // When the Meet page is shown
    $( document ).on( "pageshow", "#meetspage", function(event) {
        
        var drawMeets=function(){
            // charge les meets de la BD non encore lus
            accessDB.rechercherMeets(app.user.get("identifiant"), app.utils.addMeetsToUI);  
        };
              
        drawMeets();
        
        app.parametres.showmeettimer=setInterval(drawMeets, app.parametres.timerinterval);
        
        $( "#meetsrecents" ).off("click").on( "click",function(event) {
            event.preventDefault();
            event.stopPropagation();
            event.stopImmediatePropagation();

            $("#meetsrecus").prepend('<div class="loader"> <img src="images/ajax-loader-spinner.gif" class="loader"></div>');

            $("#meetsrecents i").replaceWith('<img src="images/ajax-loader-circle.gif"/>');

//            app.services.rechercherMeets(app.user.get("identifiant"), app.utils.addMeetsToUI);
            accessDB.rechercherMeets(app.user.get("identifiant"), app.utils.addMeetsToUI); 
        });
         
    });
    
    
    // When the Meet page is shown
    $( document ).on( "pagehide", "#meetspage", function(event) {
        
        clearTimeout(app.parametres.showmeettimer);
         
    });
    
    $( document ).on( "pageshow", "#compatibilitepage", function(event) {
        try{
            var recepteur={ pseudo: decodeURIComponent(getUrlVars()["pseudo"]), identifiant: decodeURIComponent(getUrlVars()["identifiant"])};
        
            $("#compatibilitepage span.recepteurnom").html(recepteur.pseudo);
            var opts = {
                lines: 12, // The number of lines to draw
                angle: 0.09, // The length of each line
                lineWidth: 0.33, // The line thickness
                pointer: {
                  length: 0.55, // The radius of the inner circle
                  strokeWidth: 0.035, // The rotation offset
                  color: 'red' // Fill color
                },
                limitMax: 'false',   // If true, the pointer will not go past the end of the gauge
                colorStart: '#6FADCF',   // Colors
                colorStop: '#8FC0DA',    // just experiment with them
                strokeColor: '#E0E0E0',   // to see which ones work best for you
                generateGradient: true
            };

            var canvas = document.getElementById('gauge'); // your canvas element
            var gauge = new Gauge(canvas).setOptions(opts); // create sexy gauge!
            gauge.setTextField(document.getElementById("valeurgauge"));
            gauge.maxValue = 100; // set max gauge value
            gauge.animationSpeed = 32; // set animation speed (32 is default value)
             // set actual value
            gauge.set(1);
            canvas.getContext('2d').clearRect(0, 0, canvas.width, canvas.height);

            canvas.width = canvas.width;

            // Mettre à jour sa compatibilité

            app.services.calculerCompatibilite(recepteur.identifiant, function(resultat){
                gauge.set(resultat);
            });
        }
        catch(e){
            console.log("Erreur "+e);
        }
        
        app.services.rechercherUtilisateur(recepteur.identifiant, function(user){                
            $("div.loader").remove();
            
            if(user){
                if(! user.photo || (user.photo.lastIndexOf("/") > user.photo.lastIndexOf("."))){
                    user.photo="images/default.jpg";
                }
                
                $("#compatibilitepage .row>.photouser>.photobox img").attr('src',user.photo);
                
                $("#compatibilitepage .row>.photouser>.nom>.zonenom").html(user.pseudo);
                
                $("#compatibilitepage .row>.photouser>.nom>.zoneage").html(app.utils.calculerAge(user.datenaissance)+" ans");
                              
                if(user.annoncejob != user.annonceme ){
                    $("#meetbtn").after('<div class="item-zone" id="description">'+              
                        '<div class="titre">'+
                            '<i class="fa fa-info-circle"></i> '+
                        '</div>'+

                        '<div class="item-content">'+

                        '</div>'+
                    '</div>');
                    
                    if(user.activerjob ==1 ){
                        $("#description .titre").append(user.annoncejob);
                        $("#description .item-content").append(user.complementinformationsjob);
                    }
                    else if(user.activerme ==1 ){
                        $("#description .titre").append(user.annonceme);
                        $("#description .item-content").append(user.complementinformationsme);
                    }
                    
                }
                else{
                    $("#meetbtn").after('<div class="item-zone" id="description">'+              
                        '<div class="titre">'+
                            'Description'+
                        '</div>'+

                        '<div class="item-content">'+
                            user.description+
                        '</div>'+
                    '</div>'+
                    '<div class="item-zone" id="compatibilites">'+                
                        '<div class="titre">'+
                            'Personnalité'+
                        '</div>'+

                        '<div class="item-content">'+
                            '<div class="loader"> <img src="images/ajax-loader-spinner.gif" class="loader"></div>'+
                        '</div>'+
                    '</div>');

                    // geres les pbs de criteres
                    app.services.rechercherCriteresCompatibilite(app.user.get("identifiant"), function(criteres){
                        $(".loader").remove();
                        var area=$("#compatibilites .item-content");
                        
                        if(criteres){

                            var valeur, icon;
                
                            $.each(criteres, function(index, critere){

                                valeur=(critere.valeur-1)*50;

                                switch(valeur){
                                    case 100:   icon="fa-smile-o";
                                                break;
                                    case 50:    icon="fa-meh-o";
                                                break;
                                    default:    icon="fa-frown-o";
                                                break;
                                }
                                area.append('<div class="interet">'+
                                                '<i class="fa '+icon+'"></i> '+ critere.nom+': '+ valeur+'%'+
                                                '<input data-show-value="true" disabled="disabled" value="'+valeur+'" min="0" max="100" data-mini="true" data-highlight="true" data-theme="b" data-track-theme="b" type="range">'+
                                            '</div>');                    
                            });

                            area.enhanceWithin();

                        }
                        else{
                            area.html("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucune valeur particulière </span></div>");
                        }
                    });

                }

            }
            else{
                $("#meetbtn").after("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucune information trouvée sur votre contact </span></div>")
            }

        });
        
    }); 
        
    $(document).on('click','#compatibilitepage a.sendmeet:not(.unclickable), #profilcontactpage a.sendmeet:not(.unclickable)', function(event) {
        event.preventDefault();
        event.stopPropagation();
        
        var link=$(this);
        
        link.addClass("unclickable").attr("src", "images/ajax-loader.gif");

        app.utils.showloader("Envoi...");

        var recepteur={pseudo: decodeURIComponent(getUrlVars()["pseudo"]), identifiant: decodeURIComponent(getUrlVars()["identifiant"]), photo: decodeURIComponent(getUrlVars()["photo"])};

        app.services.sendMeet(recepteur.identifiant, function(result){

            if(result==1){
                app.utils.displayBox(
                    '<div class="ui-corner-all custom-box dialog" style="display:none; border: 1px solid #CCC" >'+
                        '<div class="ui-bar ui-bar-a">'+
                          '<h3>Meet</h3>'+
                        '</div>'+
                        '<div class="ui-body ui-body-a row" >'+

                            '<div style="min-height: 60px;"> <i class="fa fa-info-circle color-red"></i>  Meet envoyé à <i class="color-green">'+recepteur.pseudo+'</i><br/></div>'+

                        '</div>'+
                        '<div class="ui-bar-f ui-bar-a"></div>'+
                    '</div>', app.constants.dialog.meet);

            }
            else if(result==2){
                app.utils.showInfoMessage('Meet non envoyé, Vous n\'êtes pas autorisés');
            }
            else if(result==3){
                app.utils.showInfoMessage('Meet non envoyé, Votre contact est introuvable');
            }
            else{
                app.utils.showInfoMessage('Erreur de connexion, Meet non envoyé');
            }
            
        }, function(){
            link.removeClass("unclickable");
            app.utils.hideloader();
        });

    });
    
    
    $( document ).on( "pageshow", "#profilpersopage", function(event) {
        event.preventDefault();
        event.stopPropagation();
        
        try{
            
            var photo = app.user.get("photo");
            
            if(! photo || (photo.lastIndexOf("/") > photo.lastIndexOf("."))){
                photo="images/default.jpg";
            }
            
            console.log("Meetooth photo="+photo);
            
            $("#profilpersopage .row>.photouser>.photobox img").attr("src", photo+"?"+(new Date().getTime()));
            
            $("#profilpersopage .row>.photouser>.photobox").addClass((app.user.get("sexe")=="M"?'homme': (app.user.get("sexe")=="F"?'femme':'') ));
            
            $("#profilpersopage .row>.photouser>.nom>.zonenom").html(decodeURIComponent(app.user.get("pseudo")));
            
            $("#profilpersopage .row>.photouser>.nom>.zoneage").html(app.utils.calculerAge(app.user.get("naissance"))+" ans");
            
            $("#nom").val(decodeURIComponent(app.user.get("nom")));
            
            $("#prenom").val(decodeURIComponent(app.user.get("prenom")));
            
            $("#naissance").val(decodeURIComponent(app.user.get("naissance")));
            
            $("#email").val(decodeURIComponent(app.user.get("mail")));
            
            $("#pseudo").val(decodeURIComponent(app.user.get("pseudo")));
            
            $("#identifiant").val(decodeURIComponent(app.user.get("identifiant")));
            
            $("#description").val(decodeURIComponent(app.user.get("description")));
            
            $("#sexe").val(app.user.get("sexe"));
            
            $("#sexe").selectmenu( "refresh" );
            
            $("#profilpersopage").enhanceWithin();
            
            app.services.rechercherUtilisateur(app.user.get("identifiant"), function(user){
                $(".view1 .loader").remove();
                
                if(user){
                    console.log("4008 id="+user.identifiant);
                    app.user.set({photo: user.photo, pseudo: user.pseudo, nom: user.nom, prenom: user.prenom, mail: user.email, password: user.motdepasse, naissance: app.utils.parseNaissance(user.datenaissance), description: user.description, sexe: user.sexe});
                    
                    if(! user.photo || (user.photo.lastIndexOf("/") > user.photo.lastIndexOf("."))){
                        user.photo="images/default.jpg";
                    }
                    
                    if(photo!=user.photo){
                        $("#profilpersopage .row>.photouser>.photobox img").attr("src", user.photo+"?"+(new Date().getTime()));
                    }
                    
                    $("#profilpersopage .row>.photouser>.nom>.zonenom").html(decodeURIComponent(user.pseudo));
                    
                    $("#profilpersopage .row>.photouser>.nom>.zoneage").html(app.utils.calculerAge(user.datenaissance)+" ans");
                    
                    $("#nom").val(user.nom);
                    
                    $("#prenom").val(user.prenom);
                    
                    $("#naissance").val(app.utils.parseNaissance(user.datenaissance));
                    
                    $("#email").val(user.email);
                    
                    $("#pseudo").val(app.user.get("pseudo"));
                    
                    $("#description").val(app.user.get("description"));

                    $("#sexe").val(app.user.get("sexe"));

                    $("#sexe").selectmenu( "refresh" );

                    $("#profilpersopage").enhanceWithin();
                    
                    
                    if(user.activerjob!=user.activerme){
                        if(user.activerjob==1){
                            $("#titrejob").val(user.annoncejob);
                            $("#descriptionjob").val(user.complementinformationsjob);
                            $("#annonce-job").attr('checked', true).checkboxradio("refresh");                            
                            $("#jobannonceinfo").show();
                        }
                        else if(user.activerme== 1){
                            $("#titreperso").val(user.annonceme);
                            $("#descriptionperso").val(user.complementinformationsme);
                            $("#annonce-perso").attr('checked', true).checkboxradio("refresh");
                            $("#personnonceinfo").show();
                        }
                        else{                            
                            $("#formprofilperso input[value='no']").attr('checked', true).checkboxradio("refresh");
                        }
                    }
                    else{
                        
                        $("#formprofilperso input[value='no']").attr('checked', true).checkboxradio("refresh");
                    }
                    
                    $("#formprofilperso .view3").enhanceWithin();
                    
                    app.services.rechercherCriteresEvenements(app.user.get("identifiant"), function(criteres){
                        if(criteres.length>0){
                            var area=$("#criteres-evt").empty();

                            $.each(criteres, function(index, critere){
                                area.append('<input type="checkbox" id="crievt-'+critere.id+'"' +(critere.valeur==1?'checked':'')+'><label for="crievt-'+critere.id+'">'+critere.nom+'</label>');
                            });
                            area.enhanceWithin();
                        }
                        else{
                            $("#criteres-evt").html("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucun profil d'intérêt trouvé </span></div>");
                        }

                        if(user.temoinevent==0){
                            $("#infoevenement1").attr('checked', true);  
                        }
                        else{
                            $("#infoevenement2").attr('checked', true);
                        }

                        $("#formprofilperso .view4").enhanceWithin();

                        if(user.temoinevent==0){   
                            $("#criteres-evt").hide();
                        }
                        else{
                            $("#criteres-evt").show();
                        }
                    });
                                       
                }
                else{
                    $("#formprofilperso").replaceWith("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucune information trouvée sur vous! </span></div>")
                }
                
            });
            
            // geres les pbs de criteres
            app.services.rechercherCriteresCompatibilite(app.user.get("identifiant"), function(criteres){
                if(criteres){
                    var table=$("#formprofilperso .view3 table tbody").empty();

                    $.each(criteres, function(index,critere){
                        table.append('<tr>'+
                            '<td>'+critere.nom+'</td>'+
                            '<td>'+
                                '<fieldset data-role="controlgroup" data-type="horizontal" data-mini="true">'+
                                    '<input name="cri'+critere.id+'" id="cri'+critere.id+'-1" value="1" '+(critere.valeur==1?'checked':'')+' type="radio">'+
                                    '<label for="cri'+critere.id+'-1">'+
                                        '<i class="fa fa-frown-o"></i>'+
                                    '</label>'+
                                    '<input name="cri'+critere.id+'" id="cri'+critere.id+'-2" value="2" '+(critere.valeur==2?'checked':'')+' type="radio">'+
                                    '<label for="cri'+critere.id+'-2"><i class="fa fa-meh-o"></i></label>'+
                                    '<input name="cri'+critere.id+'" id="cri'+critere.id+'-3" value="3" '+(critere.valeur==3?'checked':'')+' type="radio">'+
                                    '<label for="cri'+critere.id+'-3"><i class="fa fa-smile-o"></i></label>'+
                                '</fieldset>'+
                            '</td>'+
                        '</tr>');
                    });
                    $("#formprofilperso .view3 table").enhanceWithin();
                }
                else{
                    $("#formprofilperso .view3").html("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucun sujet d'intérêt à vous proposer </span></div>");
                }
            });


            
        }
        catch(e){
            $("#formprofilperso").replaceWith("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucune information trouvée sur vous! </span></div>")
        }
    }); 
    
    $( document ).on( "submit", "#formprofilperso", function(event) {
            
            event.preventDefault();
            event.stopPropagation();
            // get the current view id
            var view=$("#formprofilperso input[name='currentview']").val();
            var message="";

            var validerformulaire=function(idvue){
                var result=true;                
                
                if(idvue==1){
                    message="";
                    
                    if($("#nom").val()==""){
                        $("#nom").parent().parent().find("label").css("color", "red");
                        result=false;
                        message+="Nom obligatoire<br/>";
                    }
                    else{
                        $("#nom").parent().parent().find("label").css("color", "inherit");
                    }
                    
                    if($("#prenom").val()==""){
                        $("#prenom").parent().parent().find("label").css("color", "red");
                        result=false;
                        message+="Prénom obligatoire<br/>";
                    }
                    else{
                        $("#prenom").parent().parent().find("label").css("color", "inherit");
                    }
                    
                    if($("#naissance").val()==''){
                        message+="Date de naissance obligatoire<br/>";
                        result=false;
                        $("#naissance").parent().parent().find("label").css("color", "red");
                    }
                    else{
                        
                        if(! app.utils.validerDate($("#naissance").val())){
                            result=false;
                            message+="Date de naissance invalide<br/>";
                            $("#naissance").parent().parent().find("label").css("color", "red");
                        }
                        else{
                            if(app.utils.calculerAge($("#naissance").val())<18){
                                result=false;
                                message+="Age minimum requis: 18 ans <br/>";
                                $("#naissance").parent().parent().find("label").css("color", "red");
                            }
                            else{
                                $("#naissance").parent().parent().find("label").css("color", "inherit");
                            }
                        }
                    }
                    
                }

                else if(idvue==2){
                    message="";
                    
                    if($("#email").val()==''){
                        result=false;
                        $("#email").parent().parent().find("label").css("color", "red");
                        message+="Email obligatoire<br/>";
                    }
                    else if(! app.utils.validerEmail($("#email").val())){
                        result=false;
                        $("#email").parent().parent().find("label").css("color", "red");
                        message+="Email invalide<br/>";
                    }
                    else{
                        $("#email").parent().parent().find("label").css("color", "inherit");
                    } 
                    
                    if($("#identifiant").val()==''){
                        result=false;
                        $("#identifiant").parent().parent().find("label").css("color", "red");
                        message+="Identifiant obligatoire<br/>";
                    }
                    else if(! app.utils.validerIdentifiant($("#identifiant").val())){
                            result=false;
                            $("#identifiant").parent().parent().find("label").css("color", "red");
                            message+="Caractères spéciaux non autorisés dans l'identifiant<br/>";

                    }
                    else{
                        $("#identifiant").parent().parent().find("label").css("color", "inherit");
                    }
                    
                    if($("#password").val()=='' || $("#password2").val()==''){
                        if($("#password").val()==''){
                            message+="Mot de passe obligatoire<br/>";
                            result=false;
                            $("#password").parent().parent().find("label").css("color", "red");
                        }
                        else{
                            $("#password").parent().parent().find("label").css("color", "inherit");
                        }
                        
                        if($("#password2").val()==''){
                            message+="confirmation mot de passe obligatoire<br/>";
                            result=false; 
                            $("#password2").parent().parent().find("label").css("color", "red");
                        }  
                        else{
                            $("#password2").parent().parent().find("label").css("color", "inherit");
                        }
                    }
                    else{
                        if($("#password").val()!=$("#password2").val()){
                            result=false;
                            message+="Veuillez saisir des mots de passe identiques<br/>";
                            $("#password, #password2").parent().parent().find("label").css("color", "red");
                        }
                        else{
                            $("#password, #password2").parent().parent().find("label").css("color", "inherit");
                        }
                    }
                    
                    
                    if($("#pseudo").val()==''){
                        result=false;
                        $("#pseudo").parent().parent().find("label").css("color", "red");
                        message+="Pseudo obligatoire<br/>";
                    }
                    else if(! app.utils.validerPseudo($("#pseudo").val())){
                            result=false;
                            $("#pseudo").parent().parent().find("label").css("color", "red");
                            message+="Caractères spéciaux non autorisés dans le pseudo<br/>";
                    }
                    else{
                        $("#pseudo").parent().parent().find("label").css("color", "inherit");
                    } 
                    
                    if($("#formprofilperso input[name='annonce']").val()=="perso"){
                        $("#titreperso , #descriptionperso, #pseudo").each(function(){
                            if($(this).val()==""){
                                $(this).parent().parent().find("label").css("color", "red");
                                result=false;
                            }
                            else{
                                $(this).parent().parent().find("label").css("color", "inherit");
                            }                    
                        });
                        
                    }
                    else if($("#formprofilperso input[name='annonce']").val()=="job"){
                        $("#titrejob , #descriptionjob").each(function(){
                            if($(this).val()==""){
                                $(this).parent().parent().find("label").css("color", "red");
                                result=false;
                            }
                            else{
                                $(this).parent().parent().find("label").css("color", "inherit");
                            }                    
                        });
                    }
                    
                }
                else if(idvue==3 || idvue==4){
                    result=true;
                }
                
                if(result){
                    $("#formprofilperso p.error").html("");
                }
                else{
                    $("#formprofilperso p.error").html(message);
                }
                return result;
            
            }
        
            try{
                view=parseInt(view);
            }
            catch (e){
                view=1;
            }
            
            switch(view){
                case 1: if(validerformulaire(1)){
                            $("#formprofilperso >.view1, #formprofilperso >.view3, #formprofilperso >.view4").hide();
                            $("#formprofilperso >.view2").show();
                            $("#formprofilperso input[name='currentview']").val(2);
                            $("#profilpersopage>.ui-header>span").html(2);
                            $("#formprofilperso  fieldset.buttons a.back").removeClass("ui-disabled");
                        }
                        break;

                case 2: if(validerformulaire(2)){
                            $("#formprofilperso >.view1, #formprofilperso >.view2, #formprofilperso >.view4").hide();
                            $("#formprofilperso >.view3").show();
                            $("#formprofilperso input[name='currentview']").val(3);
                            $("#profilpersopage>.ui-header>span").html(3);
                        }
                        break;
                case 3: if(validerformulaire(3)){
                            $("#formprofilperso >.view1, #formprofilperso >.view2, #formprofilperso >.view3").hide(0);
                            $("#formprofilperso >.view4").show(1);
                            $("#formprofilperso input[name='currentview']").val(4);
                            $("#profilpersopage>.ui-header>span").html(4);
                            $("#formprofilperso fieldset.buttons button").text("Valid.");
                            $("#formprofilperso .icons fieldset.buttons button").text("");
                            $("#formprofilperso fieldset.buttons button").buttonMarkup({icon: "check"});
                        }
                        break;
                case 4: //Dernière étape, il faut envoyer le formulaire
                        if(validerformulaire(4)){
                            app.utils.showloader("Mise à jour...");
                            
                            var criteresevt=$("#formprofilperso input[name='infoevenement']:checked").val();
                            var criteres=[], criterescomp=[];

                             if(criteresevt==0){
                                $("#criteres-evt input[type='checkbox']").attr('checked', true);                            
                            }
                            
                            var id="";
                            // critères évenements
                            $("#criteres-evt input[type='checkbox']").each(function(){
                                id=$(this).attr("id");
                                
                                id=id.substring(7);
                                
                                if($(this).is(':checked')){
                                    criteres.push(""+id+":1");
                                    
                                }
                                else{

                                    criteres.push(""+id+":2");
                                }
                                
                            });
                            
                            // criteres compatibilités                            
                            $("#formprofilperso .view3 table input[type='radio']:checked").each(function(){
                                id=$(this).attr("id");
                                
                                id=id.substring(3, id.length-2);
                                
                                criterescomp.push(""+id+":"+$(this).val());

                            });

                                                        
                            if(criterescomp.join(",")==""){
                                criterescomp="-";
                            }
                            else{
                                criterescomp=criterescomp.join(",");
                            }
                            
                            if(criteres.join(",")==""){
                                criteres="-";
                            }
                            else{
                                criteres=criteres.join(",");
                            }

                            var parametre={
                                nom: encodeURIComponent($("#formprofilperso input[name='nom']").val()),
                                prenom: encodeURIComponent($("#formprofilperso input[name='prenom']").val()),
                                identifiant: encodeURIComponent($("#formprofilperso #identifiant").val()),
                                mail: encodeURIComponent($("#formprofilperso #email").val()),
                                sexe: $("#formprofilperso #sexe").val(),
                                naissance: encodeURIComponent($("#formprofilperso input[name='naissance']").val()),
                                pseudo: encodeURIComponent($("#formprofilperso input[name='pseudo']").val()),
                                password: encodeURIComponent($("#formprofilperso input[name='password']").val()),                    
                                description: encodeURIComponent($("#description").val()),
                                criterescomp: encodeURIComponent(criterescomp),
                                criteresevt: encodeURIComponent(criteres),
                                temoinevt: encodeURIComponent($("#formprofilperso input[name='infoevenement']:checked").val()),
                                activerjob: 0,
                                activerme: 0,
                                annoncejob: null,
                                annonceme: null,
                                complementinformationsjob: null,
                                complementinformationsme: null
                            };
                            
                            if($("#formprofilperso input[name='annonce']:checked").val()=="job"){
                                
                                parametre.activerjob = 1;
                                parametre.annoncejob = encodeURIComponent($("#formprofilperso #titrejob").val());
                                parametre.complementinformationsjob = encodeURIComponent($("#formprofilperso #descriptionjob").val());
                            }
                            else if($("#formprofilperso input[name='annonce']:checked").val()=="perso"){
                                
                                parametre.activerme = 1;
                                parametre.annonceme = encodeURIComponent($("#formprofilperso #titreperso").val());
                                parametre.complementinformationsme= encodeURIComponent($("#formprofilperso #descriptionperso").val());
                                
                            }
                                                       
                            app.services.modifierProfilUtilisateur(parametre.nom, parametre.prenom, parametre.identifiant, parametre.mail, parametre.sexe, parametre.naissance, parametre.pseudo, parametre.description, parametre.criterescomp, parametre.temoinevt, parametre.criteresevt, parametre.activerjob, parametre.annoncejob, parametre.complementinformationsjob, parametre.activerme, parametre.annonceme ,parametre.complementinformationsme, function(result){
                                var message="";
                                switch(result){
                                    
                                    case 0: message="Utilisateur non reconnu";
                                            break;
                                    case 1: 
                                            app.utils.showInfoMessage("Profil modifié");
                                            //upload the photo file of the just registered user
                                            var imageURI=$("#formprofilperso input[name='imageURI']").val();
                                            
                                            //Si l'utilisateur a changé sa photo, uploade la nouvelle photo
                                            if(imageURI!=""){
                                                app.utils.showInfoMessage("Envoi de la photo...");
                                                
                                                app.utils.showloader("Envoi de la photo...");
                                                
                                                app.services.changerPhotoUtilisateur(imageURI, parametre.identifiant, function(){
                                                    //Change de page, retour à l'accueil
                                                    app.utils.showInfoMessage("Modification effectuée, redirection...");
                                                    app.utils.showloader("Modification effectuée, redirection...");
                                                    setTimeout(function () {
                                                        
                                                        app.utils.hideloader();
                                                        $( ":mobile-pagecontainer" ).pagecontainer( "change", "accueil.html", { reload: false} );
                                                        
                                                    }, 500);
                                                });
                                            }
                                            else{
                                                setTimeout(function () {
                                                    
                                                    $( ":mobile-pagecontainer" ).pagecontainer( "change", "accueil.html", { reload: false} );
                                                }, 500);
                                            }
                                            
                                            // met à jour le device avec lequel l'utilisateur effectue l'opération
                                            
                                            app.services.modifierDeviceUtilisateur(app.user.get("identifiant"));
                                            break;
                                            
                                    case 2: message="Adresse email invalide";
                                            break;
                                    
                                    case 3: message="Nom utilisateur invalide";
                                            break;
                                    
                                    case 4: message="Paramètre type de notification evenement incorrect";
                                            break;
                                                
                                    case 5: message="Critères de compatibilité invalides";
                                            break;
                                                    
                                    case 6: message="Critères de notification d'évenements invalides";
                                            break;

                                    case 7: message="Erreur innatendue";
                                            break;
                                }
                                
                                if(message!=""){
                                    app.utils.showInfoMessage("Erreur, profil non modifié! \n"+message);
                                    $("#formprofilperso p.error").html(message);
                                }
                                
                            });
                        } 
                        break;
                default:$("#formprofilperso >.view2, #formprofilperso >.view3, #formprofilperso >.view4").hide(0);
                        $("#formprofilperso >.view1").show(1);
                        $("#formprofilperso input[name='currentview']").val(1);
                        $("#profilpersopage>.ui-header>span").html("1");
                        $("#formprofilperso fieldset.buttons button").text("Valid.");

                }
            });
        
        // Go back button on the registration form
        $( document ).on( "click", "#formprofilperso a.back", function(event) {
            event.preventDefault();
            event.stopPropagation();

            // get the current vieux id
            var view=$("#formprofilperso input[name='currentview']").val();

            // parse it to an integer
            try{
                view=parseInt(view);
            }
            catch (e){
                view=1;
            }

            // make ui changes depending on the view
            switch(view){

                case 2: $("#formprofilperso >.view2, #formprofilperso >.view3, #formprofilperso >.view4").hide(0);
                        $("#formprofilperso >.view1").show(1);
                        $("#formprofilperso input[name='currentview']").val(1);
                        $("#profilpersopage>.ui-header>span").html(1);
                        $("#formprofilperso  fieldset.buttons a.back").addClass("ui-disabled");
                        break;
                case 3: $("#formprofilperso >.view1, #formprofilperso >.view3, #formprofilperso >.view4").hide(0);
                        $("#formprofilperso >.view2").show(1);
                        $("#formprofilperso input[name='currentview']").val(2);
                        $("#profilpersopage>.ui-header>span").html(2);
                        break;
                case 4: $("#formprofilperso >.view1, #formprofilperso >.view2, #formprofilperso >.view4").hide();
                        $("#formprofilperso >.view3").show();
                        $("#formprofilperso input[name='currentview']").val(3);
                        $("#profilpersopage>.ui-header>span").html(3);
                        $("#formprofilperso fieldset.buttons button").text("Suiv.");
                        $("#formprofilperso .icons fieldset.buttons button").text("");
                        $("#formprofilperso fieldset.buttons button").buttonMarkup({icon: "arrow-r"});
                        break;
                default:break;

            }
        });
        
        $( document ).on( "change", "#formprofilperso input[name='infoevenement']", function(event) {
            event.preventDefault();
            event.stopPropagation();
            if($(this).val()==0){
                $("#criteres-evt").hide();
                $("#infoevenement2").parent().find("label").addClass("ui-last-child");
            }
            else if($(this).val()==1){
                $("#criteres-evt").show();
                $("#infoevenement2").parent().find("label").removeClass("ui-last-child");
            }
        }); 
    

    
    $( document ).on( "pageshow", "#profilcontactpage", function(event) {
        event.preventDefault();
        event.stopPropagation();
        
        var identifiant = getUrlVars()["identifiant"];
        var pseudo = decodeURIComponent(getUrlVars()["pseudo"]);
        var photo = decodeURIComponent(getUrlVars()["photo"]);
            
        $("#profilcontactpage .ui-header span").html("<i class='fa fa-user'></i> "+pseudo);
        
        if(! photo || (photo.lastIndexOf("/") > photo.lastIndexOf("."))){
            user.photo="images/default.jpg";
        }
                    
        $("#profilcontactpage .row>.photouser>.photobox img").attr("src", photo);
        $("#identite .item-content").html(pseudo);
        // charger les infos de la page
        try{
            
            app.services.rechercherUtilisateur(identifiant, function(user){                
            
                if(user){
                    $(".loader").remove();
                    
                    if(! user.photo || (user.photo.lastIndexOf("/") > user.photo.lastIndexOf("."))){
                        user.photo="images/default.jpg";
                    }
                    
                    $("#profilcontactpage .ui-header span").html("<i class='fa fa-user'></i> "+user.pseudo);

                    $("#profilcontactpage .row>.photouser>.photobox img").attr("src", user.photo);
                
                    $("#profilcontactpage .eventsbtn").attr("href", "evenements.html?identifiant="+identifiant+"&pseudo="+user.pseudo);
                    
                    $("#profilcontactpage .eventsbtn").prop( "disabled", false ).removeClass("ui-disabled");
                    
                    $("#profilcontactpage .row>.photouser>.nom>.zonenom").html(user.pseudo);
                    
                    $("#profilcontactpage .row>.photouser>.photobox").addClass((user.sexe=="M"?'homme': 'femme'));

                    $("#profilcontactpage .row>.photouser>.nom>.zoneage").html(app.utils.calculerAge(user.datenaissance)+" ans");
                    
                    $("#profilcontactpage .icons>a.chatbtn").attr("id","chatbtn-"+identifiant);
                    
                    $("#identite .item-content").html(user.pseudo);
                    
                    if(user.activerme != user.activerjob ){                        
                    
                        if(user.activerjob ==1 ){
                            $("#identite").after('<div class="item-zone" id="description">'+              
                                '<div class="titre">'+
                                    '<i class="fa fa-info-circle"></i> '+user.annoncejob+
                                '</div>'+

                                '<div class="item-content">'+
                                    user.complementinformationsjob+
                                '</div>'+
                            '</div>');
                    
                        }
                        else if(user.activerme ==1 ){
                            $("#identite").after('<div class="item-zone" id="description">'+              
                                '<div class="titre">'+
                                    '<i class="fa fa-info-circle"></i> '+user.annonceme+
                                '</div>'+

                                '<div class="item-content">'+
                                    user.complementinformationsme+
                                '</div>'+
                            '</div>');
                        }
                    }
                    else{
                        $("#identite").after('<div class="item-zone" id="description">'+              
                            '<div class="titre">'+
                                'Description'+
                            '</div>'+

                            '<div class="item-content">'+
                            
                                (user.description=="null"?'...':user.description)+
                            '</div>'+
                        '</div>'+
                        
                        '<div class="item-zone" id="interets" style="border: 1px solid #ccc;">'+           
                            '<div class="titre">'+
                                'Centres d\'intérêts '+
                            '</div>'+

                            '<div class="item-content">'+
                                '<div class="loader"> <img src="images/ajax-loader-spinner.gif" ></div>'+
                            '</div>'+
                        '</div>');

                        app.services.rechercherCriteresEvenements(identifiant, function(criteres){
                            var area=$("#interets .item-content").empty();
                            if(criteres){

                                $.each(criteres, function(index,critere){
                                    if(critere.valeur==1){
                                        area.append('<i class="fa fa-smile-o"></i> '+critere.nom);
                                    }

                                });

                            }
                            else{
                                area.html("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucun sujet d'intérêt </span></div>");
                            } 
                        });
                    }
                    $("a.eventsbtn").attr("href", "evenements.html?identifiant="+identifiant+"&pseudo="+encodeURIComponent(user.pseudo));
                }
                else{
                    $("#profilcontactpage .ui-content").html("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucune information trouvée sur votre contact </span></div>")
                }
                
            });
        }
        catch(e){
            $("#profilcontactpage .ui-content").html("<div class='message-blocs'><i class='fa fa-eye-slash color-red'></i><span>Aucune information trouvée sur votre contact </span></div>")
        }
        
        
    }); 
        
    
    $( document ).on( "pageshow", "#faqpage", function(event) {
        event.preventDefault();
        event.stopPropagation();
                
        // charger les infos de la page
        try{
            app.services.rechercherQuestionsFAQ(function(questions){
                
                var liste= $("#faqpage .ui-content .item-content");
                
                if(questions.length!=0){
                    
                    var content="";
                    
                    for (var idquestion in questions){
                        content+= '<li><a href="questionfaq.html?idquestion='+questions[idquestion].id+'&libelle='+encodeURIComponent(questions[idquestion].libelle)+'&reponse='+encodeURIComponent(questions[idquestion].reponse)+'">'+questions[idquestion].libelle+'</a></li>';
                    }
                    
                    liste.html('<ul data-role="listview" data-filter="true" data-filter-text="Filtrer..." data-inset="true" id="listequestions">'+content+'<ul>');
                    
                    liste.find("ul").listview().listview("refresh");
                }
                else{
                    liste.html('<div>Aucune question trouvée dans la FAQ<div>');
                }
                
                
            });
        }
        catch(e){
            console.log(e);
        }
                
    });
    
    $( document ).on( "pageshow", "#questionfaq", function(event) {
        
        var libelle= decodeURIComponent(getUrlVars()["libelle"]);   
        var reponse= decodeURIComponent(getUrlVars()["reponse"]);   
        // charger les infos de la page
        try{
//            app.services.rechercherQuestion(idquestion, function(question){                
//                
//                if(question){
//                    //Met à jour la page qui doit contenir la question 
//                    $("#questionfaq div.ui-content h4.titre").html(question.libelle);
//                    $("#questionfaq div.ui-content div.contenu").html(question.reponse);
//                }
//                else{
//                    $("#questionfaq div.ui-content").html("<div><i class='fa fa-4x fa-archive'></i><div>");
//                }
//                
//            });
        
            $("#questionfaq div.ui-content h4.titre").html('<i class="fa fa-question-circle color-green">  </i> '+libelle);
            $("#questionfaq div.ui-content div.contenu").html(reponse);
}
        catch(e){
            console.log(e);
        }
        
        
    });

    $( document ).on( "submit", "#changepasswordfrom", function( e ) {
        e.preventDefault();
        e.stopPropagation();
        var oldpass=$("#oldpassword").val();
        var newpass1=$("#password1").val();
        var newpass2=$("#password2").val();
        
        var errorzone=$("#changepasswordfrom p.error");
        
        var valid=true;
        
        $("#changepasswordfrom input").each(function(){
            if($(this).val()==""){
                $(this).parent().parent().find("label").css("color", "red");
                valid=false;
            }
            else{
                $(this).parent().parent().find("label").css("color", "inherit");
            }                    
        });
        
        if(!valid){
            if(newpass1!==newpass2){
                errorzone.html("Mots de passe incompatibles");
                $("#password1,#password2").parent().parent().find("label").css("color", "red");
                valid=false;
            }
        }
        else{
            app.utils.showloader("Changement...");
            app.services.changerMotDePasse(app.user.get("identifiant"), oldpass, newpass1,function(res){
                switch(res){
                    case 0: errorzone.html("Utilisateur non reconnu");
                            break;
                    case 1: app.utils.showInfoMessage("Mot de passe changé");
                            $( ":mobile-pagecontainer" ).pagecontainer( "change", "accueil.html", { reload: false, reverse: false, showLoadMsg: true} );
                            break;
                    case 2: errorzone.html("Mot de passe incorrect");
                            break; 
                            
                    case 3: errorzone.html("Erreur innatendue");
                            break;
                }
                
                app.utils.hideloader();
            });
        }
    });
    
    $( document ).on( "swipeleft", "#userconnecte div.userswipe", function( e ) {
        $(this).remove();
        app.utils.showInfoMessage("Utilisateur supprimé");

    });
    
    
    
    // Navigate to the next page on swipeleft
    $( document ).on( "swipeleft", ".ui-page", function( event ) {
        var page=$("body").pagecontainer("getActivePage").attr("id");
        if(page!="profilpersopage" && page!="inscriptionpage"){
            if($.mobile.navigate.history.activeIndex<=$.mobile.navigate.history.stack.length)
            $.mobile.pageContainer.pagecontainer( "forward" );
        }
        
    });

    // The same for the navigating to the previous page
    $( document ).on( "swiperight", ".ui-page", function( event ) {
        var page=$("body").pagecontainer("getActivePage").attr("id");
        if(page!="profilpersopage" && page!="inscriptionpage"){
            if($.mobile.navigate.history.activeIndex>0)
                $.mobile.back();
        }
    });
    
    // Ecoute du click sur une icone favoris de la page d'accueil
    $( document ).on( "click", "#accueilpage .icons>a.favorislink", function( event ) {
        //recupère l'identifiant de l'utilisateur
        var iduser=$(this).attr("id").split("-")[1];
        var icon=$(this).find("i.colour-favoris");
        
        if(icon.length>0){ // il ya bien une icnoe favoris colorée (pour dire que le gars est bien favoris)
            app.utils.showloader("Suppression du favoris");
        
            //Appelle le service de suppression de favoris
            app.services.supprimerFavoris(app.user.get("identifiant"), iduser, function(res){
                app.utils.hideloader();
                if(res==1){
                    //icon.removeClass("colour-favoris").addClass("colour-nonfavoris");                    
                    //icon.parent().removeClass("favorislink"); 
                    icon.remove();                    
                    icon.parent().parent().enhanceWithin();
                    
                    app.utils.showInfoMessage("Favoris supprimé");
                    
                    // retire ce gars de la liste des favoris
                    var favoris=[];
                                
                    for(var id in app.parametres.favoris){
                        if(app.parametres.favoris[id].username!= iduser){
                            favoris.push({"username": app.parametres.favoris[id].username});  
                        }

                    }

                    app.parametres.favoris=favoris;
                }
                
            });
        }
        event.preventDefault();
        event.stopPropagation();
        
    });
    
    // Clic sur le bouton pour discuter avec un utlisateur
    $( document ).on( "click", ".icons> a.chatbtn", function( event ) {
        
        var iduser=$(this).attr("id").split("-")[1];
        
        if($(this).hasClass("chatbtn")){ // lien pour chater avec la personne
            $( ":mobile-pagecontainer" ).pagecontainer( "change", "dialogue.html", { reload: false, reverse: false, showLoadMsg: false, data: {id: iduser}} );
        }
        event.preventDefault();
        event.stopPropagation();
                
    });
    
    // Enregistrer la participation à un événement
    $( document ).on( "click", "#allevenementspage a.inscriptionevent", function( event ) {
        
        var id=$(this).attr("id").split('-')[1];
        var link=$(this);
        app.utils.showloader("Inscription");
        
        app.services.inscrireEvenement(app.user.get("identifiant"), id, function(res){
            app.utils.hideloader();
            if(res==1){
                link.find("span").html("Je ne participe plus");
                link.removeClass("inscriptionevent");
                
                link.addClass("desinscriptionevent");
                
                link.parent().parent().find("p:last").append(' <i class="fa fa-check"></i>');
                link.parents(".ui-collapsible.ui-collapsible-inset").find("span.ui-li-count").html((parseInt(link.parents(".ui-collapsible.ui-collapsible-inset").find("span.ui-li-count").html())+1));
                app.utils.showInfoMessage("Participation sauvegardée");
            }
            
        });
        
    });
    
    // Annuler la participation à un evenement
    $( document ).on( "click", "#allevenementspage a.desinscriptionevent", function( event ) {
        
        var id=$(this).attr("id").split('-')[1];
        var link=$(this);
        app.utils.showloader("Désinscription");
        
        app.services.DesinscrireEvenements(app.user.get("identifiant"), id, function(res){
            app.utils.hideloader();
            if(res==1){
                app.utils.showInfoMessage("Participation annulée");
                link.find("span").html("Je participe");
                link.removeClass("desinscriptionevent");
                link.addClass("inscriptionevent");
                link.parent().parent().find("p:last> i.fa-check").remove();
                
                link.parents(".ui-collapsible.ui-collapsible-inset").find("span.ui-li-count").html((parseInt(link.parents(".ui-collapsible.ui-collapsible-inset").find("span.ui-li-count").html())-1));
            }
            
        });
        
    });
    

    // Listenner, ecoute quand on clique sur le bouton pour vider le filtre sur la page des evenements
    $( document ).on( "click", "#allevenementspage .filtre a.ui-input-clear", function( event ) {
        // affiche tout dans la liste des evenements
        $( "div.ui-collapsible" ).show();
    });

    
    // listenner, kan on saisit dans l'input zone de filtre sur la page des criteres
    $( document ).on( "keyup", "#allevenementspage .filtre input", function( e) {
        var valeur=$(this).val();
        
        //Si le champ de filtre est vide, on affiche tous les éléments
        if(valeur.trim()===""){
            $( "div.ui-collapsible" ).show();
        }
        else{
            // si le button est delete et la chaine se termine par ; ou ; espace
            // recupère le code de la touche tapée
            var code = (e.keyCode ? e.keyCode : e.which);
            
            //remove trailing spaces
            valeur=valeur.trim();
            
            // si le code correspond à la touche delete et la chaine de caractère se termine par le ;
            if(code == 8 && valeur.indexOf(";", valeur.length-1)!==-1) { 
                
                var terms = app.utils.split( valeur ); // recupère chacun des mots clés
                terms.pop();    // supprime le dernier mot clé, vide
                
                //ajoute des , pour séparer les classes css des éléments à supprimer
                var css=terms.join(", .");
                
                // supprumer all les div .collapsible n'ayant pas l'une des classes de mot clé tapé
                $( "div.ui-collapsible" ).not( "."+css).hide();
            }

            
        }
        
    });
    
    // listenner, kan on saisit dans l'input zone de filtre sur la page des evenements
    $( document ).on( "keyup", "#evenementspage .filtre input", function( e) {
        var valeur=$(this).val();
        // si le button est delete et la chaine se termine par ; ou ; espace
          // recupère le code de la touche tapée
          var code = (e.keyCode ? e.keyCode : e.which);

          //remove trailing spaces
          valeur=valeur.trim();

          // si le code correspond à la touche delete et la chaine de caractère se termine par le ;
          if(code == 8 && valeur.indexOf(";", valeur.length-1)!==-1) { 

              var terms = app.utils.split( valeur ); // recupère chacun des mots clés
              terms.pop();    // supprime le dernier mot clé, vide

              //ajoute des , pour séparer les classes css des éléments à supprimer
              var css=terms.join(", .");

              // supprumer all les div .collapsible n'ayant pas l'une des classes de mot clé tapé
              $( "div.ui-collapsible" ).not( "."+css).hide();
          }

    });
    
    function subscribeSuccess(obj)
{   
    if (obj.status == "subscribedResult")
    {
        console.log("Subscription data received");

        //Parse array of int32 into uint8
        var bytes = bluetoothle.encodedStringToBytes(obj.value);

        //Check for data
        if (bytes.length === 0)
        {
            console.log("Subscription result had zero length data");
            return;
        }

        //Get the first byte that contains flags
        var flag = bytes[0];

        //Check if u8 or u16 and get heart rate
        var hr;
        if ((flag & 0x01) == 1)
        {
            var u16bytes = bytes.buffer.slice(1, 3);
            var u16 = new Uint16Array(u16bytes)[0];
            hr = u16;
        }
        else
        {
            var u8bytes = bytes.buffer.slice(1, 2);
            var u8 = new Uint8Array(u8bytes)[0];
            hr = u8;
        }
        console.log("Heart Rate: " + hr);
    }
    else if (obj.status == "subscribed")
    {
        console.log("Subscription started");
    }
    else
  {
    console.log("Unexpected subscribe status: " + obj.status);
    disconnectDevice();
  }
}

function subscribeError(msg)
{
  //console.log("Subscribe error: " + msg.error + " - " + msg.message);
  
}

//function ScaleContentToDevice() {
//    console.log("yes, inside");
//   scroll(0, 0);
//   var headerHeight = $("#jqmHeader:visible").outerHeight();
//   var footerHeight = $("#jqa mFooter:visible").outerHeight();
//   var viewportHeight = $(window).height();
//
//   var content = $("#jqmContent:visible");
//   var contentMargins =  content.outerHeight() - content.height();
//
//   var contentheight = viewportHeight - headerHeight - footerHeight - contentMargins;
//
//   content.height(contentheight);
//}
//
//
//$(document).on("pageshow", function(){
//   ScaleContentToDevice();
//});
//
//$(window).on('resize orientationchange', function(){ ScaleContentToDevice() });
